<%--
HistoryList.jsp - List out reports from central database
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
--%>

<%@ page contentType="text/html" %>

<jsp:useBean id = "Reg"
     class="ess.AdisoftDbase"
     scope="page" />
<jsp:useBean id = "PersFile"
     class="ess.PersonnelSession"
     scope="session" />
<jsp:useBean id = "Reporter"
     class="ess.PersonnelTable"
     scope="page" />
<jsp:useBean id = "CanApprove"
     class="ess.Approver"
     scope="page" />
<jsp:useBean id = "CK"
     class="ess.ChallengeKey"
     scope="application" />
<jsp:useBean id = "Log"
     class="ess.AuditTrail"
     scope="application" />
<jsp:useBean id = "Dt"
     class="ess.CustomDate"
     scope="session" />
<jsp:useBean id = "Lang"
     class="ess.Language"
     scope="session" />           
     
     
<%@ include file="../DBAccessInfo.jsp" %>
<%@ include file="../NumericSetup.jsp" %>
<% 

String CompanyName = "x1";  //hardcoded and can later put in AdisoftDbase call to system (f1 has special processing)
String CCode = "";
String database = request.getParameter("database");

String ownersName = request.getParameter("email");

Log.println("[000] ajax/HistoryList.jsp start:" + ownersName);

boolean pFlag = PersFile.setPersInfo(ownersName); 
if (pFlag) {
  if(PersFile.getChallengeCode().equals("")) {
    PersFile.setChallengeCode(request.getRemoteAddr(),CK.getChallengeKey());
  }
  CCode = request.getParameter("ccode"); 
  CanApprove.setApprover(PersFile);
}

if (pFlag && PersFile.getChallengeCode().equals(CCode)) { 
//if (pFlag) { 
%>
<%@ include file="../StatusInfo.jsp" %>
<%@ include file="../SystemInfo.jsp" %>
<%
   Reg.setConnection(PersFile.getConnection());
   Reg.setSQLTerminator(PersFile.getSQLTerminator()); 

   Reporter.setConnection(PersFile.getConnection());
   Reporter.setSQLTerminator(PersFile.getSQLTerminator()); 
   Reporter.setSQLStrings();  

   CanApprove.setConnection(PersFile.getConnection());
   CanApprove.setSQLTerminator(PersFile.getSQLTerminator()); 
   CanApprove.setUpFiles();

   String encrypt = SystemDOM.getDOMTableValueFor("encrypt","apply","No");
   String encryptKeyStr = SystemDOM.getDOMTableValueFor("encrypt","key","15");
   int encryptKey = Integer.parseInt(encryptKeyStr);

   String reportScript = SystemDOM.getDOMTableValueFor("history","ajaxscreenscript","ajax/HistoryReportV2.jsp");

   String downlevel = request.getParameter("level");
   
   int checkLevelsDown = 1;
   if (downlevel != null) checkLevelsDown = java.lang.Integer.parseInt(downlevel);
   
   String persnumber = PersFile.persnum;    //need to replace with a PersFile.get...()

   String reporttype = request.getParameter("reporttype");
   if (reporttype == null) reporttype = "ajaxreporter";
   String begDateStr = request.getParameter("begdate");
   String endDateStr = request.getParameter("enddate");

   String SQLType = null;
   String begDateSQL = null;
   String endDateSQL = null;
   String begDateXB = null;
   String endDateXB = null;
   
   SQLType = SystemDOM.getDOMTableValueFor("sql","dateformat");
  
   if ((begDateStr != null) && (endDateStr != null))
   {
	   
      begDateSQL = Dt.getSQLDate(Dt.getDateFromStr(begDateStr));  //need this format for 2 purposes
      endDateSQL = Dt.getSQLDate(Dt.getDateFromStr(endDateStr));

      if (SQLType.equals("MM/DD/YYYY")) { 
        begDateXB = begDateStr;
        endDateXB = endDateStr;
      } else if (SQLType.equalsIgnoreCase("DD-MMM-YYYY")){    // oracle
        begDateXB = Dt.getOracleDate(Dt.getDateFromStr(begDateStr));
        endDateXB = Dt.getOracleDate(Dt.getDateFromStr(endDateStr));
      } else {    // s/b YYYY-MM-DD
        begDateXB = begDateSQL;
        endDateXB = endDateSQL;
      }
   }
   String approvalType = SystemDOM.getDOMTableValueFor("history","approval");

   String SQLCommand = SystemDOM.getDOMTableValueFor("history",reporttype);
   SQLCommand = Reg.SQLReplace(SQLCommand,"$persnum$",persnumber);
   if (begDateStr != null) SQLCommand = Reg.SQLReplace(SQLCommand,"$begdate$",begDateXB);
   if (endDateStr != null) SQLCommand = Reg.SQLReplace(SQLCommand,"$enddate$",endDateXB);
   Log.println("[000] ajax/HistoryList.jsp SQL:" + SQLCommand);
   if (begDateStr != null) Log.println("[000] ajax/HistoryList.jsp begDate:" + begDateXB + " SQL: " + begDateSQL);
   if (endDateStr != null) Log.println("[000] ajax/HistoryList.jsp endDate:" + endDateXB + " SQL: " + endDateSQL);

   if (Reg.setResultSet(SQLCommand)) { 
%>
     <h1><%= Lang.getString("HIS_WELCOME")%></h1>
<%if (begDateStr != null)  
{%>
     <h2>Reports from <%= begDateStr %> to <%= endDateStr %> are shown</h2><br>
<%} else { %>     
     <h2><%= Lang.getString("HIS_MSG")%></h2>
<%}
     String persname;
     byte[] bArray;    //used for encrypted values
     String E;         //     ditto
     boolean xFlag;
     boolean xfound = false;
     String voucher = "";
     String pvoucher = "";
     String reference;
     String repdate;
     String repamt;
     String repStat;
     String repDBStat;
     String backcolor = "class=\"offsetColor\"";
     String oldbackcolor = "";
     String newbackcolor;
     int adjustment = 0; //see status.xml
%>
     <script>
     //<%= SQLCommand %>//
     </script>

     <table id="previousTable" border="0" cellspacing="0" cellpadding="0">
     <thead>
         <tr>
             <th width="5%" <%=backcolor%>>&nbsp;</th>
             <th width="10%" <%=backcolor%>><%= Lang.getColumnTitle("reportReferenceName") %></th>
             <th width="10%" <%=backcolor%>><%= Lang.getColumnTitle("reportUserReference") %></th>
             <th width="10%" <%=backcolor%>><%= Lang.getColumnTitle("date") %></th>
             <th width="20%" <%=backcolor%>><%= Lang.getColumnTitle("name") %></th>
             <th width="10%" <%=backcolor%>><%= Lang.getColumnTitle("amount") %></th>
             <th width="25%" <%=backcolor%>><%= Lang.getColumnTitle("paymentStatus") %></th>
             <th width="10%" <%=backcolor%>></th>
         </tr>
     </thead>
<%
    newbackcolor = backcolor;
    backcolor = oldbackcolor; 
    oldbackcolor = newbackcolor;
 
    try {
     do { 
//SQL order RP_STAT, PERS_NUM, VOUCHER, PVOUCHER, SUB_DATE, NAME,RE_AMT
        repStat = PersFile.getTrim(Reg.myResult.getString(1)); 
        reference = PersFile.getTrim(Reg.myResult.getString(2)); //used for subordinate lookup
        voucher = PersFile.getTrim(Reg.myResult.getString(3));
        pvoucher = PersFile.getTrim(Reg.myResult.getString(4));
        repdate = PersFile.getTrim(Reg.myResult.getString(5));  
        if (encrypt.equalsIgnoreCase("YES")) {
          bArray = Reg.myResult.getBytes(6);
          E = new String(bArray);
          persname = unScramble(E,encrypt,encryptKey);   
        } else {
          persname = PersFile.getTrim(Reg.myResult.getString(6));
        }
        repamt = PersFile.getTrim(Reg.myResult.getString(7)); 

        //Log.println("[000] HistoryList.jsp voucher: " + voucher + ", " + repdate);

        repDBStat = StatXlation(repStat, CompanyName, StatusDOM);

        // This is necessary due to Oracle
        if (repdate != null && !repdate.equals("")) {
           if (SQLType.equalsIgnoreCase("MM/DD/YYYY")) { 
           } else if (SQLType.equalsIgnoreCase("DD-MMM-YYYY")){    // oracle
             repdate = Dt.getSQLDate(Dt.getOracleSQLDate(repdate));
           } else {    // s/b YYYY-MM-DD
           }
        } else {
           Log.println("[400] ajax/HistoryList.jsp repdate is null or blank - " + voucher);
        }
        if ((begDateStr == null) || (repdate != null && repdate.compareTo(begDateSQL) > -1  && repdate.compareTo(endDateSQL) < 1)) { 
          xFlag = true;   
          if (reporttype.equals("subordinates")) {
            if (xFlag = Reporter.setPersNumInfo(reference)) {; 
               xFlag = CanApprove.canApprove(Reporter, approvalType, checkLevelsDown + adjustment);
            }
          } 
          if (xFlag) { 
     %>          
            <tr>
            <td width="5%" <%=backcolor%>>&nbsp;</td>
            <td width="10%" <%=backcolor%>><%= voucher%></td>
            <td width="10%" <%=backcolor%>><%= pvoucher%></td>
            <td width="10%" <%=backcolor%>><%= Dt.getUserDateStr(Dt.getSimpleDate(Dt.getDateFromXBase(repdate)),PersFile.getDateFormat())%></td>
            <td width="20%" <%=backcolor%>><%= persname%></td>
            <td width="10%" <%=backcolor%>><%= money.format(money.parse(repamt))%></td>
            <td width="25%" <%=backcolor%>><%= Lang.getDataString(repDBStat) %></td>
            <td width="10%" <%=backcolor%>><a href="javascript: void parent.writeDelayMsg('<%= PersFile.getAppServer() %>/<%= PersFile.getAppFolder() %>/<%= reportScript %>?email=<%= PersFile.repStr(ownersName,"'","\\'") %>&rcpt2=<%= Reporter.getPrintableEmailAddress()%>&reference=<%= reference%>&voucher=<%= voucher%>&ccode=<%= CCode%>&status=<%= repStat%>&database=<%= database%>')"><span class="ExpenseReturnLink"><%= Lang.getString("select")%></span></a></td>
            </tr>
     <%     xfound = true;
            newbackcolor = backcolor;
            backcolor = oldbackcolor; 
            oldbackcolor = newbackcolor;
          }
        }
     } while (Reg.myResult.next());
  } catch (java.lang.Exception ex) {
    Log.println("[500] ajax/HistoryList.jsp java.lang exception possibly voucher: " + voucher);
    Log.println("[500] ajax/HistoryList.jsp exception toString : " + ex.toString()); 
    ex.printStackTrace();
%>
    <h2>Error in the SQL logic - contact support.<h2>
<%  
  } //try
  Reg.close();
%>
  </table>

<% if (!xfound) { %>
<h2>
<%= Lang.getString("REPORTS_NOT_FOUND") %><br>
</h2>
<% } %>
          



<% } else { %>
    <div class="ExpenseTag">
    <%=PersFile.name%>, <%= Lang.getString("REPORTS_NOT_FOUND") %>
    <% Log.println("[400] ajax/HistoryList.jsp No expense reports where found."); %>
    </div>
<% } //if (Reg.setResultSet(SQLCommand)) 
%>
<span language="Javascript" id="script" file="shared/blank.js" ></span>

<%
} else { %>
  <%@ include file="ReloginRedirectMsg.jsp" %>
<%
} //if (pFlag && PersFile.getChallengeCode().equals(CCode)) 
%>
<%
Reg.close();      //cleaning up open connections 
Reporter.close();
%>
<%@ include file="../UnScramble.jsp" %>
<%@ include file="../StatXlation.jsp" %>


