/* Microsoft SQL Server database load */ 

BEGIN transaction;

CREATE TABLE ADDRESS ( ADDRESS varchar(60) not null,
                       PERS_NUM varchar(12) not null,
                       SCAN_MODE varchar(8),
                       CLERK varchar(12),
                       CONSTRAINT PK_ADDRESS PRIMARY KEY (ADDRESS) );

CREATE INDEX INDX_ADDRESS1 ON ADDRESS (PERS_NUM, ADDRESS);


CREATE TABLE ACCOUNT ( EXPENSE varchar(20),
                       DESCRIP varchar(40),
                       GEN_ACCT varchar(16),
                       DEPART varchar(30),
                       CATEGORY varchar(16),
                       BILLTYPE char(1),
                       XLIMIT numeric(12,2),
                       XSHOW bit,
                       SHOWLIST char(1),
                       OMITDEPT bit,
                       CHARGE varchar(10),
                       OMITEMP bit,
                       SHOW1 bit,
                       SHOW2 bit,
                       SHOW3 bit,
                       SHOW4 bit,
                       XEXPLAIN bit,
                       ATTENDEE bit,
                       MERCHANT bit,
                       REIMB bit,
                       SPECIAL varchar(20),
                       COMPANY varchar(8),
                       CONSTRAINT PK_ACCOUNT PRIMARY KEY (EXPENSE, DEPART, COMPANY) );

INSERT INTO ACCOUNT VALUES ( 'AIR-PREPD','AIRFARE-CO. PAID','99999','','AIRFARE CO','',0.00,'1','1','1','AIR-PREPD',0,1,1,1,1,0,0,0,0,'','001');
INSERT INTO ACCOUNT VALUES ( 'AIR-CASH','AIRFARE PERSONALLY PAID','50510','','AIRFARE EMP','',0.00,'1','2','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'MILEAGE','PERSONAL CAR-MILEAGE','50510','','MILEAGE','',0.00,'','1','','',0,0,0,0,0,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'TOLLS','GROUND TRANSPORTATION-TOLLS','50510','','TOLLS','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'PARKING','GROUND TRANSPORATION-PARKING','50510','','PARKING','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'LIMO TAXI','GROUND TRANSPORTATION-LIMO/TAX','50510','','LIMO TAXI','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'CAR RENTAL','GROUND TRANSPORTATION-CAR RENT','50510','','CAR RENTAL','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'RENTAL GAS','GROUND TRANS.-RENTAL CAR GAS','50510','','RENTAL GAS','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'LUNCH','MEALS-LUNCH','50540','','MEALS','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'ENTERTAIN','ENTERTAINMENT','50540','','ENTERTAIN','',0.00,'1','1','','',0,1,1,1,1,1,1,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'SUPPLIES','SUPPLIES','50590','','SUPPLIES','',0.00,'1','1','','',0,1,1,1,1,0,0,1,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'DUES SUBS','DUES & SUBSCRIPTIONS','50580','','DUES SUBS','',0.00,'1','1','','',0,1,1,1,1,0,0,0,'1','','001');
INSERT INTO ACCOUNT VALUES ( 'PHONE GEN','PHONE-GENERAL','60520','','PHONE GEN','',0.00,'1','1','',0,0,1,1,1,1,0,0,0,'1','HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'PHONE CELL','PHONE-CELLULAR','60520','','PHONE CELL','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'TRAINING','TRAINING','50260','','TRAINING','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'LODGING','LODGING','50520','','LODGING','',0.00,'1','1','','',0,0,0,0,1,0,0,0,1,'','001');
INSERT INTO ACCOUNT VALUES ( 'PERSONAL','PERSONAL USAGE ACOUNT','99999','','PERSONAL','',0.00,'','5','1','',0,0,0,0,0,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'GST','GST,CANADA TAX','20375','','GST','',0.00,'1','2','1','',1,1,1,1,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'BREAKFAST','BREAKFAST','50540','','MEALS','',0.00,'1','1','','',0,1,1,1,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'DINNER','DINNER','50540','','MEALS','',20.00,'1','1','','',0,1,1,0,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'MISC','MISC','50550','','MISC','',0.00,'','4','','',0,1,1,1,1,0,0,0,1,'HOTEL','001');
INSERT INTO ACCOUNT VALUES ( 'ALLOWANCE','ALLOWANCE','50550','','ALLOWANCE','',25.00,'','4','','',0,0,0,0,1,0,0,0,1,'','001');



CREATE TABLE CARD ( PERS_NUM varchar(12),
                    CHARGE varchar(20),
                    CARD varchar(30),
                    NAME varchar(40),
                    EXPIRES date,
                    CLOSED date,
                    ACTIVE bit,
                    COMMENT varchar(80),
                    CONSTRAINT PK_CARD PRIMARY KEY (PERS_NUM, CHARGE, CARD) );

CREATE TABLE CHARGE ( CHARGE varchar(20),
                      DESCRIP varchar(30),
                      GEN_ACCT varchar(16) CONSTRAINT NN_GEN_ACCT NOT NULL,
                      DEPART varchar(16),
                      REIMB bit,
                      XSHOW bit,
                      SHOWLIST char(1),
                      OMITDEPT bit,
					  COMPANY varchar(8),
					  CONSTRAINT PK_CHARGE PRIMARY KEY (CHARGE, COMPANY));

INSERT INTO CHARGE VALUES ( 'CASH','CASH-EMPLOYEE','20040','',1,1,'1',0,'001');
INSERT INTO CHARGE VALUES ( 'ADVANCE','Advance Account','11800','',0,0,'1',0,'001');
INSERT INTO CHARGE VALUES ( 'CASH-RETD','Cash Returned w/Rep.','20041','',0,0,'2',0,'001');
INSERT INTO CHARGE VALUES ( 'AIR-PREPD','PREPAID AIRFARE','99999','',0,1,'3',1,'001');
INSERT INTO CHARGE VALUES ( 'PREPAID','PREPAID','99999','',0,1,'1',1,'001');
INSERT INTO CHARGE VALUES ( 'VISA','VISA CARD','99999','',0,1,'3',1,'001');



CREATE TABLE CLIENT ( CLIENT varchar(40),
                      LOCATION varchar(36),
                      PHONE varchar(24),
                      CONTACT varchar(40),
                      REMARKS varchar(160),
                      BILLEXP bit,
                      CLIENTNO varchar(16),
					  COMPANY varchar(8),
                      CONSTRAINT PK_XCLIENT PRIMARY KEY (CLIENT, COMPANY) );

INSERT INTO CLIENT VALUES ( '123 INC','SAN MATEO','555-5555','John Doe','',0,'121','001');



CREATE TABLE COMPANY ( COMPANY varchar(8),
                       DESCRIP varchar(30),
                       PAYROLL varchar(3),
                       CURRENCY varchar(20),
                       UNITS varchar(20),
                       PARENT varchar(100),
                       LOGOFILE varchar(100),
                       HEIGHT varchar(3),
                       WIDTH varchar(3),
                       CLIENT varchar(8),
                       EXPENSE varchar(8),
                       PAYMENT varchar(8),
                       MERCHANT varchar(8),
                       LOCATION varchar(8),
                       GUIDE varchar(12),
                       MILEAGE varchar(8),
                       PROJECT varchar(8),
                       XOFFSETS varchar(20),
                       STEPS varchar(20),
                       AUDITOR varchar(12),
                       LANGUAGE varchar(10),
                       MAPPING varchar(100),
                       ACTIVE bit,
                       GL_COMPANY varchar(8),
                       PURPOSESCREEN varchar(30),
                       CONSTRAINT PK_COMPANY PRIMARY KEY (COMPANY) );


INSERT INTO COMPANY VALUES ( '001','General Company','','US Dollar','Miles','ess-app/Report.jsp','ESS.gif','50','100','001','001','001','001','001','STD','001','001','generaloffset','steps','','English','',1,'001','head2b.html');




CREATE TABLE DEPART ( DEPART varchar(30),
                      DESCRIP varchar(30),
                      GL_TERM varchar(16),
                      COMPANY varchar(8),
                      LOC_CODE varchar(8),
                      SUPER varchar(16),
                      MANAGER varchar(12),
                      CLERK varchar(12),
                      GUIDE varchar(12), 
					  ACTIVE bit,
					  CONSTRAINT PK_DEPART PRIMARY KEY (DEPART, COMPANY));

/* Why this index?? */
CREATE INDEX INDX_DEPART ON DEPART (DEPART);

INSERT INTO DEPART VALUES ( 'SALES','Sales Department','1001','001','','','','','default',1);
INSERT INTO DEPART VALUES ( 'SYSTEMS','Systems and Support','1002','001','','','','','default',1);
INSERT INTO DEPART VALUES ( 'OPERATIONS','Operations and Accounting','1003','001','','','','','default',1);



CREATE TABLE EXPENSE ( EXPENSE varchar(20),
                       AMOUNT numeric(12,2),
                       VOUCHER varchar(8),
                       RECEIPT varchar(8),
                       PURPOSE varchar(8),
                       LINEITEM varchar(8),
                       DEPART varchar(30),
                       ACCOUNT varchar(22),
                       UP_DATE date,
                       UP_STAT varchar(2),
                       BILLTYPE varchar(2),
                       BL_DATE date,
                       BL_STAT varchar(2),
                       COMMENT varchar(60),
                       APPROVAL varchar(16),
                       CRE_DATE date,
                       EXP_DATE date,
                       REC_AMT numeric(12,2),
                       XRATE numeric(12,4),
                       UNITS varchar(20),
                       XSOURCE varchar(20),
                       XDATE date,
                       COMPANY varchar(8),
                       PERSPLIT numeric(2,0),
                       REIMB bit, 
                       CONSTRAINT PK_EXPENSE PRIMARY KEY (VOUCHER, RECEIPT, LINEITEM, PURPOSE) );

CREATE INDEX INDX_EXPENSE ON EXPENSE (VOUCHER, LINEITEM);


CREATE TABLE EXTENDED ( VOUCHER varchar(8),
                        PURPOSE varchar(8),
                        LINEITEM varchar(8),
                        NAME varchar(36),
                        REMARKS varchar(20),
                        CLIENT varchar(40),
                        LOCATION varchar(40),
                        COMMENT varchar(80),
                        EXTRAITEM varchar(8));

CREATE INDEX INDX_EXTENDED1 ON EXTENDED (VOUCHER, LINEITEM, EXTRAITEM);
CREATE INDEX INDX_EXTENDED2 ON EXTENDED (VOUCHER, PURPOSE, LINEITEM, EXTRAITEM);



CREATE TABLE GUIDE ( GUIDE varchar(12),
                     CATEGORY varchar(16),
                     LOCATION varchar(30),
                     AMOUNT numeric(12,2),
                     METHOD varchar(12),
                     COMMENT varchar(60),
                     CONSTRAINT PK_GUIDE PRIMARY KEY (GUIDE, CATEGORY, METHOD) );
/* This needs to be changed to account for the location, company eventually */
INSERT INTO GUIDE VALUES ( 'STD','AIRFARE CO','',1000.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','MILEAGE','',150.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','LIMO TAXI','',100.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','CAR RENTAL','',250.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','RENTAL GAS','',50.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','SUPPLIES','',100.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','DUES SUBS','',20.00,'REPORT','');
INSERT INTO GUIDE VALUES ( 'STD','PHONE GEN','',50.00,'REPORT','');
INSERT INTO GUIDE VALUES ( 'STD','TRAINING','',100.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','LODGING','',200.00,'NIGHTS','');
INSERT INTO GUIDE VALUES ( 'STD','DATE','',60.00,'DATE','');
INSERT INTO GUIDE VALUES ( 'STD','AIRFARE EMP','',150.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','PHONE CELL','',75.00,'REPORT','');
INSERT INTO GUIDE VALUES ( 'SPEC','TOTAL','',1.00,'TOTAL','');
INSERT INTO GUIDE VALUES ( 'STD','MEALS','',45.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','ENT CLIENT','',50.00,'DAILY','');
INSERT INTO GUIDE VALUES ( 'STD','TOTAL','',200.00,'TOTAL','');



CREATE TABLE LOCATION ( LOCATION varchar(30),
                        COMMENT varchar(60), 
                        COMPANY varchar(8),
						CONSTRAINT PK_LOCATION PRIMARY KEY (LOCATION, COMPANY));

INSERT INTO LOCATION VALUES ( 'New York','','001');
INSERT INTO LOCATION VALUES ( 'San Francisco','','001');
INSERT INTO LOCATION VALUES ( 'Chicago','','001');
INSERT INTO LOCATION VALUES ( 'Los Angeles','','001');
INSERT INTO LOCATION VALUES ( 'Atlanta','','001');
INSERT INTO LOCATION VALUES ( 'Boston','','001');
INSERT INTO LOCATION VALUES ( 'Miami','','001');
INSERT INTO LOCATION VALUES ( 'Milwaukee','','001');
INSERT INTO LOCATION VALUES ( 'Toronto','','001');
INSERT INTO LOCATION VALUES ( 'Montreal','','001');
INSERT INTO LOCATION VALUES ( 'Vancouver','','001');
INSERT INTO LOCATION VALUES ( 'Seattle','','001');
INSERT INTO LOCATION VALUES ( 'Minneapolis','','001');
INSERT INTO LOCATION VALUES ( 'Portland','','001');



CREATE TABLE MERCHANT ( EXPENSE varchar(20),
                        MERCHANT varchar(30), 
					    COMPANY varchar(8),
                        CONSTRAINT PK_MERCHANT PRIMARY KEY (MERCHANT,EXPENSE, COMPANY) );
/* The other two databases have this constraint as EXPENSE, MERCHANT */
INSERT INTO MERCHANT VALUES ( 'LODGING','Sheraton','001');
INSERT INTO MERCHANT VALUES ( '','Ramada Inn','001');



CREATE TABLE PROJECT ( PROJECT varchar(24),
                       STEPNO varchar(12),
                       TITLE varchar(40),
                       REMARKS varchar(160), 
                       ACCOUNT varchar(22),
                       CLIENTNO varchar(16),
					   COMPANY varchar(8),
                       CONSTRAINT PK_PROJECT PRIMARY KEY (PROJECT, STEPNO, CLIENTNO, COMPANY) );
/* This needs to be changed to account for the STEPNO and CLIENTNO eventually */
INSERT INTO PROJECT VALUES ( '001-001','','Project One','This is a test project','','','001');
INSERT INTO PROJECT VALUES ( '002-002','','Project Two','This is a test project','','','001');



CREATE TABLE PURPOSE ( PURPOSE varchar(8),
                       VOUCHER varchar(8),
                       CLIENT varchar(40),
                       LOCATION varchar(40),
                       COMMENT varchar(250),
                       PROJECT varchar(24),
                       BEG_DATE date,
                       END_DATE date,
                       DAYS numeric(3,0),
                       NIGHTS numeric(3,0),
                       CLIENTNO varchar(16),
                       FORCED bit,
                       STEPNO varchar(12),
                       EXTENDED bit,
                       TIMESLIP bit,
                       CONSTRAINT PK_PURPOSE PRIMARY KEY (VOUCHER, PURPOSE) );



CREATE TABLE RECEIPT ( RCPTTYPE varchar(2),
                       CHARGE varchar(20),
                       VOUCHER varchar(8),
                       RECEIPT varchar(8),
                       REFER varchar(23),
                       REC_DATE date,
                       REC_AMT numeric(12,2),
                       XRATE numeric(12,4),
                       UNITS varchar(20),
                       XSOURCE varchar(20),
                       XDATE date,
                       AMOUNT numeric(12,2),
                       ACCOUNT varchar(22),
                       OFFSET varchar(22),
                       REIMB bit,
                       FORCED bit,
                       OK_DATE date,
                       OK_STAT varchar(2),
                       OK_REF varchar(8),
                       CRE_DATE date,
                       XCHECK bit,
                       UP_DATE date,
                       UP_STAT varchar(2),
                       MERCHANT varchar(30),
                       SUBTYPE varchar(2),
                       BEG_DATE date,
                       LOCATION varchar(30),
                       CONSTRAINT PK_RECEIPT PRIMARY KEY (VOUCHER, RECEIPT) );



CREATE TABLE REGISTER ( OWNER varchar(60),
                        XMLFILE varchar(60),
                        STATUS varchar(20),
                        MESSAGE varchar(60),
                        REVIEWER varchar(60),
                        XREF varchar(20),
                        REPDATE varchar(40),
                        REFERENCE varchar(16) CONSTRAINT PK_REFERENCE PRIMARY KEY,
                        REPORTER varchar(60),
                        THEIR_REF varchar(20),
                        AMOUNT varchar(16) );

CREATE INDEX INDX_REGISTER1 ON REGISTER (OWNER);
CREATE INDEX INDX_REGISTER2 ON REGISTER (XREF);
CREATE INDEX INDX_REGISTER3 ON REGISTER (STATUS);


CREATE TABLE REPORT ( RP_STAT varchar(2),
                      PERS_NUM varchar(12),
                      CRE_DATE date,
                      CRE_TIME varchar(8),
                      VOUCHER varchar(8) CONSTRAINT PK_VOUCHER PRIMARY KEY,
                      PVOUCHER varchar(8),
                      SUB_DATE date,
                      SUB_TIME varchar(8),
                      CUR_DATE date,
                      CUR_TIME varchar(8),
                      ACT_DATE date,
                      ACT_TIME varchar(8),
                      PAYMENT bit,
                      NAME varchar(36),
                      LOCATION varchar(30),
                      PHONE varchar(24),
                      DEPART varchar(30),
                      COMPANY varchar(8),
                      RE_AMT numeric(12,2),
                      AD_AMT numeric(12,2),
                      RC_AMT numeric(12,2),
                      SIGN1 varchar(12),
                      SIGN2 varchar(12),
                      SIGN3 varchar(12),
                      XCHECK bit,
                      XCHARGE bit,
                      AUD_DATE date,
                      FORCED bit,
                      UP_DATE date,
                      UP_STAT varchar(2),
                      VEHICLE varchar(20),
                      MONTH varchar(5),
                      SERVDATE date,
                      START numeric(7,0),
                      FINISH numeric(7,0),
                      BUSINESS numeric(6,0),
                      CLERK varchar(12),
                      SG1_DATE date,
                      SG2_DATE date,
                      EXTRA1 varchar(20),
                      EXTRA2 varchar(12),
                      UNITS varchar(12),
                      MANAGER varchar(12),
                      COMMENT varchar(80),
                      EXTRA3 varchar(8),
                      OLD_STAT varchar(2),
                      PHY_REC varchar(4),
                      RECEIVED date,
                      EXTRA4 varchar(12),
                      SIGN4 varchar(12),
                      RC_DATE date,
                      ADMIN1 varchar(12),
                      AD1_DATE date,
                      ADMIN2 varchar(12),
                      AD2_DATE date,
                      WEEKEND date,
                      CURRENCY varchar(20), 
                      HISTORY varchar(8) );

CREATE INDEX INDX_REPORT1 ON REPORT (PERS_NUM, RP_STAT);
CREATE INDEX INDX_REPORT2 ON REPORT (RP_STAT, CRE_DATE);

CREATE TABLE SCAN ( SCAN_REF varchar(8),
                    PERS_NUM varchar(12),
                    PVOUCHER varchar(8),
                    RECEIPT varchar(8),
                    FILE_TYPE varchar(6),
                    UP_DATE date,
                    UP_TIME varchar(8),
                    CLERK varchar(12),
                    STATUS varchar(8),
                    XREF varchar(8),
                    COMMENT varchar(60),
					ADDRESS varchar(60),
                    FILE_SIZE bigint,
                    FILE_CONTENT varbinary(max),
                    CONSTRAINT PK_SCAN PRIMARY KEY (SCAN_REF) );

CREATE INDEX INDX_SCAN1 ON SCAN (PERS_NUM, PVOUCHER, SCAN_REF);


CREATE TABLE SPECIAL ( ITEM varchar(30),
                       TYPE varchar(20),
                       CONSTRAINT PK_SPECIAL PRIMARY KEY (ITEM, TYPE) );

INSERT INTO SPECIAL VALUES ( 'X123456','WBS-feed-omission');
INSERT INTO SPECIAL VALUES ( 'TT&TTest','WBS-feed-omission');



CREATE TABLE STATE ( STATUS varchar(24),
                     ACTION varchar(20),
                     POSITIVE varchar(24),
                     NEGATIVE varchar(24),
                     CONSTRAINT PK_STATE PRIMARY KEY (STATUS, ACTION) );

INSERT INTO STATE VALUES ( 'ST_NEW','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_NEW','GUIDELINE','ST_APPROVED','ST_SUBMIT_ON');
INSERT INTO STATE VALUES ( 'ST_REJECTED','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_SUBMIT_ON','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_SUBMIT_OFF','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_REVIEWED','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_APPROVED','REPLACEOLD','','');
INSERT INTO STATE VALUES ( 'ST_APPROVED','RANDOMSELECT','ST_AUDITED','ST_REVIEWED');



CREATE TABLE STATEMNT ( CHARGE varchar(10),
                        CARD varchar(30),
                        EMPLOYEE varchar(25),
                        SIC varchar(6),
                        REFERENCE varchar(23),
                        AMOUNT numeric(12,2),
                        TDATE date, 
                        SDATE date,
                        INFO varchar(30),
                        STATUS varchar(2),
                        RDATE date,
                        XREF varchar(8),
                        PDATE date,
                        REC_AMT numeric(12,2),
                        XRATE numeric(12,4),
                        UNITS varchar(20),
                        CONSTRAINT PK_STATEMNT PRIMARY KEY (CHARGE, CARD, REFERENCE) );

CREATE INDEX INDX_STATEMNT1 ON STATEMNT (STATUS, CHARGE, CARD);
CREATE INDEX INDX_STATEMNT2 ON STATEMNT (CHARGE, REFERENCE);

/* Want to eventually add some test credit card transactions here. */

CREATE TABLE SYSTEM ( COMPANY varchar(16),
                      TAG varchar(20),
                      ELEMENT varchar(240),
                      CONSTRAINT PK_TABLE PRIMARY KEY (COMPANY, TAG) );

INSERT INTO SYSTEM VALUES ( 'ESS','MESSAGE_SEQUENCE','100');
INSERT INTO SYSTEM VALUES ( 'ESS','XMLSYSTEM','/var/ess/xmls/system.xml');
INSERT INTO SYSTEM VALUES ( 'ESS','VOUCHER','100');
INSERT INTO SYSTEM VALUES ( 'ESS','COMPANY_SEQUENCE','100');
INSERT INTO SYSTEM VALUES ( 'ESS','PERSNUM_SEQUENCE','100');
INSERT INTO SYSTEM VALUES ( 'ESS','SCAN_SEQUENCE','100');
INSERT INTO SYSTEM VALUES ( 'ESS','INCOMING_SEQUENCE','100');


CREATE TABLE EXPUSER ( PERS_NUM varchar(12) CONSTRAINT PK_PERS_NUM PRIMARY KEY,
                      LNAME varchar(20),
                      FNAME varchar(18),
                      LOCATION varchar(30),
                      PHONE varchar(24),
                      EMAIL varchar(60),
                      DEPART varchar(30),
					  COMPANY varchar(8),
                      EMPCODE varchar(12),
                      BILLEXP bit,
                      LEVEL char(1),
                      XLIMIT numeric(12,2),
                      VEHICLE varchar(20),
                      SERVDATE date,
                      GUIDE varchar(12),
                      MANAGER varchar(12),
                      EXTRA1 varchar(20),
                      EXTRA2 varchar(20),
                      MILEAGE numeric(8,4),
                      BANKCODE varchar(20),
                      BANKACCT varchar(20),
                      SAVINGS bit,
                      PRENOTE bit,
                      PRE_DATE date,
                      MILES_TYPE varchar(10),
                      SHOWGRP char(1),
                      ACTIVE bit,
                      PASSWORD varchar(16),
                      CASH varchar(10),
                      EXTRA3 varchar(20),
                      PSWD_DATE date,
                      CURRENCY varchar(20),
                      XFUNCTION varchar(10),
                      LANGUAGE varchar(10),
					  COUNTRY varchar(10),
                      DATEFORMAT varchar(10),
                      NUMBERFORMAT varchar(10),
                      APPLICATION varchar(30));

CREATE INDEX INDX_USER1 ON EXPUSER (EMAIL);
CREATE INDEX INDX_USER2 ON EXPUSER (LNAME);

INSERT INTO EXPUSER VALUES ( '99999','Controller','Joe','Head Office','(510) 483-3556','admin@expenseservices.com','OPERATIONS','001','',0,'8',10000.00,'123456789','2004-06-21','STD','99990','','0.0000',0.0000,'122000098','101010101',0,0,'1998-03-18','','1','1','PASSWORD','ACH','','2005-10-07','','Auditor','','','','','');
INSERT INTO EXPUSER VALUES ( '00001','Manager','Mary','Head Office','(510) 483-3556','approver@expenseservices.com','OPERATIONS','001','',0,'4',10000.00,'','1901-01-01','STD','99999','','0.0000',0.0000,'','',0,0,'1901-01-01','','1','1','PASSWORD','A/P','','2005-10-07','','','','','','','');
INSERT INTO EXPUSER VALUES ( '00002','Auditor','Tom','Head Office','(555) 555-5555','auditor@expenseservices.com','OPERATIONS','001','',0,'2',10000.00,'','1901-01-01','STD','99999','','0.0000',0.0000,'','',0,0,'1901-01-01','','1','1','PASSWORD','A/P','','2005-10-07','','Auditor','','','','','');
INSERT INTO EXPUSER VALUES ( '00003','Reporter','Joe','Head Office','(555) 555-5555','reporter@expenseservices.com','OPERATIONS','001','',0,'4',0.00,'111122222','1901-01-01','STD','00001','','0.0000',0.0000,'','',0,0,'1901-01-01','','1','1','PASSWORD','A/P','','2005-10-07','','','','','','','');
INSERT INTO EXPUSER VALUES ( '99990','Backup','Joe','Head Office','(510) 483-3556','backup@expenseservices.com','OPERATIONS','001','',0,'8',10000.00,'123456789','2004-06-21','STD','00000','','0.0000',0.0000,'122000098','101010101',0,0,'1998-03-18','','1','1','PASSWORD','ACH','','2005-10-07','','','','','','','');

CREATE TABLE CURRENCY ( CURRENCY varchar(20) CONSTRAINT PK_CURRENCY PRIMARY KEY,
                        XLIMIT numeric(12,2),
                        COMMENT varchar(60),
                        SHOW bit,
                        SHOWLIST varchar(1));

INSERT INTO CURRENCY VALUES ( 'US Dollar',10000,'',1,'1');
INSERT INTO CURRENCY VALUES ( 'Canada Dollar',10000,'',1,'2');
INSERT INTO CURRENCY VALUES ( 'Mexico Peso',10000,'',1,'3');
INSERT INTO CURRENCY VALUES ( 'ECC Euro',10000,'',1,'4');
INSERT INTO CURRENCY VALUES ( 'Argentina Peso',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Australia Dollar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Bahrain Dinar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Brazil Real',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Chile Peso',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'China Renminbi',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Colombia Peso',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Czech Koruna',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Denmark Krone',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Egypt Pound',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Hong Kong Dollar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Hungary Forint',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'India Rupee',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Indonesia Rupiah',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Isreal Shekel',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Japan Yen',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Jordan Dinar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Kuwait Dinar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Lebanon Pound',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Malaysia Ringgit',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Malta Lira',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'New Zealand Dollar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Norway Krone',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Pakistan Rupee',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Peru new Sol',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Phillippines Peso',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Poland Zloty',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Russia Ruble',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Saudia Arabia Riyals',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Singapore Dollar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Slovak Koruna',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'South Africa Rand',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'South Korea Won',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Sweden Krona',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Switzerland Franc',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Taiwan Dollar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Thailand Baht',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Turkey Lira',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'UK Pound',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'United Arab Dirham',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Uraguay Peso',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Venezuela Bolivar',10000,'',1,'5');
INSERT INTO CURRENCY VALUES ( 'Specify in Source',10000,'',1,'9');

CREATE TABLE FX ( CURRENCY varchar(20),
                        XDATE date,
                        HOME varchar(20),
                        XRATE numeric(14,4),
                        RATETYPE bit,
                        XSOURCE char(36),
                        CONSTRAINT PK_RATE PRIMARY KEY (CURRENCY, XDATE, HOME) );

CREATE TABLE MILEAGE ( COMPANY varchar(8),
                        EFFECTIVE date,
                        UNITS varchar(10),
                        CURRENCY varchar(20),
                        RATE numeric(12,4),
                        CONSTRAINT PK_MILEAGE PRIMARY KEY (COMPANY, EFFECTIVE) );

INSERT INTO MILEAGE VALUES ( '001','2001-01-01','Miles','US Dollars',0.4250);


CREATE TABLE TRANSLOG ( PVOUCHER varchar(8),
                        TRANS_DATE date,
                        TRANS_TIME varchar(8),
                        STATUS varchar(16),
                        PERS_NUM varchar(12),
                        VOUCHER varchar(8),
                        REFERENCE varchar(12),
                        CONSTRAINT PK_TRANSLOG PRIMARY KEY (PVOUCHER,TRANS_DATE,TRANS_TIME,STATUS) );

CREATE INDEX INDX_TRANSLOG1 ON TRANSLOG (PVOUCHER,TRANS_DATE,TRANS_TIME,STATUS);
CREATE INDEX INDX_TRANSLOG2 ON TRANSLOG (PERS_NUM,TRANS_DATE,TRANS_TIME,VOUCHER);

commit transaction;

