package ess;

import java.sql.*;

public class ApplyScan {
	
	private AdisoftDOM expenses = new AdisoftDOM();
	// private AdisoftDOM payments = new AdisoftDOM();
	private AdisoftDOM companies = new AdisoftDOM();
	
	private PersonnelTable pt = new PersonnelTable();
	
	private String[] expenseTypes = null;
	//private String[] paymentTypes = null;
	private String[] expenseComment = null;
	
	private int expenseType = -1;
	private int correctedType = -1;
	private int expenseAmount = -1;
	private int expenseDate = -1;
	
	public ApplyScan ()
	{
		
	}

	public ApplyScan(Connection x, String SQLTerminator)
	{
		setConnection(x);
		setSQLTerminator(SQLTerminator);
		pt.setSQLStrings();
	}
	public ApplyScan(Connection x)
	{
		setConnection(x);
		pt.setSQLStrings();
	}

	public String getCorrectedType()
	{ 
		String retVal = null;
		if (correctedType > -1) retVal = expenseTypes[correctedType];
		return retVal;
	}
	
	public String getExpenseType()
	{
		return getComment(expenseType);
	}
	public String getExpenseAmount()
	{
		return getComment(expenseAmount);
	}
	public String getExpenseDate()
	{
		return getComment(expenseDate);
	}

	private String getComment(int i)
	{ 
		String retVal = null;
		if (i > -1) retVal = expenseComment[i];
		return retVal;
	}

	public void setSQLTerminator(String SQLTerminator)
	{
		pt.setSQLTerminator(SQLTerminator);
	}
	
	public void setConnection(Connection x)
	{
		expenses.setConnection(x);
		expenses.setDOMFromTable("ACCOUNT");

		//payments.setConnection(x);
		//payments.setDOMFromTable("CHARGE");
		
		companies.setConnection(x);
		companies.setDOMFromTable("COMPANY");
		
		pt.setConnection(x);
	}
	
	public boolean setExpense(String pers_num, String x) {
		boolean retVal = setPersnum(pers_num);
		if (retVal) 
		{
			retVal = setExpense(x);
			if (!retVal) AuditTrail.println("[000] ApplyScan.setExpense expense type not found: " + x);
		} else
		{
			AuditTrail.println("[400] ApplyScan.setExpense persnum not found: " + pers_num);
		}
		return retVal;
	}
		
	public boolean setExpense(String x){
		boolean retVal = false;
		expenseType = -1;
		correctedType = -1;
		expenseAmount = -1;
		expenseDate = -1;
		expenseComment = null;
		if (x.length() > 0)
		{
			expenseComment = x.split(" ");
			retVal = classifyExpense(expenseComment);
		}
		return retVal;
	}
	
	public boolean setPersnum(String pers_num){
		boolean retVal = false;

		if ((pt != null) && (pt.getPersNum().equals(pers_num)))
		{
			retVal = true;
		} else {
			retVal = pt.setPersNumInfo(pers_num);
			expenseTypes = getArrayList(expenses, "EXPENSE", pt.getCompany(), "EXPENSE");
			//paymentTypes = getArrayList(payments, "CHARGE", pt.getCompany(), "PAYMENT");
		}
		return retVal;
	}
	
	private String[] getArrayList(AdisoftDOM db, String returnColumn, String company, String companyList)
	{
		String[] retArray1 = new String[0];
		String[] retArray2 = new String[0];
        String[] retArray = new String[0];
        AuditTrail.println("[000] ApplyScan.getArrayList for company: " + company);
		retArray1 = db.getDOMTableArrayWhere(returnColumn, "company", company);
		String secondCompany = companies.getDOMTableValueWhere("company", company, "expense"); //later check that person can post to this expense
		if (!secondCompany.equalsIgnoreCase(company))
		{
			AuditTrail.println("[000] ApplyScan.getArrayList second company added: " + secondCompany);
			retArray2 = db.getDOMTableArrayWhere(returnColumn, "company", secondCompany);
		}
		if (retArray1.length == 0) retArray = retArray2;
		if (retArray2.length == 0) retArray = retArray1;
		if (retArray1.length > 0 && retArray2.length > 0) retArray = combineArrays(retArray1, retArray2);
		for (int i = 0; i < retArray.length; i++) AuditTrail.println("[000] ApplyScan.getArrayList item: " + retArray[i]);
        return retArray;	
	}

	private String[] combineArrays(String[] a1, String[] a2)
	{
		String[] retArray = new String[a1.length + a2.length];
		System.arraycopy(a1, 0, retArray, 0, a1.length);
		System.arraycopy(a2, 0, retArray, a1.length, a2.length);
		return retArray;
	}
	
	private boolean classifyExpense(String[] cmtArray)
	{
		boolean retVal = false;
		for (int i = 0; i < cmtArray.length ; i++) {
			if (setExpenseType(cmtArray[i]))
			{
				expenseType = i;
				i = cmtArray.length;
				retVal = true;
    			AuditTrail.println("[000] ApplyScan.classifyExpense expense type: " + this.getExpenseType());
			}
		}
		return retVal;
	}
	
    private boolean setExpenseType(String item)
    {
    	boolean retVal = false;
    	for (int i = 0; i < expenseTypes.length && !retVal; i++)
    	{
    		if (expenseTypes[i].equalsIgnoreCase(item))
    		{
    			correctedType = i;
    			retVal = true;
    			AuditTrail.println("[000] ApplyScan.setExpenseType corrected expense type: " + this.getCorrectedType());
    		}
    	}
    	return retVal;
    }
}
