/*
ChallengeKey.java - Generates a challenge key which is an internal ID  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

import java.util.*;

//
//  This Object generates the keys used for challenge code creation
//
public class ChallengeKey {
  private static boolean singleServerMode = true;
  // true = one server system (current supported)
  // false = multi server environment
  private static String XORSubstitutionKey;
  private static String TransposeKey;
  private static String AddKey;
  private static String[] retString = new String[3];
  private Random R = new Random();
  public ChallengeKey() {
    newKeys();
  }
  
  private void newKeys(){
    XORSubstitutionKey = generateKey();
    TransposeKey = generateKey();
    AddKey = generateKey();
  }
  
  public String[] getChallengeKey() {
    if (singleServerMode) newKeys(); //should be able to get this working
    retString[0] = XORSubstitutionKey;
    retString[1] = TransposeKey;
    retString[2] = AddKey;
    return retString;
  }
  
  private String generateKey() {
    
    byte[] bKey = new byte[8];
    R.nextBytes(bKey);
    String cKey = new String(bKey);
    return cKey;
  }
}