/*
CommonFunctions.java - Common Functions mainly dealing with strings 
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
import java.util.*;
// need to add a close() method

public class CommonFunctions {

// This object simply provides a set of commonly used methods to any object to use
// Note:  Check on instantiation to see if each object has to instantiate this.

    CommonFunctions() {
    }    

    public static String[] parsDelimStr(String sString) {
        String[] ReturnArray = parsDelimStr(sString, ";");
        return ReturnArray;
    }



    public static String[] parsDelimStr(String sString, String sDelimiter) {
    // Given a delimiter and string, return an array of substrings
    // within the string. Example:
    //          if delimiter = ";" and string = "ABBA; BBAA; CCDD; GGHH"
    //          array will be: {"ABBA", "BBAA", "CCDD", "GGHH"}


        String[] sSubString = new String[100];
        StringTokenizer store = new StringTokenizer(sString.trim(), sDelimiter);
        String[] ReturnArray;
        int iLen = -1;
        int i = 0;

        while(store.hasMoreTokens() ) {
            sSubString[++iLen] = store.nextToken();
        }


        if(iLen > -1){
            ReturnArray = new String[++iLen];
            for(i = 0; i < iLen; i++) {
                ReturnArray[i] = sSubString[i];
            }
        } else {
            ReturnArray = new String[0];
        }

        return ReturnArray;

    }

    public static String singleDot() {
    // Creates a LF + "." + CR and is used for testing of a single dot
    // on a line which in many TCP/IP apps signifies end of a data grouping
        byte[] TheArray = {10,46,13};
        String ReturnString = new String(TheArray,0,3);
        return ReturnString;
    }

    public static String CRLF() {
    // creates a CR + LF string for sending and testing
        byte[] TheArray = {13,10};
        String ReturnString = new String(TheArray,0,2);
        return ReturnString;
    }


    public static String addSlash(String InputString) {
    // adds a slash primarily for creating
        if (!InputString.endsWith("/")) {
            InputString = InputString + "/" ;
        }
        return InputString;
    }

    public static String normalizeString(String InputString) {
        // This method replaces special transmission characters with their normal
        // ASCII values.
        return InputString;       //Dummy function right now!!!!
    }
    public static String hideSpace(String InputString) {
        // This method replaces a space with a character for XML tagname
        // ASCII values.
        return InputString;       //Dummy function right now!!!!
    }
    public static String restoreSpace(String InputString) {
        // This method restores the special space character with a space
        // ASCII values.
        return InputString;       //Dummy function right now!!!!
    }
    public static String makeCurrency(String f) {
        String s = f + "00";
        int i = s.indexOf(".");
        return s.substring(0, i + 2); 
    }    
}