/*
CurrencyTest.java - applies approvals from email messages - DREPRECATED   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;
import org.jdom.Document;


public class Currency
{
    static AuditTrail Logfile;
    private ResultSet myResult;

    private String currency = "";
    private String limit = "";      //transaction limit for input
    private String comment = "";
    private String show = "";
    private String showlist = "";
    private String xrate = "";
    private String ratetype = "";
    private String home = "";
    private String xdate = "";
    private String xsource = "";
    private double normalRate = (double) 0.00;
    
    private String testCurrency = "";
    
    // SQL Items below
    private String currencySQL = "SELECT * FROM CURRENCY WHERE CURRENCY = '$currency$'";
    private String lastRateSQL = "SELECT * FROM FX WHERE CURRENCY = '$currency$' ORDER BY XDATE DESC";  //to upper case
    private String defaultCurrency = "US Dollar";
    private String homeCurrencyString = ";;US Dollar;Local Currency;";
    
    private boolean alreadyLoaded = false;
    
    AdisoftDbase db = new AdisoftDbase();
    
    
    public boolean isAlreadyLoaded() {
        return alreadyLoaded;
    }

    public Currency() {
      Logfile = new AuditTrail();
    }

    //really not using this
    public void setSQLStrings(String A, String B) {
        currencySQL = A;
        lastRateSQL = B;
    }   
    
    public void setConnection(Connection dbCon) {
        db.setConnection(dbCon);
    }
    
    public void setSQLTerminator(String X) {
        db.sqlTerminator = X;
    }
    
    public void setSQLStrings() {
        //rewrite this for to do the SysTable SQL from this object
        if (!alreadyLoaded) {
            ServerSystemTable SysTable = new ServerSystemTable();
            AdisoftDOM SystemDOM = new AdisoftDOM();
            SysTable.setConnection(db.getConnection());
            SysTable.setSQLTerminator(db.getSQLTerminator());
        
            String system_file = SysTable.getSystemString("XMLSYSTEM","C:\\WORK\\"); 
            java.io.File SystemFile = new java.io.File(system_file);
            SystemDOM.setDOM(SystemFile); 
        
            AuditTrail.println("[000] Currency.setSQLStrings from " + system_file);
            currencySQL = SystemDOM.getDOMTableValueFor("currency","currencysql");
            lastRateSQL = SystemDOM.getDOMTableValueFor("currency","lastratesql");
            homeCurrencyString = ";;" + SysTable.getSystemString("currency","US Dollar") + ";Local Currency;";
            defaultCurrency = SysTable.getSystemString("currency","US Dollar");
  
            db.setSchemaTable(SysTable.getSystemString("XMLSCHEMA","C:\\WORK\\"));
            alreadyLoaded = true;
        } else {
            AuditTrail.println("[000] Currency already setup");
        }
    }    
    
    public ResultSet getResult() {
      return db.myResult;
    }
    
    
    //Look at combining the next two methods and the the complete record memos
    
    public boolean setCurrency(String SearchCurrency) {  //uses email

        boolean exitStatus = true;
        String SQLCommand = "SQL not defined";

        if (SearchCurrency == null) return false;

        if (useExistingCurrency(SearchCurrency)) {
            return true;
        } else {
          try {
            SQLCommand = db.SQLReplace(currencySQL,"$currency$",SearchCurrency);
            resetCurrency();             
            if (db.setResultSet(SQLCommand)) {   //change below later to column locations to generalize
                myResult = db.getResultSet();
                updateCurrencyVariables();
                exitStatus = setLastRate(SearchCurrency);
            } else {
                AuditTrail.println("[400] Currency.setCurrency: Invalid currency: " + SearchCurrency);
                AuditTrail.println("[400] " + SQLCommand);
                exitStatus = false;
            }
            db.closeMyState();  
            return (exitStatus);

          } catch (java.lang.NullPointerException ex) {
            AuditTrail.println("[400] Currency.setCurrency: null pointer - force relogin: " + SearchCurrency);
            return false;
          } catch (java.lang.Exception ex){
            AuditTrail.println("[500] Currency.setPersInfo: Error finding " + SearchCurrency);
            AuditTrail.println("[500] SQL: " + SQLCommand);
            AuditTrail.println("[500] Error: " + ex.toString());
            ex.printStackTrace();
            return false;
          }
        }
    }
    
    private boolean setLastRate(String SearchCurrency) {  //uses email

        boolean exitStatus = true;
        String SQLCommand = "SQL not defined";

        if (SearchCurrency == null) return false;

        try {
            SQLCommand = db.SQLReplace(lastRateSQL,"$currency$",SearchCurrency);
            resetRate();             
            if (db.setResultSet(SQLCommand)) {   //change below later to column locations to generalize
                myResult = db.getResultSet();
                updateRateVariables();
            } else {
                AuditTrail.println("[400] Currency.setCurrency: Invalid currency: " + SearchCurrency);
                AuditTrail.println("[400] " + SQLCommand);
                exitStatus = false;
            }
            db.closeMyState();  
            return (exitStatus);

          } catch (java.lang.NullPointerException ex) {
            AuditTrail.println("[400] Currency.setRate: null pointer - force relogin: " + SearchCurrency);
            return false;
          } catch (java.lang.Exception ex){
            AuditTrail.println("[500] Currency.setRate: Error finding " + SearchCurrency);
            AuditTrail.println("[500] SQL: " + SQLCommand);
            AuditTrail.println("[500] Error: " + ex.toString());
            ex.printStackTrace();
            return false;
        }
    }
    
    private boolean useExistingCurrency(String xCurrency) {
    // later can add a storage vector for large scale users.
        return xCurrency.equalsIgnoreCase(currency);
    }
    
    private void updateCurrencyVariables() throws SQLException {
        
       db.setColumns("CURRENCY");
       currency = getTrim(myResult.getString(db.getColumnName("CURRENCY")));
       limit = getTrim(myResult.getString(db.getColumnName("LIMIT")));
       comment = getTrim(myResult.getString(db.getColumnName("COMMENT")));
       show = getTrim(myResult.getString(db.getColumnName("SHOW")));
       showlist = getTrim(myResult.getString(db.getColumnName("SHOWLIST")));
       testCurrency = currency;
    }
    
    private void updateRateVariables() throws SQLException {
        
       db.setColumns("FX"); 
       xrate = getTrim(myResult.getString(db.getColumnName("XRATE")));
       ratetype = getTrim(myResult.getString(db.getColumnName("RATETYPE")));
       home = getTrim(myResult.getString(db.getColumnName("HOME")));
       xdate = getTrim(myResult.getString(db.getColumnName("XDATE")));
       xsource = getTrim(myResult.getString(db.getColumnName("XSOURCE")));
       normalRate = getNormalRate();
    }
    
    public void resetCurrency() {
        
        currency = "";
        limit = "";      //transaction limit for input
        comment = "";
        show = "";
        showlist = "";
        resetRate();
    }
    
    public void resetRate() {
        
        xrate = "";
        ratetype = "";
        home = "";
        xdate = "";
        xsource = "";
        normalRate = (double) 0.00;
    }

    public String getCurrency() {
       return currency;
    }
    
    public String getTestCurrency() {
       return testCurrency;
    }
    
    public String getLimit() {
       return limit;
    }
    
    public String getComment() {
       return comment;
    }

    public String getShow() {
       return show;
    }

    public String getShowlist() {
       return showlist;
    }

    public String getXrate() {
       return xrate;
    }

    public String getRatetype() {
       return ratetype;
    }

    public String getHome() {
       return home;
    }

    public String getXdate() {
       return xdate;
    }

    public String getXsource() {
       return xsource;
    }

    public double getNormalRate() {  //Doesn't appear to function as expected JH 2008-4-16
       Double y = Double.valueOf(xrate);
       double x = y.doubleValue();
       if (ratetype.equals("0")) x = (double) 1 / x;
       return x;
    }
    
    public double getRate(String xCurrency) {
        xCurrency = getTrim(xCurrency);
        //Later on can work in a vector for performance.
        double retRate = (double) 0.00;
        if (homeCurrencyString.indexOf(xCurrency) > -1) {
            retRate = (double) 1.00;
            testCurrency = "Default Currency";
        } else {
          if (setCurrency(xCurrency)) {
             retRate = normalRate;
          }
        }
        AuditTrail.println("[000] Currency.getRate for currency: " + xCurrency + ", rate: " + Double.toString(retRate));
        return retRate;
    }
            
    
    public String repStr(String x, String oldChar, String newChar) 
    {
      //newChar = getTrim(newChar);  
      int startLocate = 0;
      int oldLength = oldChar.length();
      int newLength = newChar.length();
      
      int locate = x.indexOf(oldChar, startLocate);
      while (locate != -1) {
          x = x.substring(0,locate) + newChar + x.substring(locate + oldLength);
          startLocate = locate + newLength;
          locate = x.indexOf(oldChar, startLocate);
      }
      return x;
    }
    private String getTrim(String x) {
      if (x == null) return "";
      return x.trim();
   }
    
    public double getConvertedAmount(double amt)
    {
    	double retVal = (double) (this.getRate( currency ) * amt);
    	return retVal;
    }
    
}

