/*
DB2Client.java - Creates report array for browser from database  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

import org.jdom.Element;
import org.jdom.Document;

public class DB2Client extends DB2ESS {
  private ess.AuditTrail Logfile = new ess.AuditTrail();  
  private String Header = "";
  private String Purposes = "";
  private String Receipts = "";
  private String DBase = "";
  //private AdisoftDOM debugDOM = new AdisoftDOM();
  
  public DB2Client () {
  }
  
  public void setReportStrings (String thisVoucher) {
    
    set(thisVoucher);
    
    Header = getClientHeader();   //
    Purposes = getClientPurposes();
    Receipts = getClientReceipts();
    
    String PurposeComma = "";
    String ReceiptComma = "";
    
    AuditTrail.println("[000] DB2Client.setReportStrings Header: " + Header);
    AuditTrail.println("[000] DB2Client.setReportStrings Purposes: " + Purposes);
    AuditTrail.println("[000] DB2Client.setReportStrings Receipts: " + Receipts);
  }
  
  public void setDBString(Document RegisterDOM) {
    Element DB = RegisterDOM.getRootElement();
    //Logfile.println("[000] Report2Client.setDBString: " + RegisterDOM.toString());
    java.util.List DBaseElements = DB.getChildren();   
    DBase = "[";
    DBase = DBase + setChildren(DBaseElements) ;
    DBase = DBase + "]";   
  }
  
  private String setChildren(java.util.List Children) {
    String ReturnString = "";
    String Comma = "";
    for (int i = 0; i < Children.size(); i++) {
      Element CE = (Element) Children.get(i);
      if (CE.getTextNormalize().length() != 0 || (CE.getContentSize() > 0)) {
        ReturnString += Comma + "[\"" + ess.CommonFunctions.restoreSpace(CE.getName()) + "\""; 
        if (CE.getTextNormalize().length() != 0) {
          ReturnString += ",\"" + repStr(CE.getText()) + "\"" ;  //was getTextNormalize() before
        }
        if (CE.getContentSize() > 0) {
          java.util.List DBaseElements = CE.getChildren();
          ReturnString += ",[" + setChildren(DBaseElements) + "]";
        }  
        ReturnString += "]";
        Comma = ",";
      }
    }
    return ReturnString;
  }
  
  public String getHeader() {
    return Header;
  }  
  public String getPurposes() {
    return Purposes;
  }  
  public String getReceipts() {
    return Receipts;
  } 
  public String getDBase() {
    return DBase;
  }
  
  public static String repStr(String x) {
      x = repStr(x, "\"","'");
      x = repStr(x, "\\","\\\\"); // was "&#92"
      x = repStr(x, "\n","\\n");  // was "&#10;"
      x = repStr(x, "\r","");

      return x; 
  }
   
  public static String repStr(String x, String oldChar, String newChar) 
  {
      int startLocate = 0;
      int oldLength = oldChar.length();
      int newLength = newChar.length();
      
      int locate = x.indexOf(oldChar, startLocate);
      while (locate != -1) {
          x = x.substring(0,locate) + newChar + x.substring(locate + oldLength);
          startLocate = locate + newLength;
          locate = x.indexOf(oldChar, startLocate);
      }
      return x;
  }
    
} //End of DB2Client