/*
EMailXMLFile.java - used to send a XML file in email message 
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

import java.io.*;
//import java.util.*;
import org.jdom.Document;


public class EMailXMLFile extends OutputTextFile {

// Need to add the methodology of opening up a new message file for each rpt.
//
// New to get a hold of the sqlTerminator if we want to use with CodeBase

//
// Need to add methodology to use a different directory than c:/work/inmail
    private ServerSystemTable SystemTable = new ServerSystemTable();
    private AuditTrail AuditLog = new AuditTrail();
    private String Owner = "Adisoft";
    private String Status = "Not Set";
    private String curr_ref = "";
    private boolean AlternateFormat = false;
    private String XMLReference = "";
    private String DBUrl = "";
    private String DBUser = "";
    private String DBPassword = "";
    private String Comment = "";
    protected String sqlTerminator = ";";
 
    public EMailXMLFile() {  //blank constructor
    } 
    
    public EMailXMLFile(String url, String User, String Password) {
        setDB(url, User, Password);
    }    
    
    public void setSystemTable(ServerSystemTable x) {
    	SystemTable = x;
    }
    
    public void setOwner(String setString) {
        Owner = setString;
    }
    
    public void setComment(String setString) {
        Comment = setString;
    }
    
    public void setSQLTerminator(String X) {
        sqlTerminator = X;
    }

    
    public void setDB(String Url, String User, String Password) {
        DBUser = User;
        DBPassword = Password;
        setDB(Url);
    }
    public void setDB(String Url) {
        DBUrl = Url;
        SystemTable.setDB(Url, DBUser, DBPassword);
    }
    
    public void close() throws IOException {
        SystemTable.close();
    }
    
    //public void close() {
    //    DBUrl = "";
    //    SystemTable.close();
    //}
     
    public String getStatus() {
      return Status;
    }
    
    public void setXMLReference(String XMLRef) {
        XMLReference = XMLRef;
    }
    
    public void setMessage(Document Message) {
        
    }

    public void setAlternateFormat() {
        AlternateFormat = true;
    }    

    public boolean setXMLMessage(String MessageText) {
        String Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");
        return(outputSMTPFile(MessageText, Reference,"xml", Reference));
    }

    //public void setXMLMessage(String MessageText) {
    //    String Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");
    //    outputSMTPFile(MessageText, Reference,"xml", Reference);
    //}

    public boolean setMessage(String MessageText, String FileName, String Extension, String Reference) {
      return(outputSMTPFile(MessageText, FileName, Extension, Reference));
    }
    

    public boolean setMessage(String MessageText, String FileName) {
      String Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");  
      return(outputSMTPFile(MessageText, FileName, "out", Reference));
    }
    
    private boolean outputSMTPFile(String MessageText, String FileName, String FileType, String Reference) {
       boolean exitStatus = true;
       String message = "";
       String PositiveMessage = "Message sent";
       if (!Comment.equals("")) PositiveMessage = Comment;

       String smtp_address = SystemTable.getSystemString("smtp_address","127.0.0.1");
       String smtp_port = SystemTable.getSystemString("smtp_port","25");
       String rcpt_to = SystemTable.getSystemString("exp_email_address","expense@expenseservices.com");
       String from_address = SystemTable.getSystemString("pal_email_address","expense@expenseservices.com");
       String EmailFileName = SystemTable.getSystemString("xml_folder","C:\\WORK\\")+ FileName + "." + FileType;
       Register reg = new Register(SystemTable.getConnection()); 
       reg.setEmailFileName(EmailFileName);
       reg.setOwner(Owner);
       
       AdisoftDOM DOM = new AdisoftDOM();
       DOM.setDB(DBUrl, DBUser, DBPassword);
       Enhancement Enh = new Enhancement();
       Enh.setDB(DBUrl, DBUser, DBPassword);
       // used to match reference in parent directory.  need to set up a parameter for packing later
       String xref = setXref(XMLReference);
       reg.setXMLReference(xref); //kc
       reg.setReference(Reference);
       java.util.Date now = new java.util.Date();
       reg.setReportDate(now.toGMTString());
      
       String dataType = "report";  //temporary
       try {
            this.createFileHandle(EmailFileName);
            AuditTrail.println("[000] RPT file creation:" + EmailFileName);
            this.writeln("<register type=\"" + dataType + "\">");
            this.writeln("<reference>" + Reference + "</reference>");
            this.writeln("<smtp_address>" + smtp_address + "</smtp_address>");
            this.writeln("<rcpt_to>" + rcpt_to + "</rcpt_to>");
            this.writeln("<file>" + EmailFileName + "</file>");
            this.writeln("<from>" + from_address + "</from>");
            this.writeln("<reply-to>" + Owner + "</reply-to>"); //temporary
            this.writeln(MessageText);
            this.writeln("</register>");
            super.close();
            SMTPSingle SendingMsg = new SMTPSingle(); //set up thge SMTP transmission class
            SendingMsg.setIP_URL(smtp_address);  //point to SMTP server that we are using
            SendingMsg.setPort(smtp_port);
            DOM.setDOM(MessageText);    // Create a new DOM so we can normalize the transmission
            DOM.setNormal();            // normalized the transmission 
            Enh.setExp2Cat(DOM);           //enhancing file with mappings - maybe just for
            Enh.setTable("CHARGE");        //testing, but might also help with ESS conversion
            Enh.setSearch4("charge");
            Enh.setCompliment("reimb");
            Enh.setParentType("charge");
            Enh.setEnhancement("reimb");
            Enh.setGeneric(DOM);           // done with the mappings
            if (AlternateFormat) {
               DOM.setDocType();                  // set DocType to xml
               DOM.setOmitDeclaration(false); 
               XML2ESS x = new XML2ESS();
               x.setDB(DBUrl, DBUser, DBPassword,sqlTerminator);
               x.setReference(XMLReference);
               x.set(DOM);
               message = "ZCZC\r\n" + x.getReport() + "NNNN";
               x.close();
            } else {
               MessageText =  "<register type=\"report\">";
               MessageText += "<reference>" + Reference + "</reference>";
               MessageText += "<smtp_address>" + smtp_address + "</smtp_address>";
               MessageText += "<rcpt_to>" + rcpt_to + "</rcpt_to>";
               MessageText += "<file>" + EmailFileName + "</file>";
               MessageText += "<from>" + from_address + "</from>";
               MessageText += "<reply-to>" + Owner + "</reply-to>";     //jh 11-22-2002         
               MessageText += DOM.toString(false);
               MessageText += "</register>"; 
               DOM.setDOM(MessageText);
               DOM.setDocType();                  // set DocType to xml
               DOM.setOmitDeclaration(false); 
               message = DOM.toString();
            }   
            SendingMsg.setMimeSendType("attachment");   
            if (SendingMsg.setSMTPMessage(message,rcpt_to,from_address)) {
                Status = reg.getStatus(); //kc
                AuditTrail.println("[230] EMailXMLFile.setMessage file sent:" + EmailFileName);
                reg.setMessage(PositiveMessage);
                reg.setSimple(reg.REFERENCE,Reference);
               
            } else {
               AuditTrail.println("[400] EMailXMLFile.setMessage transmission failure:" + EmailFileName);
               reg.setStatus("Problem");
               Status = "Not Delivered";
               reg.setMessage("Report not sent - transmission failure");
               reg.setSimple(reg.REFERENCE,Reference);
               exitStatus = false;
            }    
            Status = reg.getStatus();
            curr_ref = Reference;
       } catch (IOException e) {
            e.printStackTrace();
            AuditTrail.println("[500] EMailXMLFile.setMessage file creation failure.");
            Status = "Sys Error";
            exitStatus = false;
       }
       reg.close();
       return exitStatus;
    }
    public String setXref(String X) {
       String xref = "00000000" + X.toUpperCase();
       String alternatePrefix = SystemTable.getSystemString("alternateprefix","A");
       xref = alternatePrefix + xref.substring(xref.length() - 7);
       return xref;
    }

}



    
