/*
ESSCEO.java - routes to the accounting address  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;
//import java.sql.*;
//import org.jdom.Document; //See if I can find this
//import org.jdom.Element;
//import org.jdom.DocType;
//import org.jdom.input.SAXBuilder;
//import org.jdom.output.XMLOutputter;


public class ESSCEO implements RouteTo
{
//expense report status

    static AuditTrail Logfile;
    String DBUrl;
    String DBUser;
    String DBPassword;
    Connection DBConn;
    PersonnelTable PT;
    ServerSystemTable Sys;
    
    private AdisoftDOM SecurityDOM = new AdisoftDOM();
    
    public void init(Connection DBConnection, String SQLTerminator) 
    {
        DBConn = DBConnection;
        Sys = new ServerSystemTable();
        Sys.setConnection(DBConn);
        Sys.setSQLTerminator(SQLTerminator);
        PT = new PersonnelTable();
        PT.setConnection(DBConn);
        PT.setSQLTerminator(SQLTerminator);        
        PT.setSQLStrings();
        setSecurityDOM();
    }

    public void init(String DBUrl, String DBUser, String DBPassword, String SQLTerminator)
    {
        Sys = new ServerSystemTable(DBUrl, DBUser, DBPassword);
        DBConn = Sys.getConnection();
        Sys.setSQLTerminator(SQLTerminator);        
        PT = new PersonnelTable();
        PT.setConnection(DBConn);
        PT.setSQLTerminator(SQLTerminator);        
        PT.setSQLStrings();
        setSecurityDOM();
    }
    
    public void setCurrencyConversion(double multiplier)
    {
    	// stub
    }

    private void setSecurityDOM() {
        String security_file = Sys.getSystemString("XMLSECURITY","C:\\WORK\\"); 
        java.io.File SecurityFile = new java.io.File(security_file);
        SecurityDOM.setDOM(SecurityFile); 
    }
    
    public String getEmailAddress(String persNum)
    {
// logon: Astation
// pwd: adisoft
        return SecurityDOM.getDOMTableValueWhere("uniquefunctions","function","ceo","email");
    }
    
    public String getEmailAddress(String persNum, String duplicateSignatureOK, String chargedDepart, String chargedCompany, String limitRequired, String reportAmount, 
                    String adminSigned, String signed1, String singed2, boolean atLeastOnce)
    {
        return SecurityDOM.getDOMTableValueWhere("uniquefunctions","function","ceo","email");
    }
    public String getRouteToPersNum() 
    {
        return SecurityDOM.getDOMTableValueWhere("uniquefunctions","function","ceo","persnum");
    }
    
    public void close()
    {
        if (Sys != null)
        {
            Sys.close();
            Sys = null;
        }
        if (PT != null)
        {
            PT.close();
            PT = null;
        }
    }
}
