/*
ESSManagerDepartSimple.java - id manager from depart and chains through user profile  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
//import java.util.*;
//import java.sql.*;
//import java.sql.*;
//import org.jdom.Document; //See if I can find this
//import org.jdom.Element;
//import org.jdom.DocType;
//import org.jdom.input.SAXBuilder;
//import org.jdom.output.XMLOutputter;


public class ESSManagerDepartSimple extends ApproverEmailAddress
{

/**
This method Returns the depart's email address. 
*/
    public String getEmailAddress(String persNum)
    {
        return (getEmailAddress(persNum, "NO", "", "", "NO", "", "", "", "", false));
    }
/**
This method Returns the submitter's email address.
*/
    public String getEmailAddress(String persNum, String duplicateSignatureOK, String chargedDepart, String chargedCompany, String limitRequired, String reportAmount, 
                    String adminSigned, String signed1, String signed2, boolean atLeastOnce)
    {
        String email = "";
        
        super.getEmailAddress(persNum, duplicateSignatureOK, chargedDepart, 
        		        chargedCompany, limitRequired, reportAmount, 
                        adminSigned, signed1, signed2, atLeastOnce);
        
        if (submitter.setPersNumInfo(persNum))
        {
            DepartmentTable depart = new DepartmentTable();
            depart.setConnection(DBConn);
            depart.setSQLTerminator(sqlTerminator); //jh 2006-03-01
            depart.setSQLStrings();
            if (depart.setDepartInfo(submitter.getDepartment().trim(), submitter.getCompany()))
            {
                PersonnelTable manager = submitter;
                String managerPersNum = manager.getManager();
                while (email.length() == 0 && manager.setPersNumInfo(managerPersNum))
                {
                    if (validateDuplicateSignatures(managerPersNum))
                        if (limitRequired.equalsIgnoreCase("NO") || manager.validLimit(super.reportAmount,super.currencyConversionRate))
                            email = manager.getEmailAddress();
                    managerPersNum = manager.getManager();
                } 
                if (email.length() > 0) receiver = manager;
            }
            
            if (depart != null)
                depart.close();
        }
        return email;
    }
}
