/*
ESSManagerDepartment.java - gets manager of a department for routing 
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
//import java.util.*;
//import java.sql.*;
//import java.sql.*;
//import org.jdom.Document; //See if I can find this
//import org.jdom.Element;
//import org.jdom.DocType;
//import org.jdom.input.SAXBuilder;
//import org.jdom.output.XMLOutputter;


public class ESSManagerDepartment extends ApproverEmailAddress
{

/**
This method Returns the depart's email address. 
*/
    public String getEmailAddress(String persNum)
    {
        return (getEmailAddress(persNum, "NO", "", "", "NO", "", "", "", "", false));
    }
/**
This method Returns the submitter's email address.
*/
    public String getEmailAddress(String persNum, String duplicateSignatureOK, String chargedDepart, String chargedCompany, String limitRequired, String repAmount, 
                    String adminSigned, String signed1, String signed2, boolean atLeastOnce)
    {
        String email = "";
        String superDepart = "";
        boolean retVal;
        
        super.getEmailAddress(persNum, duplicateSignatureOK, chargedDepart, 
        		        chargedCompany, limitRequired, repAmount, 
                        adminSigned, signed1, signed2, atLeastOnce);
//AuditTrail.println("[000] ESSManagerDepartment (1)");        
        if (submitter.setPersNumInfo(persNum))
        {
//AuditTrail.println("[000] ESSManagerDepartment (2)");             
            DepartmentTable depart = new DepartmentTable();
            depart.setConnection(DBConn);
            depart.setSQLTerminator(sqlTerminator); //jh 2006-03-01
            depart.setSQLStrings();
            if (depart.setDepartInfo(submitter.getDepartment().trim(), submitter.getCompany()))
            {
                PersonnelTable manager = submitter;
                String managerPersNum = depart.getManager();
                retVal = (!managerPersNum.equals("") && manager.setPersNumInfo(managerPersNum));
//AuditTrail.println("[000] ESSManagerDepartment (3) email:" + email);                 
//AuditTrail.println("[000] ESSManagerDepartment (3) depart.depart: " + depart.depart);                 
                while (email.length() == 0 && !depart.depart.equals(""))
                {
//AuditTrail.println("[000] ESSManagerDepartment (4) email:" + email);                 
//AuditTrail.println("[000] ESSManagerDepartment (4) depart.depart: " + depart.depart);                 
                    if (  retVal &&
                          validateDuplicateSignatures(managerPersNum) && 
                         (limitRequired.equalsIgnoreCase("NO") || manager.validLimit(super.reportAmount,currencyConversionRate)))

                    {
                            email = manager.getEmailAddress();
                    } else {
                            superDepart = depart.getSuperDepartment(); 
                            if (!superDepart.equals("") && depart.setDepartInfo(superDepart, submitter.getCompany()) == true)
                            {
                                managerPersNum = depart.getManager();
//AuditTrail.println("[000] ESSManagerDepartment Manager: " + managerPersNum);                                
                                if (!managerPersNum.equals("") && manager.setPersNumInfo(managerPersNum))
                                {
//AuditTrail.println("[000] ESSManagerDepartment Manager: true");                                    
                                    retVal = true;
                                } else {
//AuditTrail.println("[000] ESSManagerDepartment Manager: false");                                    
                                    retVal = false;
                                }
                            } else {
//AuditTrail.println("[000] ESSManagerDepartment Manager: set to blank");                                 
                                managerPersNum = "";  //need to add somekind of break flag
                                if (superDepart.equals("")) depart.depart = "";
                            }  
                    }
                         
                } 
                if (email.length() > 0) receiver = manager;
            }
            
            if (depart != null)
                depart.close();
        }
//AuditTrail.println("[000] ESSManagerDepartment (x)");         
        return email;
    }
}
