/*
Enhancement.java - adds information to a DOM (e.g., report.xml)   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.net.URL;
import java.sql.*;
//import java.io.*;
//import java.util.*;
//import org.jdom.Document;
import org.jdom.Element;

public class Enhancement extends AdisoftTreeAPI4DOM {
  //Used to enhance an element by looking up information in another table that it is
  //related to and then adding that information to the element.
  private java.util.List Accounts;
  private String Search4Element = "expensetype";  //item containing the relation
  private String ComplimentName = "category";     //item that needs the compliment
  private String sTable = "ACCOUNT";              //table to look in
  private String parentType = "expense";          //item in table that is the link to Search4Element
  private String enhancement = "category";        //item that has the value for ComplimentName
  private String DBUrl = "";
  private String DBUser = "";
  private String DBPassword = "";
  private Connection DBConn;
  private String sqlTerminator = ";";
  
  static AuditTrail Logfile;
    
  public Enhancement(){
  }  
  
  public void setConnection(Connection Conn) {
    DBConn = Conn;
  }
  
  public void setDB(String Url) {
    DBUrl = Url;
  }
  
  public void setDB(String Url, String User, String Password) {
    DBUrl = Url;
    DBUser = User;
    DBPassword = Password;
  }
  
  public void setSQLTerminator(String X) {
    sqlTerminator = X;
  }
  
  public void setTable (String table) {
    sTable = table;
  }  
  
  public void setSearch4 (String S4) {
    Search4Element = S4;
  }  
   
  public void setCompliment (String CM) {
    ComplimentName = CM;
  }  
   
  public void setParentType (String PT) {
    parentType = PT;
  }
  
  public void setEnhancement (String Enh) {
    enhancement = Enh;
  }  
    
  public void setGeneric(AdisoftDOM ReportDOM) {
    setValues(ReportDOM, sTable);
  }
  
  public void setExp2Cat(AdisoftDOM ReportDOM) {
    setValues(ReportDOM, "ACCOUNT");
  }
    
  private void setValues(AdisoftDOM ReportDOM, String acctTable) {
    AdisoftDOM AccountTable = new AdisoftDOM();
    if (DBConn == null) {
      AccountTable.setDB(DBUrl,DBUser,DBPassword);
      AccountTable.setSQLTerminator(sqlTerminator);
    } else {
      AccountTable.setConnection(DBConn);
      AccountTable.setSQLTerminator(sqlTerminator);
    }
    AccountTable.setDOMFromTable(acctTable);
    Accounts = AccountTable.getDOM().getRootElement().getChildren();
    ReportDOM.performAgainstDOM(this);
  }

  public void doMethod (Element CurrentElement) {
    if (CurrentElement.getName().equals(Search4Element)) {
      Element thisParent = (Element) CurrentElement.getParent();
      Element ComplimentElement = new Element(ComplimentName);
      ComplimentElement = (Element) ComplimentElement.addContent(matchedValue(CurrentElement.getText()));
      thisParent = (Element) thisParent.addContent(ComplimentElement);
    }    
  }
  private String matchedValue(String SearchItem) {
    Element row;
    Element expense;
    String retVal = ""; 
    int i = 0;
    do {
      row = (Element) Accounts.get(i);  // get a row from the database
      if (row.getChild(parentType) != null) {  //temporary for fleet ->.toLowerCase()
        if (row.getChild(parentType).getText().equalsIgnoreCase(SearchItem)) {
          if (row.getChild(enhancement) != null) {  //temporary for fleet ->.toLowerCase()  
            retVal = row.getChild(enhancement).getText();
            i = Accounts.size();
          } else {
            AuditTrail.println("[500] Enhancement.matchedValue: Could not find enhancement: " + enhancement);
          }  
        }    // not equals is not an error condition.
      } else {
        AuditTrail.println("[500] Enhancement.matchedValue: didn't find a row for " + parentType);
      }  
      i = i + 1;
    } while (i < Accounts.size());
    return retVal; 
  }

}