/*
ExpSysTable.java - accesses a legacy system table - DEPRECATED   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.net.URL;
import java.sql.*;

//
//  This object extends the Dbase class to provide enhancements for reading and writing
//  to the SYSTEM table which contains setup and control parameters
//

public class ExpSysTable extends AdisoftDbase {

    //Statement myState;                          // every instance gets a pair of these
    //ResultSet myResult;

    //static AuditTrail Logfile;
    //static AdisoftDbase DbaseObject = new AdisoftDbase();     // all instances share these
    private String DBUrl = "jdbc:odbc:adisoftdbase";
    static IncrementDbase IncDB = new IncrementDbase();
    
    public ExpSysTable() {
    }

    public ExpSysTable(String DBUrl) {
        this.DBUrl = DBUrl;
        setDB(DBUrl);
    }

    public void setLockTable (String x) {
        IncDB.setLockTable(x);
    }

    public String getString(String ElementTag, String ElementDefault) {


        try {
            myState = dbCon.createStatement();
            myResult = myState.executeQuery("SELECT " + ElementTag.trim() + " FROM EXPSYS" + sqlTerminator);

            if (myResult.next()) {
                return myResult.getString(ElementTag);
            } else {
                return ElementDefault;
            }


        } catch (java.lang.Exception ex){
            ex.printStackTrace();
            AuditTrail.println("[000] ExpSysTable.getString Default for " + ElementTag + " used: " + ElementDefault);
            return ElementDefault;
        }
    }

    
    public void setString(String ElementTag, String ElementValue) {
        putString(ElementTag, ElementValue);
    }    
    
    public void putString(String ElementTag, String ElementValue) {
        int returnResult;
        Integer returnInteger;
        String SQLStatement = "SQL statement not yet constructed";

        try {

            if (getString(ElementTag,"NONE_NONE").equals("NONE_NONE")) {
                SQLStatement = "INSERT INTO EXPSYS (" + ElementTag.trim() +") VALUES ('" + ElementValue.trim() + "')" + sqlTerminator;
            } else {
                SQLStatement = "UPDATE EXPSYS SET " + ElementTag.trim() + " = '" + ElementValue.trim() + "'" + sqlTerminator;
            }
            
            returnResult = myState.executeUpdate(SQLStatement);
            returnInteger = new Integer(returnResult);

            if (returnResult == 1) {
                AuditTrail.println("[000] ExpSysTable.putString succeeded: " + ElementTag.trim() + ", " + ElementValue.trim());
            } else {
                AuditTrail.println("[500] ExpSysTable.putString failed: " + ElementTag.trim() + ", " + ElementValue.trim() + ", Error: " + returnInteger.toString());
            }


        } catch (java.lang.Exception ex){
            ex.printStackTrace();    //want to get this to the log file
            AuditTrail.println("[500] ExpSysTable.putString failed for " + ElementTag.trim() + ", value: " + ElementValue.trim());
            AuditTrail.println("[500] ExpSysTable.putString SQL: " + SQLStatement);

        }

    }

    public void setInt(String ElementTag, int ElementValue){
        putInt(ElementTag, ElementValue);
    }    

    public void putInt(String ElementTag, int ElementValue){
        Integer IntResult = new Integer(ElementValue);
        putString(ElementTag, IntResult.toString());
    }


    public int getInt(String ElementTag) {
// This method gets a ExpSys string and converts it to an int.
        String StringResult = getString(ElementTag, "-1");
        Integer IntResult = new Integer(Utilities.removeDecimals(getTrim(StringResult)));
        return IntResult.intValue();
    }


    public synchronized int getExpSysIncrement(String ElementTag) {
        String getSQL = "SELECT " + ElementTag + " FROM EXPSYS";
        String putSQL = "UPDATE EXPSYS SET " + ElementTag + " = '$columnvalue$'";
        int intResult = IncDB.IncrementInDbase(dbCon, ElementTag, "EXPSYS",getSQL, putSQL);
        return intResult;
    }

    public String getExpSysIncString(String ElementTag) {
        int IntValue = getExpSysIncrement(getTrim(ElementTag));
        String StringResult = new Integer(IntValue).toString(); 
        return StringResult;
    } 
    public String getTrim(String x) {
      if (x == null) return "";
      return x.trim();
    }
    private String getReferenceString(int Value, int xLen, String sequencePrefix) {
      String S = Integer.toString(Value);
      String NewS = "0000000000" + S;
      if (!sequencePrefix.equals("") && sequencePrefix != null) xLen = xLen - sequencePrefix.length();
      return sequencePrefix + NewS.substring(NewS.length()-xLen);
    }
    
    private boolean findDBFReport(String voucher)
    {
        Statement myState;                          
        ResultSet myResult;
        boolean result = false;
        try
        {            
            myState = dbCon.createStatement();
            myResult = myState.executeQuery("SELECT VOUCHER FROM REPORT WHERE VOUCHER = '" + voucher.trim() + "' ORDER BY VOUCHER" + sqlTerminator);
            result = myResult.next();
         }
        catch (Exception e)
        {
            e.printStackTrace();    //want to get this to the log file
            AuditTrail.println("[500] ExpSysTable.findDBFReport failed for voucher " + voucher);
        }
        
            return (result);
    }
    
    public String getExpSysIncString(String elementTag, boolean unique, String sequencePrefix) {
        int nextVoucher = 0;
        String searchString;
        int searchNum;
        boolean numberUsed = false;
        String result = null; 
        int test = -1;
        nextVoucher = getExpSysIncrement(elementTag);
        searchNum = nextVoucher;
        
        do
        {
            searchString = getReferenceString(searchNum, 8, sequencePrefix);
            if (findDBFReport(searchString) == true)
            {
                numberUsed = true;
                searchNum += 1000;
            }
            else 
                numberUsed = false;
        } while (numberUsed == true);    
        
        if (searchNum != nextVoucher)
            putInt(elementTag, ++searchNum);
        return (searchString);
        
    }    
}

