/*
ExpenseReport.java - Expense report class unsed in guideline checking   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
import java.util.*;
import java.text.*;
import java.sql.*;
import org.jdom.Document;
//import org.jdom.Element;
//import org.jdom.Attribute;
//import org.jdom.DocType;
//import org.jdom.input.SAXBuilder;
//import org.jdom.output.XMLOutputter;

public class ExpenseReport {
    public final int LINE = 1;
    public final int DAILY = 2;
    public final int NIGHTS = 3;
    public final int REPORT = 4;
    public final int TOTAL = 5;
    public final int ADVANCE = 6;
    public final int REIMBURSE = 7;
    public final int DAYS = 8;
    public final int WEEKEND = 9;
    public final int DATE = 10;
    public final int MILEAGERATE = 11;
    public final int LODGING = 12;
    
    
    String DbaseURL = "";
    String DbaseUser = "";
    String DbasePassword = "";
    Connection dbConnection;
    protected Header header;
    protected Vector purposes = new Vector();
    protected Vector receipts = new Vector();
    protected SortVector rptExpenses = new SortVector(new compareExpenses());
    private String guidelineReport = "";
    private String guidelineStatus = "passed";
    private boolean debug = false;
    private boolean format = true;
    protected final int BY_CATEGORY_EXPDATE_XREF = 0;
    protected final int BY_RECEIPTS = 1;
    protected int sortBy = BY_CATEGORY_EXPDATE_XREF;
    protected int prevSortBy;
    private java.util.Date submit_date;
    private String encrypt = "No";
    private int encryptKey = 6;
    protected String sqlTerminator = ";";
    PersonnelTable PT = new PersonnelTable();
    float personalRate = (float) 0.0;
    
    static AuditTrail Logfile;
    private String dateFormatStr = "MM/dd/yyyy";
    private String decimalStr = ".";
    private String separatorStr = ",";
    private ess.Language myLang = new ess.Language();
    private ess.CustomDate cDate = new ess.CustomDate();
    
    public ExpenseReport ()
    {
    }
    
    public void setConnection(Connection dbConn,String SQLTerminator) {
    }
    public void setHeaderFieldNames(String[] x) {
    }
    public void setPurposeFieldNames(String[] x) {
    }
    public void setReceiptFieldNames(String[] x) {
    }
    public void setExpenseFieldNames(String[] x) {
    }
    public void setReport (Document reportDOM) {
    }
    
    public void setDefaults(Connection dbConn, String SQLTerm)
    {
        sqlTerminator = SQLTerm;
        PT.setConnection(dbConn);  //JH 1/19/04
        PT.setSQLTerminator(sqlTerminator);
        PT.setSQLStrings();
        ServerSystemTable ST = new ServerSystemTable();  //Look at duplication in DB2Guideline
        ST.setConnection(dbConn);
        ST.setSQLTerminator(sqlTerminator);
        AdisoftDOM SD = new AdisoftDOM();
        SD.setSQLTerminator(sqlTerminator);
        String system_file = ST.getSystemString("XMLSYSTEM","C:\\WORK\\"); 
        java.io.File SystemFile = new java.io.File(system_file);
        SD.setDOM(SystemFile); 
        
        encrypt = SD.getDOMTableValueFor("encrypt","apply","No");
        if (encrypt.equalsIgnoreCase("YES")) {
          String encryptKeyStr = SD.getDOMTableValueFor("encrypt","key","15");
          encryptKey = Integer.parseInt(encryptKeyStr);
        }
    }
    
    //public void setSystemTable (ServerSystemTable sysTable) {
    //    ST = sysTable;
    //}
    
    
    public void setLanguage(ess.Language x) {
    	myLang = x;
    }
    
    public void setLanguage(String x){
  	  myLang.setLanguage(x);
    }

    public void setLanguage(String x, String y){
  	  myLang.setLanguage(x,y);
    }
    
    public void setDateFormat(String x) {
  	  dateFormatStr = x;
    }
    
    public java.util.Date getDateFromString(String x)
    {
       return cDate.getDateFromStr(x,dateFormatStr);	
    }
    
    public void setDecimal(String x) {
  	  decimalStr = x;
    }

    public void setSeparator(String x) {
  	  separatorStr = x;
    }
    
    public void setSortBy(int sortType)
    {
        prevSortBy = sortBy;
        sortBy = sortType;
    }
        
    public void restoreSortBy()
    {
        sortBy = prevSortBy;
    }
        
    public void resetSortBy()
    {
        sortBy = BY_CATEGORY_EXPDATE_XREF;
    }
        

    public void sort()
    {
          rptExpenses.sort();
    }
            
            
    protected class Header
    {
      String persNum = null;
      String name = null;
      String phone = null;
      String location = null;
      String depart = null;
      java.util.Date creDate = null;
      String admin1 = null;
      String email = null;
      java.util.Date subDate = null;
      String currency = null;         //2007-06-28
                    
        Header (String persNum, String name, String phone, String location,
                    String depart, java.util.Date creDate, String admin1,
                    String email, java.util.Date subDate, String currency)
        {
            this.persNum = persNum ;
            this.name = unScramble(name);
            this.phone = phone;
            this.location = location;
            this.depart = depart;
            this.creDate = creDate;
            this.admin1 = admin1;
            this.email = email;
            this.currency = currency;
            
            if (subDate == null || subDate.equals("")) subDate = Utilities.today();
            this.subDate = subDate;
            submit_date = this.subDate;
            if (PT.setPersNumInfo(persNum)) {
               personalRate = java.lang.Float.valueOf(PT.getMileage()).floatValue(); 
            }
        }
        
        public String getPersNum()
        {
            return(persNum);
        }
        
        public String getCurrency()
        {
            return(currency);
        }
        
        public String toString()
        {
            return (persNum + "  " + name + "  " + phone + "  " + 
                        location + "  " + depart + "  " + creDate + "  " +
                    admin1 + "  " + email + "  " + currency);
                
        }
        
    }
//End of Header class
    
    protected class Purpose
    {
        private String project;
        private String stepno;
        private String clientNo;
        private String client;
        private String location;
        private String comment;
        private java.util.Date begDate;
        private java.util.Date endDate;
        private int days = 0;
        private int nights = 0;
        private String xref;
                
        Purpose(String project, String stepno, String clientNo,
                String client, String location, String comment,
                java.util.Date begDate, java.util.Date endDate,int days, int nights, String xref)
        {
            this.project = unScramble(project);
            this.stepno = stepno;
            this.clientNo = unScramble(clientNo);
            this.client = unScramble(client);
            this.location = unScramble(location);
            this.comment = unScramble(comment);
            this.begDate = begDate; 
            this.endDate = endDate;
            this.xref = xref;
            if ((days == 0) && (begDate != null) && (endDate != null))
                this.days = Utilities.days(endDate, begDate) + 1;
            else
                this.days = days;
            this.nights = nights > 0 ? nights : ((this.days > 0) ? this.days - 1 : 0);
        }
        
        public String getXref()
        {
            return(xref);
        }
        
        public int getDays()
        {
            return(days);
        }
        
        public int getNights()
        {
            return(nights);
        }
        public String getLocation()
        {
            return(location);
        }
        public boolean sameXref(String expRef)
        {
            return(xref.equals(expRef));
        }
        
        public String toString()
        {
            return (project + "  " + stepno + "  " + clientNo + "  " +
                client + "  " + location + "  " + comment+ "  " +
                begDate + "  " + endDate + "  " + days + "  " + nights + "  " + xref);
                
        }
    }
//End of Purpose class

    protected class Receipt
    {
        private String receipt;
        private double amount; 
        private String units;
        private float xrate;
        private java.util.Date rcptDate;
        private String sequence; 
        private Vector rcptExpenses; 
        private String comment;
        private String charge;
        private String reimburse;
        private String xref;
        private java.util.Date begDate;
        
        Receipt(String receipt, double amount, String units, float xrate, java.util.Date rcptDate, Vector rcptExpenses, String comment,
                   String charge, String reimburse, java.util.Date begDate, String xref)
        {
            setReceipt(receipt, amount, units, xrate, rcptDate, rcptExpenses, comment,
                   charge, reimburse, begDate, xref);
        }
                
        private void setReceipt(String receipt, double amount, String units, float xrate, java.util.Date rcptDate, Vector rcptExpenses, String comment,
                   String charge, String reimburse, java.util.Date begDate, String xref)
        {
            this.receipt = getTrim(receipt);
            this.amount = amount;
            this.units = getTrim(units);
            this.xrate = xrate;
            this.rcptDate = rcptDate;
            this.rcptExpenses = rcptExpenses;
            this.comment = getTrim(comment);
            this.charge = getTrim(charge);
            this.reimburse = getTrim(reimburse);
            this.begDate = begDate;
            this.xref = getTrim(xref);

            if (rcptExpenses!= null)
            {
                for (int i = 0; i < rcptExpenses.size(); i++)
                    ((Expense) rcptExpenses.elementAt(i)).setReimburse(reimburse);
            }
        }
        
        public boolean isUnits(String units)
        {
            return(this.units.equalsIgnoreCase(units));
        }
        
        public float getXrate()
        {
            return(xrate);
        }
        
        public java.util.Date getRcptDate()
        {
            return(rcptDate);
        }
        public int getNights()
        {
            return(Utilities.days(rcptDate, begDate));
        }
        
        
        public boolean equals(Receipt other)
        {
            return(receipt.equals(other.receipt));
        }
        
        public boolean sameReceipt(String receipt)
        {
            return( this.receipt.equals(receipt));
        }
        
        public String toString()
        {
            return (rcptDate + "  " + amount + "  " + 
                        rcptExpenses + "  " + comment);
        }
    }
//End of Receipt class

    protected class Expense
    {
        private String receipt = "";
        private String sequence = "";
        private java.util.Date expenseDate = null;
        private String expenseType = "";
        private String category = "";
        private double amount = 0.0; 
        private int perSplit = 0;
        private String comment = "";
        private String xref = ""; 
        private String reimburseStatus;
                
        Expense(String receipt, String sequence, java.util.Date expenseDate, String expenseType, String expenseCategory,
                    double amount, int perSplit, String comment, String xref, String reimburseStatus)
        {
            setExpense(receipt, sequence, expenseDate, expenseType, expenseCategory,
                    amount, perSplit, comment, xref, reimburseStatus);
        }
        
        private void setExpense(String receipt, String sequence, java.util.Date expenseDate, String expenseType, String expenseCategory,
                    double amount, int perSplit, String comment, String xref, String reimburseStatus)
        {

            this.receipt = getTrim(receipt);
            this.sequence = getTrim(sequence);
            this.expenseDate = expenseDate;
            this.expenseType = getTrim(expenseType);
            this.category = getTrim(expenseCategory);
            this.amount = amount;
            this.perSplit = perSplit;
            this.comment = getTrim(unScramble(comment));
            this.xref = getTrim(xref);
            this.reimburseStatus = getTrim(reimburseStatus);
            
            if (this.expenseDate == null) 
            {
                this.expenseDate = new java.util.Date();
            }
        }
        
        public String toString()
        {
            return(receipt + " " + expenseDate + " " + expenseType + " " + amount + "\n");
        }
       
        public void setReimburse(String rcptReimburse)
        {
// Need to use reimburse == null  instead of false
            if (reimburseStatus == null)
                reimburseStatus = rcptReimburse;
        }
        
        public java.util.Date getExpenseDate()
        {
            return(expenseDate);
        }
        
        public double getAmount()
        {
            return (amount);
        }
        
        public double getPerSplit()
        {
            return (perSplit);
        }
        
        public double getPerPersonAmount()
        {
            return (perSplit <= 1 ? amount : amount / perSplit);
        }
        
        public String getCategory()
        {   
            return (category);
        }
        
        public String getXref()
        {
            return (xref);
        }
        
        public String getReceipt()
        {
            return (receipt);
        }
      
        public double getReimburse()
        {
            double reimbAmount = 0;
            
            if ((reimburseStatus != null) && (reimburseStatus.equals("1")))
                reimbAmount = amount;
                
            return (reimbAmount);
        }
        
        public int getDaysOld()
        {
            return (Utilities.days(submit_date, expenseDate));
        }
        
        public boolean sameExpenseCategory(String expenseCategory)
        {
            String UC_expCategory;
            String UC_category;

            UC_expCategory = expenseCategory.toUpperCase();
            UC_category = category.toUpperCase();
            return( UC_expCategory.equals(UC_category));
        }
        
        public boolean sameReceipt(String receipt)
        {
            return( this.receipt.equals(receipt));
        }
        
        public boolean sameExpenseDate(java.util.Date expenseDate)
        {
            return( this.expenseDate.equals(expenseDate));
        }
        
        public boolean sameXref(String expXref)
        {
            return( this.xref.equals(expXref));
        }
        
        public boolean isWeekend()
        {
            return(Utilities.isWeekend(expenseDate));
        }
        
        public int compareTo(Expense otherExp)
        {
            int result;
            switch (sortBy)
            {
                case BY_RECEIPTS:
                    result = receipt.compareTo(otherExp.receipt);
                    break;
                case BY_CATEGORY_EXPDATE_XREF:
                default:
                    if ((result = category.compareTo(otherExp.category)) == 0)
                        if ((result = expenseDate.compareTo(otherExp.expenseDate)) == 0)
                            result = xref.compareTo(otherExp.xref);
                    break;
            }
                    
            return (result);
        }
        
        public String getExpenseDetails(String amountFormat)
        {
            SimpleDateFormat formatter = new SimpleDateFormat ("MM/dd/yyyy");
            if (debug == false)
                return ("&nbsp;&nbsp;" + expenseType + "&nbsp;&nbsp;" +
                formatter.format(expenseDate) + "&nbsp;&nbsp;" + 
                Utilities.format(amountFormat, amount) + "<br>");
            else
                return ("    " + expenseType + "    " + 
                formatter.format(expenseDate) + "     " + 
                Utilities.format(amountFormat, amount)  + "    " + xref);
        }
        public String getSplitExpense()
        {
            double tranAmount = perSplit > 1 ? amount/perSplit : amount;
            SimpleDateFormat formatter = new SimpleDateFormat ("MM/dd/yyyy");
            if (debug == false)
                return ("&nbsp;&nbsp;" + expenseType + "&nbsp;&nbsp;" + formatter.format(expenseDate) +
                "&nbsp;&nbsp;" + Utilities.format("0.00", tranAmount) + "<br>");
            else
                return ("    " + expenseType + "    " + formatter.format(expenseDate) +
                "     " + Utilities.format("0.00", tranAmount) + "    " + xref);
        }
        
        public String getSplitDetails()
        {
            String result = "";
            
            if (perSplit > 1)
            {
                SimpleDateFormat formatter = new SimpleDateFormat ("MM/dd/yyyy");
                if (debug == false)
                    result += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +  formatter.format(expenseDate)+ "&nbsp;&nbsp;" + expenseType + 
                            "&nbsp;&nbsp;"+ Utilities.format("0.00", amount) + "&nbsp;&nbsp;" + perSplit + "&nbsp;people" +
                            "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;" + comment + "<br>";
                else                           
                    result += "          " +  formatter.format(expenseDate)+ "    " + expenseType + 
                            "    "+ Utilities.format("0.00", amount) + "    " + perSplit + " people" +
                            "\n          - " + comment + "\n";
            }
            
            return(result);
        }
    }
//End of Expense Class

    class compareExpenses implements Compare{
        public boolean lessThan(Object left, Object right) {
                return (((Expense) left).compareTo((Expense) right) < 0);
        }
        public boolean lessThanOrEqual(Object left, Object right) {
                return (((Expense) left).compareTo((Expense) right) <= 0);
        }
        
/* setup for selection sort        
        public int compareObjects(Object left, Object right) {
                return (((Expense) left).compareTo((Expense) right));
        }
 */               
    }
//End of compareExpenses class


    public String getPersNum()
    {
        return(header == null ? "" : header.getPersNum());
    }
     

    public String getCurrency()
    {
        return(header == null ? "" : header.getCurrency());
    }
     
    public String getReportExpenses()
    {
        return(myLang.getString("reportExpenses") + rptExpenses);
    }
    
    public Vector getReceiptExpenses(String receipt)
    {
      Vector expenses = new Vector();    
      int item = 0;
      
      while ((item < rptExpenses.size()) && 
                (((Expense) rptExpenses.elementAt(item)).sameReceipt(receipt) == false))
            item++;
            
      while ((item < rptExpenses.size()) && 
                (((Expense)(rptExpenses.elementAt(item))).sameReceipt(receipt) == true))
      {
            expenses.addElement(rptExpenses.elementAt(item));
            item++;
      }
      return(expenses);
    }
        
    public int findXref(String expenseXref)
    {
        int i = 0;
        while ( (i < purposes.size()) && 
               ((((Purpose) purposes.elementAt(i)).sameXref(expenseXref)) == false))
            i++;

            
        if (i >= purposes.size())
            i = -1;
            
        return(i);
    }
    public int findReceipt(String expenseXref)
    {
        int i = 0;
        while ( (i < receipts.size()) && 
               ((((Receipt) receipts.elementAt(i)).sameReceipt(expenseXref)) == false))
        {
            i++;
        }

        if (i >= receipts.size()) i = -1;
            
        return(i);
    }
    
    public int getNightsFromExpense(String expenseXref)
    {
        
        int nights = 0;
 
        int i = findXref(expenseXref);
        if (i != -1)
            nights = ((Purpose) purposes.elementAt(i)).getNights();

        return (nights);
    }
    
    
    public int getNightsFromReceipt(String receiptXref)
    {
       int nights = 0;
 
       int i = findReceipt(receiptXref);
       if (i != -1) nights = ((Receipt) receipts.elementAt(i)).getNights();
       return (nights);
    }
    
    
    public int getDays(String expenseXref)
    {
        int days = 0;
/*        
        int i = 0;
        while ( (i < purposes.size()) && 
               ((((Purpose) purposes.elementAt(i)).sameXref(expenseXref)) == false))
            i++;
            
        if (i < purposes.size())
        */
        
        int i = findXref(expenseXref);
        if (i != -1)
            days = ((Purpose) purposes.elementAt(i)).getDays();

        
        return (days);
    }
    public String getLocation(String expenseXref)
    {
        String location = null;
        
        int i = findXref(expenseXref);
        if (i != -1)
            location = ((Purpose) purposes.elementAt(i)).getLocation();

        return (location);
    }
    
    public void checkTOTAL(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        //skip over the none matching expense types
        int i = 0;
        double catTotal = 0;
        String categoryStatus = "pass";
        int startingExpenseItem = i;
  //format = true;      
        guidelineReport += formatCategoryHeader(category, myLang.getString("total"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
        while (i < rptExpenses.size())
        {
            catTotal += ((Expense) rptExpenses.elementAt(i)).getAmount();
            i++;
        } 
        categoryStatus = catTotal <= amount ? "pass" : "fail" ;
        if (catTotal > amount)
            guidelineStatus = "failed";
        
        // guidelineReport += formatExpenseItems(startingExpenseItem, i-1);
        guidelineReport += formatCategoryTrailer(myLang.getLabel("total")  + "&nbsp;", catTotal, 
                                        categoryStatus);
//format = false;                                        
    }
    
//    public void checkREPORT(String methodName, String category, double amount)
    public void checkREPORT(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        int i = 0;
//skip non matching expenses   

        while ((i < rptExpenses.size()) && (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == false))
            i++;   

        if (i < rptExpenses.size())
        {
            double catTotal = 0;
            String categoryStatus = "pass";
            int startingExpenseItem = i;
            
            guidelineReport += formatCategoryHeader(category, myLang.getString("report"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
            
            while ((i < rptExpenses.size())&& 
            (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category)== true))
            {
                catTotal += ((Expense) rptExpenses.elementAt(i)).getAmount();
                i++;
            }       
                    
            categoryStatus = catTotal <= amount ? "pass" : "fail" ;
            if (categoryStatus.equals("fail"))
                guidelineStatus = "failed";
                                        
            guidelineReport += formatExpenseItems(startingExpenseItem, i-1);
            guidelineReport += formatCategoryTrailer(myLang.getLabel("total") + "&nbsp;", catTotal, 
                                            myLang.getString(categoryStatus));
        }
    }
    
    public void checkDAILY(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        //skip over the none matching expense types
        int i = 0;
        while ((i < rptExpenses.size()) && (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == false))
            i++;   

        if (i < rptExpenses.size())
        {
            String categoryStatus = "pass";
            int startingExpenseItem = i;
            java.util.Date expenseDate = ((Expense) rptExpenses.elementAt(i)).getExpenseDate();
            double catTotal = 0;
            boolean weekEnd = false;
            
            while ((i < rptExpenses.size())&& 
            (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == true))
            {
                if (((Expense) rptExpenses.elementAt(i)).sameExpenseDate(expenseDate) == false)
                {
//get location amount                    

                    String loc = getLocation(((Expense) rptExpenses.elementAt(i-1)).getXref());
                    
                    if ((((Expense) rptExpenses.elementAt(i-1)).isWeekend()== true))
                    {
                        
                        amount = guideline.getWeekEndAmount(loc);
                        weekEnd = true;
                    }
                    else
                    {
                        amount = guideline.getAmount(loc);
                        weekEnd = false; 
                    }
                    categoryStatus = catTotal <= amount ? "pass" : "fail" ;
                    if (catTotal > amount)
                        guidelineStatus = "failed";
                        
                    String headerMsg;
                    if ((loc != null) && (loc.length() > 0))
                        headerMsg = loc + " Amount:&nbsp;";
                    else
                        headerMsg = myLang.getLabel("guidelineAmount") + "&nbsp;";
                        
                    if (weekEnd == true)
                        guidelineReport += formatCategoryHeader(category, myLang.getString("weekend"), headerMsg, amount);
                    else
                        guidelineReport += formatCategoryHeader(category, myLang.getString("daily"), headerMsg, amount);
                    guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                    guidelineReport += formatCategoryTrailer(myLang.getLabel("total") + "T&nbsp;", catTotal, 
                                                    myLang.getString(categoryStatus));
                    expenseDate = ((Expense) rptExpenses.elementAt(i)).getExpenseDate();
                    catTotal = 0;
                    startingExpenseItem = i;
                }
                        
                catTotal += ((Expense) rptExpenses.elementAt(i)).getPerPersonAmount();
                i++;
                                
            }       
            
            if (catTotal > 0)
            {
//get location amount                    
                String loc = getLocation(((Expense) rptExpenses.elementAt(i-1)).getXref());
                if ((((Expense) rptExpenses.elementAt(i-1)).isWeekend()== true))
                {
                    amount = guideline.getWeekEndAmount(loc);
                    weekEnd = true;
                }
                else {
                    amount = guideline.getAmount(loc);
                }     
                    
                
                categoryStatus = catTotal <= amount ? "pass" : "fail" ;
                if (catTotal > amount)
                    guidelineStatus = "failed";
                        
                String headerMsg;
                if ((loc != null) && (loc.length() > 0))
                    headerMsg = loc + " " + myLang.getLabel("amount") + "&nbsp;";
                else
                    headerMsg = myLang.getLabel("guidelineAmount") + "&nbsp;";
                        
                if (weekEnd == true)
                    guidelineReport += formatCategoryHeader(category, myLang.getString("weekend"), headerMsg, amount);
                else
                    guidelineReport += formatCategoryHeader(category, myLang.getString("daily"), headerMsg, amount);
                guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                guidelineReport += formatCategoryTrailer(myLang.getLabel("total") + "&nbsp;", catTotal, 
                		myLang.getString(categoryStatus));
            }
        }
    }
    
    public void checkNIGHTS(GuideObject guideline) {
        checkNIGHTS(guideline, true);
    }
    public void checkLODGING(GuideObject guideline) {
        checkNIGHTS(guideline, false);
    }
    
    public void checkNIGHTS(GuideObject guideline, boolean thruExpense)
    {
        String nightsType = thruExpense ? "NIGHTS" : "LODGING" ;;
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        //skip over the none matching expense types
        int i = 0;
        while ((i < rptExpenses.size()) && (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == false))
            i++;   
            
        if (i < rptExpenses.size())
        {
            String categoryStatus = "pass";
            int startingExpenseItem = i;
            String expenseXref = ((Expense) rptExpenses.elementAt(i)).getXref();
            String expenseReceipt = ((Expense) rptExpenses.elementAt(i)).getReceipt();
            double catTotal = 0;
            String thisLocation = getLocation(expenseXref);
            amount = guideline.getAmount(thisLocation);
            while ((i < rptExpenses.size())&& 
            (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == true))
            {
                if (((Expense) rptExpenses.elementAt(i)).sameXref(expenseXref) == false)
                {                                    
                    String loc = getLocation(((Expense) rptExpenses.elementAt(i-1)).getXref());
                    double avgNightRate= 0;
                    int nights;
                    if (thruExpense) 
                    {
                       nights = getNightsFromExpense(expenseXref);
                    } else
                    {
                       nights = getNightsFromReceipt(expenseReceipt);
                    }
                    
                    if (nights > 0)
                    {
                        avgNightRate= catTotal/nights;
                        categoryStatus = avgNightRate <= amount ? "pass" : "fail" ;
                    }
                    else
                        categoryStatus = "fail";
                      
                    if (categoryStatus.equals("fail"))
                        guidelineStatus = "failed";
                        
                    String headerMsg;
                    if ((loc != null) && (loc.length() > 0))
                        headerMsg = loc + " " + myLang.getLabel("amount") + "&nbsp;";
                    else
                        headerMsg = myLang.getLabel("guidelineAmount") + "&nbsp;";

                    guidelineReport += formatCategoryHeader(category, nightsType, headerMsg, amount);
                    guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                    guidelineReport += formatCategoryTrailer(myLang.getStringWithReplace("REPORT_AVERAGE_NIGHTS", "$nights$", Integer.toString(nights)) + ": ", avgNightRate,myLang.getString(categoryStatus));
                    expenseXref = ((Expense) rptExpenses.elementAt(i)).getXref();
                    expenseReceipt = ((Expense) rptExpenses.elementAt(i)).getReceipt();                    
                    amount = guideline.getAmount(getLocation(expenseXref));
                    catTotal = 0;
                    startingExpenseItem = i;
                }
                catTotal += ((Expense) rptExpenses.elementAt(i)).getPerPersonAmount();
                i++;
            }       
            if (catTotal > 0)
            {
//get location amount                    
                String loc = getLocation(((Expense) rptExpenses.elementAt(i-1)).getXref());
                double avgNightRate= 0;
                int nights;
                if (thruExpense) 
                {
                   nights = getNightsFromExpense(expenseXref);
                } else
                {
                   nights = getNightsFromReceipt(expenseReceipt);
                }
                if (nights > 0)
                {
                    avgNightRate= catTotal/nights;
                    categoryStatus = avgNightRate <= amount ? "pass" : "fail" ;
                }
                else
                    categoryStatus = "fail";
                    
                if (categoryStatus.equals("fail"))
                    guidelineStatus = "failed";
                                                
                String headerMsg;
                if ((loc != null) && (loc.length() > 0))
                    headerMsg = loc + " " + myLang.getLabel("Amount") + "&nbsp;";
                else
                    headerMsg = myLang.getLabel("guidelineAmount") + "&nbsp;";
                        
                guidelineReport += formatCategoryHeader(category, nightsType, headerMsg, amount);
                guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                guidelineReport += formatCategoryTrailer("Average Over "+nights+" nights:", avgNightRate, 
                		myLang.getString(categoryStatus));
AuditTrail.println("[---] ExpenseReport.getNights hd [2]: " + category + ", " + nightsType + ", " + headerMsg + ", " + Double.toString(amount));
            }
        }                        
    }
    
    public void checkDAYS(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        //skip over the none matching expense types
        int i = 0;
        while ((i < rptExpenses.size()) && (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == false))
            i++;   

        if (i < rptExpenses.size())
        {
            
            String categoryStatus = "pass";
            int startingExpenseItem = i;
            String expenseXref = ((Expense) rptExpenses.elementAt(i)).getXref();
            double catTotal = 0;
            amount = guideline.getAmount(getLocation(expenseXref));
                    
            while ((i < rptExpenses.size())&& 
            (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == true))
            {
                if (((Expense) rptExpenses.elementAt(i)).sameXref(expenseXref) == false)
                {                                    
                    double avgDayRate= 0;
                    int days = getDays(expenseXref);
                    if (days > 0)
                    {
                        avgDayRate= catTotal/days;
                        categoryStatus = avgDayRate <= amount ? "pass" : "fail" ;
                    }
                    else
                        categoryStatus = "fail";
                                        
                    if (categoryStatus.equals("Fail"))
                        guidelineStatus = "failed";
                                            
                    guidelineReport += formatCategoryHeader(category, myLang.getString("days"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
                    guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                    guidelineReport += formatCategoryTrailer(myLang.getStringWithReplace("REPORT_AVERAGE DAYS", "$days$", Integer.toString(days)) + ":", avgDayRate,myLang.getString(categoryStatus));
                    expenseXref = ((Expense) rptExpenses.elementAt(i)).getXref();
                    amount = guideline.getAmount(getLocation(expenseXref));
                    catTotal = 0;
                    startingExpenseItem = i;
                }
                catTotal += ((Expense) rptExpenses.elementAt(i)).getPerPersonAmount();
                i++;
            }       
                    
            if (catTotal > 0)
            {
                double avgDayRate= 0;
                int days = getDays(expenseXref);
                if (days > 0)
                {
                    avgDayRate= catTotal/days;
                    categoryStatus = avgDayRate <= amount ? "pass" : "fail" ;
                }
                else
                    categoryStatus = "failed";
                                            
                if (categoryStatus.equals("fail"))
                    guidelineStatus = "failed";
                                                
                guidelineReport += formatCategoryHeader(category, myLang.getString("days"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
                guidelineReport += formatSplitExpenseItems(startingExpenseItem, i-1);
                guidelineReport += formatCategoryTrailer(myLang.getStringWithReplace("REPORT_AVERAGE DAYS", "$days$", Integer.toString(days)) + ":", avgDayRate, 
                		myLang.getString(categoryStatus));
            }
        }                        
    }

    public void checkREIMBURSE(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        //skip over the none matching expense types
        int i = 0;
        double catTotal = 0;
        double reimburseAmount = 0;
        String categoryStatus = "pass";
        
        guidelineReport += formatCategoryHeader(category, myLang.getString("reimburse"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
        while (i < rptExpenses.size())
        {
            reimburseAmount = ((Expense) rptExpenses.elementAt(i)).getReimburse();
            if (reimburseAmount > 0)
            {
                catTotal += reimburseAmount;
                guidelineReport += formatExpenseItems(i, i);
            }
            i++;
        } 
        categoryStatus = catTotal <= amount ? "pass" : "pail" ;
        if (catTotal > amount)
            guidelineStatus = "failed";
        
        guidelineReport += formatCategoryTrailer(myLang.getLabel("total") + "&nbsp;", catTotal, 
        		myLang.getString(categoryStatus));
    }
    
    public void checkADVANCE(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        double amount = guideline.getAmount();
        int i = 0;
//skip non matching expenses   

        while ((i < rptExpenses.size()) && (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category) == false))
            i++;   

        if (i < rptExpenses.size())
        {
            double catTotal = 0;
            String categoryStatus = "pass";
            int startingExpenseItem = i;
            
            guidelineReport += formatCategoryHeader(category, myLang.getString("advance"), myLang.getLabel("guidelineAmount") + "&nbsp;", amount);
            
            while ((i < rptExpenses.size())&& 
            (((Expense) rptExpenses.elementAt(i)).sameExpenseCategory(category)== true))
            {
                catTotal += ((Expense) rptExpenses.elementAt(i)).getAmount();
                i++;
            }       
                    
            categoryStatus = catTotal <= amount ? "pass" : "fail" ;
            if (categoryStatus.equals("fail"))
                guidelineStatus = "failed";
                                        
            guidelineReport += formatExpenseItems(startingExpenseItem, i-1);
            guidelineReport += formatCategoryTrailer(myLang.getLabel("total") + "&nbsp;", catTotal, 
            		myLang.getString(categoryStatus));
        }
    }
    
    public void checkDATE(GuideObject guideline)
    {
        String methodName = guideline.getMethod();
        String category = guideline.getCategory();
        int guidelineDays = (int) guideline.getAmountNoRate();
        int i = 0;
//skip non matching expenses   

        String categoryStatus = "pass";
        int startingExpenseItem = i;
        int daysOld = 0;
        int itemsFound = 0;
        
        while (i < rptExpenses.size())
        {
            daysOld =  ((Expense) rptExpenses.elementAt(i)).getDaysOld();
                
            if (daysOld > guidelineDays)
            {
                categoryStatus = "fail" ;
                guidelineStatus = "failed";
                if (itemsFound == 0)
                    guidelineReport += formatCategoryHeader(category, myLang.getString("date"), myLang.getLabel("guidelineDaysOld") + "&nbsp;", guidelineDays);
                guidelineReport += formatExpenseItems(i, i);
                guidelineReport += formatCategoryTrailer(myLang.getLabel("rcptAge") + "&nbsp;", daysOld, 
                		myLang.getString(categoryStatus));
                itemsFound++;
            }
            i++;
        }       
        
    }
    
    public void checkMILEAGERATE(GuideObject guideline)
    {
        float rate = (float) 0.0;
        String effectiveDate = "";
        
        if (receipts.size() > 0)
        {
            SystemXML sysXML;
            
            if (DbaseURL.equals("") == true)
                sysXML = new SystemXML(dbConnection, sqlTerminator);
                
            else
                sysXML = new SystemXML(DbaseURL, DbaseUser, DbasePassword, sqlTerminator);
                
            Vector rateTable = sysXML.getMileageRates(guideline.getCompany()); 
            if (rateTable.size() > 0)
            {
                SimpleDateFormat formatter = new SimpleDateFormat ("MM/dd/yyyy");
                int i = 0;
                String categoryStatus = "passed";
                guidelineReport += myLang.getLabel("mileageRate");
                while (i < receipts.size())
                {
                   Receipt rcpt = (Receipt) receipts.get(i);
                   if (rcpt.isUnits("Miles") || rcpt.isUnits("Kilometers"))  //temporary sssssssssssssssssssssss
                   {
                        java.util.Date rDate = rcpt.getRcptDate();
                        if (personalRate != (float) 0.0) {
                            rate = personalRate;
                            effectiveDate = myLang.getString("personalRate");
                        } else {
                            rate = sysXML.getEffectiveRate(rDate);
                            effectiveDate = formatter.format(sysXML.getEffectiveDate());
                        }
                        float rcptRate = rcpt.getXrate();
                        if (rcptRate != rate) 
                        {
                            categoryStatus = "fail";
                            guidelineStatus = "failed";
                            
                            if (debug == true)
                                guidelineReport += "\n    " + myLang.getString("receiptDate") + "/" + myLang.getLabel("receiptDate") + " " + formatter.format(rDate) + " " + formatRate(rcptRate) + "   " +
                                  myLang.getLabel("guideline") + " " + effectiveDate + "   "+
                                  formatRate(rate) + "    " + myLang.getString("fail");
                            else
                                guidelineReport += "<br>&nbsp;&nbsp;&nbsp;&nbsp;"+ myLang.getString("receiptDate") + "/" + myLang.getLabel("rate") +"&nbsp;" + formatter.format(rDate) + "&nbsp;" + formatRate(rcptRate) + "&nbsp;&nbsp;&nbsp;" +
                                myLang.getLabel("guideline") + "&nbsp;" + effectiveDate + "&nbsp;&nbsp;&nbsp;"+
                                  formatRate(rate) + "&nbsp;&nbsp;&nbsp;&nbsp;" + myLang.getString("fail");
                        }
                   }
                   i++;
                }
                
                if (categoryStatus.equals("passed"))
                {
                    if (debug == true)
                        guidelineReport += "  " + myLang.getString("passed").toUpperCase();
                    else
                        guidelineReport += "&nbsp;&nbsp;&nbsp;" + myLang.getString("passed").toUpperCase();
                }
                if (debug == true)
                    guidelineReport += "\n\n";
                else
                    guidelineReport += "<br><br>\n";  //JH 2007-10-02
                
            }
        }
    }
        
    private String formatRate(float FFN)
    {
      String S = Float.toString(FFN) + "0000";
      return S.substring(0,S.indexOf(".")+ 5);
    }
        
    public String formatCategoryHeader(String category, String checkedMethod,  
                    String heading, double guidelineAmount)
    {
        if (format == true)
        {
        if (debug == false)
            return(category + "&nbsp;&nbsp;" + checkedMethod + "&nbsp;&nbsp;" +
                        heading + "&nbsp;&nbsp;" + Utilities.format("0.00", guidelineAmount) + "<br>");
        else                
            return(category + "  " + checkedMethod + "  " +
                        heading + "  " + Utilities.format("0.00", guidelineAmount) + "\n");
        }else return "";
    }
        
    public String formatExpenseItems(int startingExpenseItem, int endingExpenseItem)
    {
        String result = "";
       if (format == true)
       {
        for (int i = startingExpenseItem; i <= endingExpenseItem; i++)
            if (debug == false)
                result += ((Expense) rptExpenses.elementAt(i)).getExpenseDetails("0.00");
            else
                result += ((Expense) rptExpenses.elementAt(i)).getExpenseDetails("0.00") + "\n";
       }
    return(result);
    }
    
    public String formatSplitExpenseItems(int startingExpenseItem, int endingExpenseItem)
    {
        String result = "";
       if (format == true)
       {
        for (int i = startingExpenseItem; i <= endingExpenseItem; i++)
            if (debug == false)
                result += ((Expense) rptExpenses.elementAt(i)).getSplitExpense()  +
                        ((Expense) (rptExpenses.elementAt(i))).getSplitDetails();
            else
                result += ((Expense) rptExpenses.elementAt(i)).getSplitExpense()  + "\n" +
                        ((Expense) (rptExpenses.elementAt(i))).getSplitDetails() + "\n";
       }
    return(result);
    }
    
            
    public String formatCategoryTrailer(String heading, double total, String categoryStatus)
    {
        int leadingSpaces = 30-heading.length();
        String spaces = "";
        String roundedTotal = Utilities.format("0.00", total);
        if (format == true)
        {
        for (int i = 0; i < leadingSpaces; i++)
            if (debug == false)
                spaces += "&nbsp;";
            else
                spaces += " ";
        
        if (debug == false)
            return(spaces + heading + "&nbsp;&nbsp;"+
                    roundedTotal + "&nbsp;&nbsp;***&nbsp;&nbsp;"+ categoryStatus + "&nbsp;&nbsp;***<br><br>");
        else
           return(spaces + heading + "  "+
                    roundedTotal + "     ***  "+ categoryStatus + "  ***\n\n");
        }
        else return "";
    }
    
    
    public String getStatus()
    {
        return(guidelineStatus);
    }
    
    public boolean getBooleanStatus()
    {
        return(guidelineStatus.equals("passed"));
    }
    
    public String toString()
    {
//        if (guidelineReport.length() > 0)
           return (guidelineReport);
//        else
//            return("No guideline information to report.");
        
    }
    
    public String getTrim(String x) {
      if (x == null) return "";
      return x.trim();
    }

    private String unScramble(String X) {
      if (encrypt.equalsIgnoreCase("YES")) {
        X = Utilities.unScramble(X, encryptKey).trim(); 
      }
       return X;
    }
}
