/*
FileDataBaseUpdate.java - Updates database from text files - used in Email update of database  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.net.*;
import java.io.*;
//import java.util.*;

public class FileDataBaseUpdate implements Runnable {

// This class updates a database from a text file.
// it is run as a batch process

    private CommonFunctions F = new CommonFunctions();
    private AuditTrail Logfile = new AuditTrail();

    public void run () {

        ServerSystemTable SystemTable = new ServerSystemTable();
        String MailBox = SystemTable.getSystemString("INMAILBOX","C:/WORK");
        File MailDir = new File(MailBox);
        String[] FilesArray;
        int NumberOfFiles;
        int i;
        String ReturnString;
        int FirstReturn;


        FileTypeFilter OutTypeOfFile = new FileTypeFilter(".in");  //later get this from Audit
        FilesArray = MailDir.list(OutTypeOfFile);
        NumberOfFiles = FilesArray.length;

        MailBox = CommonFunctions.addSlash(MailBox);

        if(NumberOfFiles > 0) {

            for (i = 0; i < NumberOfFiles; i++ ) {

                try {
                    AuditTrail.println("[000] FileDataBaseUpdate: " + MailBox + FilesArray[i]);
                    ParsedTokenFile ThisFile = new ParsedTokenFile(MailBox + FilesArray[i]);
                } catch (IOException e) {
                    AuditTrail.println("[500] FileDataBaseUpdate:Error - Could not process: " + MailBox + FilesArray[i]);
                }
            }
            AuditTrail.println("[000] FileDataBaseUpdate: File - Database update complete.");
        } else {
            AuditTrail.println("[000] FileDataBaseUpdate: No messages in the inbox.");
        }
    }
}