/*
FileTypeFilter.java - used to select files with appropriate extensions  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;
//import java.util.*;

class FileTypeFilter implements FilenameFilter {
   private String filetype;

   public FileTypeFilter(String selectedType) {
// Use this function to set the filetype (extension) that will be checked for
        filetype = selectedType;
    }


   public boolean accept(File dir, String filename) {
// This method is used as a code block by the calling File object to produce
// a list of files that have the appropriate extension
        return (filename.endsWith(filetype));
   }
}