/*
GeneralCSVImport.java - simple mapping for an import
Copyright (C) 2006,2012 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

public class GeneralCSVImport extends ImportSave {
    // This interface is used for instantiating feeds in the EOD process
    
    private String postAction = "POST";

    public GeneralCSVImport() {
    }
    
    public void run() 
    {
        CustomDate CurrentDate = new CustomDate();
        
        AuditTrail.println("[000] GeneralCSVImport Import Method: " + getImportMethod());
        String[] rowSet;
        String[] superRowSet;
// Need to get the next two from the import.xml file
        
        setupFiles();
        
        printHTMLln("<HTML>");
        
        printHTMLln("<BODY>");
        
        printHTMLln("<h1>Import (CSV) Control Report</h1>");
        printHTMLln("Run Date: " + CustomDate.getExportDate(CurrentDate.getDate()));
        printHTMLln("As Of Date: " + CustomDate.getExportDate(StandardDate.getDate()));
        printHTMLln("Import Description File: " + importDescFile);
        printHTMLln("Import Method: " + importMethod);        
        printHTMLln("Import File Name: " + inputFileName);
        printHTMLln("Import Type: " + importType);        
        printHTMLln("Initial Row Type: " + rowType + "<br>");  
        
        setFixedColumnsAndValues(ImportControlDOM);       // All default stuff but setting  
        setColumnsWanted(setupExportDescription2Array()); // separate in case a routine would
        setAttributesWanted(setupAttribute2Array());      // like to substitute
                
        listWantedArrays("Rowset items",getColumnsWanted(), false);  //for logging and debug purposes
        listWantedArrays("Attributes",getAttributesWanted(), false);
        listWantedArrays("Super set",getSuperColumnNames(), true);
        printHTMLln("<br>");
        
        boolean xFound = setParser(); 
        int goodItems = 0;
        int badItems = 0;
        int testItems = 0;
        
        do { 

           rowSet = getRow();       
           
           listWantedArrays("Values before",rowSet, false);
           
           rowSet = adjust2InternalFormat(rowSet,getAttributesWanted());
           
           listWantedArrays("Values after",rowSet, false);
           listWantedArrays("Super values",getSuperColumnValues(rowSet),false);
           superRowSet = adjust4SuppliedDefaults(getSuperColumnValues(rowSet));
           listWantedArrays("Post values",superRowSet,true);
           
           if (postAction.equalsIgnoreCase("TEST"))
           {
              testItems = testItems + 1;    
           } else
           {
              if (db.setPersistance("INSERT",getTableName(),getSuperColumnNames(),superRowSet))
              {
                 printHTMLln("Item posted OK");
                 goodItems = goodItems + 1;
              } else
              {
                 printHTMLln("------ Item skipped ------");
                 badItems = badItems + 1;
              }
              //db.closeMyState();
              //db.closeResultSet();
           }
          
        } while (next());

        printHTMLln("Import process has ended normally");
        
        printHTMLln("Number of items imported: " + Integer.toString(goodItems));
        printHTMLln("Number of items skipped (investigate): " + Integer.toString(badItems));
        printHTMLln("Number of test items: " + Integer.toString(testItems));
        printHTMLln("Total items: " + Integer.toString(goodItems + badItems + testItems));
        printHTMLln("---End---");
        
        printHTMLln("</BODY>");
        
        printHTMLln("</HTML>");
        
    }
    
    public void listWantedArrays(String title, String[] AL, boolean printHTML)
    {
        String x = "";
        String delim = "";
        for (int i = 0; i < AL.length; i++)
        {
            x = x + delim + AL[i];
            delim = ", ";
        }
        AuditTrail.println("[000] GeneralCSVImport " + title + ": ["  + x + "]");
        if (printHTML) printHTMLln(title + ": "  + x);
    }
    
    public void printHTMLln(String x) {
        println(x + "<br>");
    }
    
    public void setAction(String x) {
        postAction = x;
    }
}