/*
GeneralJournal.java - Report on EOD G/L feed   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.io.*;
//import java.util.*; 
//import org.jdom.Document;
//import org.jdom.Element;
//import org.jdom.Attribute;
import java.sql.*;

import org.jdom.Element;


public class GeneralJournal extends ReportAPI {
    
    // This class is used to generate reports and feeds from the EOD process
    
    static AuditTrail Logfile;
    //private String importType = "EOD"; 
    //private String rowType = "row";
    //private String journalName = "SimpleGL.dat";
    /*
    Default position:
    0  RP_PERS_NUM
    1  RP_VOUCHER
    2  RP_NAME
    3  RP_DEPART
    4  RC_AMOUNT
    5  RC_ACCOUNT
    6  EX_AMOUNT
    7  EX_ACCOUNT
    8  EX_DEPART
    9  RP_UPDATE
    */
    protected String[] columnsWanted = {"RP_PERS_NUM","RP_VOUCHER","RP_NAME","RP_DEPART","RC_AMOUNT","RC_ACCOUNT","RC_COSTCENTER","EX_AMOUNT","EX_ACCOUNT","EX_DEPART","EX_COSTCENTER","RP_UP_DATE","EX_BILLTYPE","EX_EXPENSE","RC_CHARGE","PR_PROJECT","PR_CLIENTNO","PR_STEPNO","RP_COMPANY"};

    public GeneralJournal () 
    {
    }
    public void init(ess.AdisoftDOM sys, Connection x, String journal)
    {
        String system_file = sys.getDOMTableValueFor("configuration","xmlexport","C:\\WORK\\");
        super.setImportType(journal);
        initElement(system_file, importType, rowType);
        super.Sys = sys;

        Element xLine;
        DescribDOM = new AdisoftDOM();
        DescribDOM.setDOM(super.SystemFile); 
        
        AuditTrail.println("[000] GeneralJournal.init getMaskInput(): " + getMaskInput());
        xLine = DescribDOM.getElement(getMaskInput());

        setDelimitStr(xLine.getAttributeValue("delimiter"));
        AuditTrail.println("[000] GeneralJournal.init getDelimitStr(): " + getDelimitStr());

        setQuotes(xLine.getAttributeValue("quotes"));
        AuditTrail.println("[000] GeneralJournal.init getQuotes(): " + getQuotes());
        
        inputLine = xLine.getChild(maskRow);
        columnList = inputLine.getChildren();
         
        setJournalName(xLine.getAttributeValue("file"));
        AuditTrail.println("[000] GeneralJournal.init setJournalName(): " + getJournalName());
        if(inputFile(getJournalName()) == -1) AuditTrail.println("[400] GeneralJournal.init file opened failed");
    }

    public void init(ess.AdisoftDOM sys, Connection x)
    {
        String system_file = sys.getDOMTableValueFor("configuration","xmlexport","C:\\WORK\\"); 
        initElement(system_file, importType, rowType);
        super.Sys = sys;
        inputFile(journalName);
    }
    
    public void close()
    {
        AuditTrail.println("[000] GeneralJournal.close" );
        //this.println("End of file");
        //this.setClose();
    }
    
    public void setColumnsWanted(String[] x)
    {
        columnsWanted = x;
    }
    
    public String[] getRow()
    {
        return getRow(columnsWanted);
    }
    
    /*
    public void setRowType(String x)
    {
        rowType = x;
    }

    public void setImportType(String x)
    {
        importType = x;
    }

    public void setFileType(String x)
    {
        super.fileType = x;
    }
    */
    
}