/*
GeneralserImport.java - Mapped inport to user file
Copyright (C) 2010 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

public class GeneralUserImport extends ImportSave {
    // This interface is used for instantiating feeds in the EOD process
    
    private String postAction = "POST";

    public GeneralUserImport() {
    }
    
    public void run() 
    {
        CustomDate CurrentDate = new CustomDate();
        
        AuditTrail.println("[000] GeneralUserImport Import Method: " + getImportMethod());
        String[] rowSet;
        
// Need to get the next two from the import.xml file
        setEditName("user");
        setupFiles();
        

        // org.jdom.Element columns = getInputDescElement();
        org.jdom.Element columns = getTableSchema().getChild("columns");
        
        printHTMLln("<HTML>");
        
        printHTMLln("<BODY>");
        
        printHTMLln("<h1>User Import Control Report</h1>");
        printHTMLln("Run Date: " + CustomDate.getExportDate(CurrentDate.getDate()));
        printHTMLln("As Of Date: " + CustomDate.getExportDate(StandardDate.getDate()));
        printHTMLln("Import Description File: " + importDescFile);
        printHTMLln("Import Method: " + importMethod);        
        printHTMLln("Import File Name: " + inputFileName);
        printHTMLln("Import Type: " + importType);   
        printHTMLln("Import File Type: " + fileType);
        printHTMLln("Initial Row Type: " + rowType);  
        
        setFixedColumnsAndValues(ImportControlDOM);       // All default stuff but setting  
        setColumnsWanted(setupExportDescription2Array()); // separate in case a routine would
        setAttributesWanted(setupAttribute2Array());      // like to substitute
                
        listWantedArrays("Rowset items",getColumnsWanted(), false);  //for logging and debug purposes
        listWantedArrays("Attributes",getAttributesWanted(), false);
        listWantedArrays("Super set",getSuperColumnNames(), true);
        printHTMLln("");
        printHTMLln("");
        
        // boolean xFound = setParser(); 
        int goodItems = 0;
        int badItems = 0;
        int testItems = 0;
        
        java.util.List listOfKeys = rowKey.getChildren();
        org.jdom.Element keyMember = (org.jdom.Element) listOfKeys.get(0);  //Can only handle a simple key right now
        String keyName = keyMember.getName();
        
        printHTMLln("Initial Key Name: " + keyName);  
        printHTMLln("<br>");
        
        
        while (next()) {                                       // was: do {

           rowSet = getRow();       
           
           listWantedArrays("Values before",rowSet, false);
           
           rowSet = adjust2InternalFormat(rowSet,getAttributesWanted());
           
           listWantedArrays("Values after",rowSet, false);
           listWantedArrays("Super values",getSuperColumnValues(rowSet),false);
           listWantedArrays("Post values",adjust4SuppliedDefaults(getSuperColumnValues(rowSet)),true);
           
           if (postAction.equalsIgnoreCase("TEST"))
           {
              testItems = testItems + 1;    
           } else
           {
// if it exists I would probably want something like:
        	   /*
        	    * db.setSimple(getTableName(), rowKey, getVariableColumnValues()[0], getColumnesWanted() - less 0, getVariableColumnValues()- less 0);
        	    * after I check with something like =
        	    * db.setResultSet(getTableName(), rowKey, getVariableColumnValues()[0])
        	    */
        	  if (db.setResultSet(getTableName(), keyName , rowSet[0]))  //Checking for the record
        	  {
        		  // if( db.writeSimple(getTableName(), keyName , rowSet[0], getColumnsWanted(), rowSet))
        		  if( db.setUpdate("SIMPLESQL", getTableName(), rowKey, columns, db.getArrayList(getColumnsWanted(), rowSet)))
        		  {
                      printHTMLln("Update item posted OK");
                      goodItems = goodItems + 1;
        		  } else 
        		  {
                      printHTMLln("------ Update item skipped ------");
                      badItems = badItems + 1;
        		  }
        	  } else {
                if (db.setPersistance("INSERT",getTableName(),getSuperColumnNames(),adjust4SuppliedDefaults(getSuperColumnValues(rowSet))))
                {
                   printHTMLln("Insert item posted OK");
                   goodItems = goodItems + 1;
                } else
                {
                   printHTMLln("------ Insert item skipped ------");
                   badItems = badItems + 1;
                }
              }
              //db.closeMyState();
              //db.closeResultSet();
           }
          
        }     // was: } while (next()); 

        printHTMLln("Import process has ended normally");
        
        printHTMLln("Number of items imported: " + Integer.toString(goodItems));
        printHTMLln("Number of items skipped (investigate): " + Integer.toString(badItems));
        printHTMLln("Number of test items: " + Integer.toString(testItems));
        printHTMLln("Total items: " + Integer.toString(goodItems + badItems + testItems));
        printHTMLln("---End---");
        
        printHTMLln("</BODY>");
        
        printHTMLln("</HTML>");
        
    }
    
    public void listWantedArrays(String title, String[] AL, boolean printHTML)
    {
        String x = "";
        String delim = "";
        for (int i = 0; i < AL.length; i++)
        {
            x = x + delim + AL[i];
            delim = ", ";
        }
        AuditTrail.println("[000] GeneralUserImport " + title + ": ["  + x + "]");
        if (printHTML) printHTMLln(title + ": "  + x);
    }
    
    public void printHTMLln(String x) {
        println(x + "<br>");
    }
    
    public void setAction(String x) {
        postAction = x;
    }
}