/*
GeneralVerticalImport.java - mapping with record types incorporated
Copyright (C) 2006 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import org.jdom.Element;

public class GeneralVerticalImport extends ImportSave {
    // This interface is used for instantiating feeds in the EOD process
    
    private String postAction = "POST";

    public GeneralVerticalImport() {
    }
    
    public void run() 
    {
        CustomDate CurrentDate = new CustomDate();
        
        AuditTrail.println("[000] GeneralVerticalImport Import Method: " + getImportMethod());
        String[] rowSet;
        
// Need to get the next two from the import.xml file
        
        setupFiles();
        
        printHTMLln("<HTML>");
        
        printHTMLln("<BODY>");
        
        printHTMLln("<h1>Import (Vertical) Control Report</h1>");
        printHTMLln("Run Date: " + CustomDate.getExportDate(CurrentDate.getDate()));
        printHTMLln("As Of Date: " + CustomDate.getExportDate(StandardDate.getDate()));
        printHTMLln("Import Description File: " + importDescFile);
        printHTMLln("Import Method: " + importMethod);        
        printHTMLln("Import File Name: " + inputFileName);
        printHTMLln("Import Type: " + importType);        
        printHTMLln("Initial Row Type: " + rowType);  
        
        java.util.List addOnlyTheseList = getListFromControlFile("add");
        Element addOnlyThese = null;
        if (addOnlyTheseList.size() > 0)
        {
            addOnlyThese = (Element) addOnlyTheseList.get(0);
            printHTMLln("Add items only detected.");
        }    
        
        java.util.List work4NonPostables = getListFromControlFile("drop");
        Element dropTheseItems = null;
        if (work4NonPostables.size() > 0)
        {
            dropTheseItems = (Element) work4NonPostables.get(0);
            printHTMLln("Drop items detected.");
        }    
        setFixedColumnsAndValues(ImportControlDOM);       // All default stuff but setting  
        setColumnsWanted(setupExportDescription2Array()); // separate in case a routine would
        setAttributesWanted(setupAttribute2Array());      // like to substitute
                
        String recordTypeName = getFromControlFile("recordtype");
        String writeTriggerValue = getFromControlFile("writetrigger");
        
        java.util.List complexRowSet = getListFromControlFile("group");
                
        printHTMLln("Record Type Column: " + recordTypeName);        
        printHTMLln("Write Trigger Value: " + writeTriggerValue + "<br>");                 
                
        listWantedArrays("Rowset items",getColumnsWanted(), false);  //for logging and debug purposes
        listWantedArrays("Attributes",getAttributesWanted(), false);
        listWantedArrays("Fixed Columns",fixedColumnNames, true);
        
        String[] SuperNames = getSuperColumnNames(complexRowSet);
        listWantedArrays("Super Column Names",SuperNames, true);
        
        printHTMLln("<br>");
        
        boolean xFound = setParser(); 
        int goodItems = 0;
        int badItems = 0;
        int testItems = 0;
        int lineItems = 0;
        int skippedItems = 0;
        
        int updateReturn = 0;  // 1 post record, 0 OK, but no post, -1 error occurred
        
        String TriggerName = getFromControlFile("recordtype");
        String TriggerValue = getFromControlFile("writetrigger");
        int recordTypeIndex = getRowIndex(getColumnsWanted(), TriggerName);
        
        do 
        { 
           rowSet = getRow(); //We will need to change this for the complex one      
           
           //listWantedArrays("Rowset values:",rowSet, false);  //
           /*commented out just for now
           rowSet = adjust2InternalFormat(rowSet,getAttributesWanted());
           listWantedArrays("Values after",rowSet, false);
           */
           
           updateReturn = updateComplexRowSet(complexRowSet, getColumnsWanted(), rowSet, recordTypeIndex, TriggerValue);
           lineItems = lineItems + 1;
           
           if (updateReturn == 1)
           {
              if (postAction.equalsIgnoreCase("TEST"))
              {
                 testItems = testItems + 1;    
              } else
              {
                 if (checkItem(complexRowSet, addOnlyThese, dropTheseItems) == 0)
                 {
                    if (db.setPersistance("INSERT",getTableName(),SuperNames,adjust4SuppliedDefaults(getSuperColumnValues(complexRowSet))))
                    {
                       //printHTMLln("Item posted OK");
                       goodItems = goodItems + 1;
                    } else
                    {
                       listWantedArrays("Rowset values:",rowSet, true);
                       printHTMLln("--- Item skipped - post failed ---");
                       badItems = badItems + 1;
                    }
                 } else
                 {
                    // Remove from report at a later date when everything is always
                    // working fine.
                    listWantedArrays("Rowset values:",rowSet, true);
                    printHTMLln("- Item skipped - add/drop rule -");
                    skippedItems = skippedItems + 1;
                 }
              }
           }
          
        } while (next());

        printHTMLln("<br>Import process has ended normally");
        
        printHTMLln("Number of lines read: " + Integer.toString(lineItems));
        printHTMLln("Number of items imported: " + Integer.toString(goodItems));
        printHTMLln("Number of do-not-post items: " + Integer.toString(skippedItems));
        printHTMLln("Number of items skipped (investigate): " + Integer.toString(badItems));
        printHTMLln("Number of test items: " + Integer.toString(testItems));
        printHTMLln("Total items: " + Integer.toString(goodItems + badItems + skippedItems + testItems));
        printHTMLln("---End---");
        
        printHTMLln("</BODY>");
        
        printHTMLln("</HTML>");
        
    }
    
    public void listWantedArrays(String title, String[] AL, boolean printHTML)
    {
        String x = "";
        String delim = "";
        for (int i = 0; i < AL.length; i++)
        {
            x = x + delim + AL[i];
            delim = ", ";
        }
        AuditTrail.println("[000] GeneralVerticalImport " + title + ": ["  + x + "]");
        if (printHTML) printHTMLln(title + ": "  + x);
    }
    
    public void printHTMLln(String x) {
        println(x + "<br>");
    }
    
    public void setAction(String x) {
        postAction = x;
    }
    
    
    //adjust2InternalFormat(rowSet,getAttributesWanted());
    public int updateComplexRowSet( java.util.List complexRowSet, 
                                    String[] columnNames, 
                                    String[] rowSet, 
                                    int recordTypeIndex, 
                                    String TriggerValue)
    {
        int retVal = 0;
        Element record;
        Element column;
      
        String currentRecordType;
        String recordTypeWanted = rowSet[recordTypeIndex];
        String[] validColumns = getRecordElements(complexRowSet, recordTypeWanted);
        for (int i = 0; i < complexRowSet.size(); i++)
        {
           record = (Element) complexRowSet.get(i);
           currentRecordType = record.getAttributeValue("recordtype");
           if (currentRecordType.equalsIgnoreCase(recordTypeWanted))
           {
              for (int j = 0; j < columnNames.length; j++)
              {        
                  column = (Element) record.getChild(columnNames[j]);
                  if (column != null)
                  {
                     
                     column = column.setText(getSingleAdjValueForColumn(columnNames[j],rowSet[j]));
                  }
              }
              if (currentRecordType.equalsIgnoreCase(TriggerValue))
              {
                 retVal = 1;
              }
           }
        }
        return retVal; 
    }
    
    
    public int checkItem(java.util.List complexRowSet, Element addOnlyThese, Element dropTheseItems)
    {
        int retVal = 0;
        if (addOnlyThese != null) retVal = addItem(complexRowSet, addOnlyThese);
        if (dropTheseItems != null) retVal += dropItem(complexRowSet, dropTheseItems);
        return retVal;
    }
    public int addItem(java.util.List complexRowSet, Element addOnlyThese)
    {
        int retVal = 1;
        Element record;
        java.util.List columns;
        Element column;
        String columnName;
        Element addElement;
        String columnValue;
        String addValue;
        
        for (int i = 0; i < complexRowSet.size(); i++)
        {
           record = (Element) complexRowSet.get(i);
           columns = record.getChildren();
           for (int j = 0; j < columns.size(); j++)
           {        
              column = (Element) columns.get(j);
              columnName = column.getName();
              java.util.List elements2Add = addOnlyThese.getChildren(columnName);
              if (elements2Add.size() > 0) 
              {
                 for (int k = 0; k < elements2Add.size(); k++) {
                    addElement = (Element) elements2Add.get(k);  
                    columnValue = column.getText();
                    addValue = addElement.getText();
                    //printHTMLln("Comparing column " + columnValue + " to add " + addValue);
                    if (Utilities.equalStringsIgnoreCase(addValue,columnValue)) 
                    {
                        retVal = 0;
                        k = elements2Add.size();
                        j = columns.size();
                        i = complexRowSet.size();
                    }
                 }
              }
           }
        }
        //if (retVal == 1) printHTMLln("Item below skipped - not in add list -"); 
        return retVal; 
    }

    public int dropItem(java.util.List complexRowSet, Element dropTheseItems)
    {
        int retVal = 0;
        Element record;
        java.util.List columns;
        Element column;
        String columnName;
        Element dropElement;
        String columnValue;
        String dropValue;
        
        for (int i = 0; i < complexRowSet.size(); i++)
        {
           record = (Element) complexRowSet.get(i);
           columns = record.getChildren();
           for (int j = 0; j < columns.size(); j++)
           {        
              column = (Element) columns.get(j);
              columnName = column.getName();
              java.util.List elements2Drop = dropTheseItems.getChildren(columnName);
               
              if (elements2Drop.size() > 0) 
              {
                 for (int k = 0; k < elements2Drop.size(); k++) {
                   dropElement = (Element) elements2Drop.get(k);                    
                   columnValue = column.getText();
                   dropValue = dropElement.getText();
                   //printHTMLln("Comparing column " + columnValue + " to drop " + dropValue);                   
                   if (Utilities.equalStringsIgnoreCase(dropValue, columnValue)) 
                   {
                       retVal = 2;
                       k = elements2Drop.size();
                       j = columns.size();
                       i = complexRowSet.size();
                   }
                 }
              }
           }
        }
        //if (retVal == 2) printHTMLln("Item below skipped - in drop list -");
        return retVal; 
    }
   
}