/*
HTMLFile.java - used by objects to create HTML files for later viewing   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/



package ess;

import java.io.*;
//import java.util.*;

public class HTMLFile {

// This class is used to create HTML files for reporting viewing purposes

    private CustomDate dateRoutine = new CustomDate();
    private BufferedWriter FileHandle;           //Redefines FileHandle in OutputTextFile
    private int NumberOfInstances = 0;
    private OutputTextFile HTMLFile = new OutputTextFile();


    public HTMLFile() {          //used by apps
    }

    public HTMLFile(String UseLog) { 
        openHTMLFile(UseLog);
    }

    public void setHTMLFile(String UseLog) { 
        openHTMLFile(UseLog);
    }

    public void openHTMLFile(String NameOfTheFile) {
        if (NumberOfInstances == 0) {
            try {
                HTMLFile.createFileHandle(NameOfTheFile);
                NumberOfInstances++;
            } catch (IOException e) {
                System.out.println("Adisoft HTML file creation has failed (1)");
            }
        } else {
            NumberOfInstances++;
        }
    }

    public BufferedWriter getHandle() {
        return FileHandle;
    }


    public void println(String logEntry) {
        try {
            HTMLFile.write(logEntry + "\r\n");
        } catch (IOException e) {
            System.out.println("Adisoft HTML file creation has failed (2)");
        }
    }

    public void print(String logEntry) {
        try {
            HTMLFile.write(logEntry);
        } catch (IOException e) {
            System.out.println("Adisoft HTML file creation has failed (2)");
        }
    }
    public void printException(Exception ThisException) {

    // This method will be used to printout call information in the event of a controlled failure


    }


    public void close() {

    // Start here tomorrow...............

    }


}
