/*
IncrementDbase.java - Counter to increment referecne in the system table  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;
import java.sql.*;

public class IncrementDbase extends AdisoftDbase {
     
  static AuditTrail Logfile;  
     
  public IncrementDbase () {
    Logfile = new AuditTrail();
  }
        
  public synchronized int IncrementInDbase (Connection dbCon, String ColumnName, String TableName, String getSQLString, String putSQLString) {
    // int IntResult;
    // IntResult = ST.getSystemInt(ElementTag);
    // ST.putSystemInt(ElementTag, ++IntResult);
    // return IntResult;
    
    //To update "Expsys and the System tables.
    
    int intResult = 0;
    int checkResult = -1;
    int LockResponse = 0;
    String sqlString;
    
    this.dbCon = dbCon;
    setAutoCommit(false);        
    if (!sqlLockTable.equals("")){
       sqlString = SQLReplace(sqlLockTable, "$table$", TableName.trim());
       LockResponse = doSQLExecute(SQLReplace(sqlString, "$columnname$", ColumnName.trim()));
    }
    intResult = getSystemInt(ColumnName.trim(), getSQLString);
    putSystemInt(ColumnName.trim(), ++intResult, putSQLString);
    setCommit();  
    if (!sqlUnlockTable.equals("")){
       sqlString = SQLReplace(sqlUnlockTable, "$table$", TableName.trim()); 
       LockResponse = doSQLExecute(SQLReplace(sqlString, "$columnname$", ColumnName.trim()));  
    }
    setAutoCommit(true);
    return intResult;
  }
  
    public int getSystemInt(String ColumnName, String SQLString) {
    // This method gets a system string and converts it to an int.
        String StringResult = getSystemString(ColumnName, "-1", SQLString);
        Integer IntResult = new Integer(StringResult);
        return IntResult.intValue();
    }

    private String getSystemString(String ColumnName, String ColumnDefault, String SQLString) {
        String SQLCommand = "not defined";
        try {
            myState = dbCon.createStatement();
            SQLCommand = SQLString;
            //SQLCommand = "SELECT ELEMENT FROM " + updateTable + " WHERE RTRIM(TAG) = '" + ElementTag.toUpperCase() + "';";
            myResult = myState.executeQuery(SQLCommand);

            if (myResult.next()) {
                return myResult.getString(ColumnName).trim();
            } else {
                AuditTrail.println("[500] IncrementDbase.getSystemString Default for " + ColumnName + " used: " + ColumnDefault);
                AuditTrail.println("[500] " + SQLCommand);
                return ColumnDefault;
            }
        } catch (java.lang.Exception ex){
            ex.printStackTrace();
            AuditTrail.println("[500] IncrementDbase.getSystemString failed for : " + ColumnName);
            AuditTrail.println("[500] IncrementDbase.getSystemString Default for " + ColumnName + " used: " + ColumnDefault);
            AuditTrail.println("[500] " + SQLCommand);
            AuditTrail.println("[500] " + ex.toString());
            return ColumnDefault;
        }
    }
    
    public void putSystemInt(String ColumnName, int ColumnValue, String SQLString){
        Integer IntResult = new Integer(ColumnValue);
        putSystemString(ColumnName, IntResult.toString(), SQLString);
    }

    public void putSystemString(String ColumnName, String ColumnValue, String SQLString) {
    // Modified for only replacing a value from here - not insert like
    // ServerSystemTable and ExpSysTable
        int returnResult;
        Integer returnInteger;
        String SQLStatement = "SQL statement not yet constructed";
        try {
            SQLStatement = SQLReplace(SQLString, "$columnvalue$", ColumnValue.trim());
            SQLStatement = SQLReplace(SQLStatement, "$columnname$", ColumnName.trim());
            // SQLStatement = "UPDATE " + updateTable + " SET ELEMENT = '" + ElementValue + "' WHERE TAG = '" + ElementTag.toUpperCase() + "';";
            returnResult = doSQLExecute(SQLStatement);
            returnInteger = new Integer(returnResult);

            if (returnResult == 1) {
                AuditTrail.println("[000] IncrementInDbase.putSystemString succeeded: " + ColumnName + ", " + ColumnValue);
            } else {
                AuditTrail.println("[500] IncrementInDbase.putSystemString failed: " + ColumnName + ", " + ColumnValue + ", Error: " + returnInteger.toString());
            }
        } catch (java.lang.Exception ex){
            ex.printStackTrace();    //want to get this to the log file
            AuditTrail.println("[500] IncrementInDbase.putSystemString failed for " + ColumnName + ", value: " + ColumnValue);
            AuditTrail.println("[500] " + ex.toString());
            AuditTrail.println("[500] IncrementInDbase.putSystemString SQL: " + SQLStatement);
        }
        finally
        {
            closeMyState();
        }
    }

    
  
}
