/*
InputTextFile.java - reads in text files   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;
//import java.util.*;

// need to add a close() method
public class InputTextFile extends TextFile {

// This class represents the input file and provides some simple methods for accessing
// the contents of a sequential file.

    private BufferedReader FileHandle;  //used in TextFile class

    public void setFile(String InputTextFileName)throws IOException {
        createFileHandle(InputTextFileName);
    }

    public void createFileHandle(String InputTextFileName) throws IOException {

// This method creates a file handle which is necessary to reading the contents
// of the file.  Right now this is a standard method and not a contructor for the
// convenience of the "try" statement, but this may change as it makes the use of the
// object a little more difficult (ie, two steps en lieu of one).

        FileHandle = new BufferedReader(new InputStreamReader(new FileInputStream(InputTextFileName)));

    }

    public String readLine() throws IOException {

// This method is used to allow the standard readLine to be used.
// May want to make this the preferred method.

        return readString();
    }

    public String readString() throws IOException {

// This method reads a line into a string
// The read preforms to the next carridge return / line feed

        String bufferString;
        bufferString = FileHandle.readLine();
        return bufferString;

    }

    public String readChar() throws IOException {

// This reads a 1k buffer into a string, it passes along any embedded CR/LFs as
// part of the process.

        char[] buffer = new char[1024];
        String bufferString = null;
        int bufferlength;
        int i;
        Character charObject;
        // the read function will fill buffer and return the number
        // of characters to bufferlength
        bufferlength = FileHandle.read(buffer,0,1024);
        // a -1 means that the read had failed, if we do have characters
        // we will need to convert them to the string one at a time
        if (bufferlength != -1) {
            charObject = new Character(buffer[0]);
            bufferString = charObject.toString();
            for (i = 1; i < bufferlength; i++) {
                charObject = new Character(buffer[i]);
                bufferString = bufferString + charObject.toString();
            }
        } else {
            bufferString = null;
        }
        return bufferString;
    }
    public void setClose() throws IOException {
        FileHandle.close();
    }
    
    public static String readWholeFileAsString(String filePathandName) throws java.io.IOException{
    	return new String(readWholeFile(filePathandName));
    }
    
    public static byte[] readWholeFile(String filePathandName) throws java.io.IOException{
        byte[] buffer = new byte[(int) new File(filePathandName).length()];
        BufferedInputStream diskFile = null;
        try {
        	diskFile = new BufferedInputStream(new FileInputStream(filePathandName));
        	diskFile.read(buffer);
        } finally {
            if (diskFile != null) try { diskFile.close(); } catch (IOException e) { }   //ignore error
        }
        return buffer;
    }
}
