package ess;

import java.util.*; 
import java.io.*;

public class Language {
	
	  private ResourceBundle myLang;
	  
	  public Language () {
		  
	  }

	  public void setDefault(){
		  setLanguage("xyz");
	  }
	  
	  public void resetLanguage(String x) {
		  myLang = null;
		  setLanguage(x);
	  }
	  
	  public void resetLanguage(String x, String y) {
		  myLang = null;
		  setLanguage(x,y);
	  }
	  
	  public void setLanguage(String x){
		  if (myLang == null) {
			  Locale currentLocale = new Locale(x);
			  myLang = ResourceBundle.getBundle("ess", currentLocale);
		  }
	  }

	  public void setLanguage(String x, String y){
		  if (myLang == null) {
			  Locale currentLocale = new Locale(x, y);
			  myLang = ResourceBundle.getBundle("ess", currentLocale);
		  }
	  }

	  public String getString(String x){
		  if (myLang == null) setDefault();
		  try {
			  return myLang.getString(x);
//			  x = myLang.getString(x);
//			  String retString = new String(x.getBytes("UTF-8"),"ASCII");
//			  return retString;
		  } catch (MissingResourceException e) {
			  return "??" + x;
//		  } catch (UnsupportedEncodingException e) {
//			  return "!!" + x;
		  }
	  }
	  
	  public String getString(String x, String y){
		  return getDataString(x,y);
	  }


	  public String getDataString(String x){
		  if (myLang == null) setDefault();
		  try {
			  return myLang.getString(x);
		  } catch (MissingResourceException e) {
			  return x;
		  }
	  }
	  public String getDataString(String x, String y){
		  if (myLang == null) setDefault();
		  try {
			  return myLang.getString(x);
		  } catch (MissingResourceException e) {
			  return y;
		  }
	  }
	  
	  public String getLabel(String x){
		  return getString(x) + ":";
	  }
	  
	  public String getDataLabel(String x){
		  return getDataString(x) + ":";
	  }

      public String getColumnTitle(String x)  //May Use later on for Capitalization, etc.
      {
    	  return getString(x);
      }

      public String getDataTranslation(String x)  //Eliminates spaces.
      {
    	  return getDataString(getReplace(x," ","_"));
      }

      public String getButton(String x)  //May Use later on for Capitalization, etc.
      {
    	  return getString(x);
      }
      
      //
	  public String getStringWithReplace(String token, String atString, String replacement)
	  {
		  String retVal = getString(token);
		  return getReplace(retVal,atString,replacement);
	  }
	  
	  public String getReplaceToken(String x, String oldChar, String newChar) {
         return getReplace(x, oldChar, newChar);
	  }

	  
	  public String getReplace(String x, String oldChar, String newChar) 
	  {
	      int startLocate = 0;
	      int oldLength = oldChar.length();
	      int newLength = newChar.length();
	      
	      int locate = x.indexOf(oldChar, startLocate);
	      while (locate != -1) {
	          x = x.substring(0,locate) + newChar + x.substring(locate + oldLength);
	          startLocate = locate + newLength;
	          locate = x.indexOf(oldChar, startLocate);
	      }
	      return x;
	   }

}
