/*
MyWorld.java - determines who a manager can see for management reports 
Copyright (C) 2004,2007 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;
//import java.net.URL;

public class MyWorld
{
    static AuditTrail Logfile;
    AdisoftDbase db = new AdisoftDbase();
    private Connection dbConnection;
    String me = null;
    int approvalStatus = 0;
    final int OK = 0;
    private String SQL_Manager;
    private String SQL_Depart;
    private DepartmentTable depart;
    protected String sqlTerminator = ";";
    private AdisoftDOM schemaDOM = new AdisoftDOM(); //schema table
    
    java.util.ArrayList myWorld = new java.util.ArrayList();
    java.util.ArrayList notMyWorld = new java.util.ArrayList();
    
    boolean setupFlag = false;
    
    
 //need to use the connection stuff for this
    public MyWorld(String _me, Connection x, String sqlTerminator) {
        dbConnection = x;
        setConnection(x);
        depart = new DepartmentTable();
        depart.setConnection(x);
        setSQLStrings();
        setMe(_me);
        setupFlag = true;
    }
    
    public boolean isSetup()
    {
        return setupFlag;
    }
    
    public void setMe(String x)
    {
        me = x;  
        myWorld.clear();
        notMyWorld.clear();
        myWorld.add(me);
    }
    
    public MyWorld() {
        //used for a Javabean call
    }
    
    public void setConnection(Connection x) {
        dbConnection = x;
        db.setConnection(dbConnection);
    }
    
    public void setSQLTerminator(String X) {
        sqlTerminator = X;
        db.setSQLTerminator(sqlTerminator);
    }
    
    public void setUpFiles() {
        depart = new DepartmentTable();
        depart.setConnection(dbConnection);
        depart.setSQLTerminator(sqlTerminator);
        setSQLStrings();
        depart.setSQLStrings(SQL_Depart);
        setupFlag = true;
    }
        
    public void setSQLStrings() {
        //rewrite this for to do the SysTable SQL from this object
        ServerSystemTable SysTable = new ServerSystemTable();
        AdisoftDOM SystemDOM = new AdisoftDOM();
        SysTable.setConnection(dbConnection);
        SysTable.setSQLTerminator(sqlTerminator);
        String system_file = SysTable.getSystemString("XMLSYSTEM","C:\\WORK\\"); 
        java.io.File SystemFile = new java.io.File(system_file);
        SystemDOM.setDOM(SystemFile); 
        AuditTrail.println("[000] MyWorld.setSQLStrings from " + system_file);
        SQL_Manager = SystemDOM.getDOMTableValueFor("personneltable","whoismanager");
        SQL_Depart = SystemDOM.getDOMTableValueFor("departtable","departinfosql");
        //java.io.File schemaFile = new java.io.File(SysTable.getSystemString("XMLSCHEMA","C:\\WORK\\"));
        db.setSchemaTable(SysTable.getSystemString("XMLSCHEMA","C:\\WORK\\"));
        db.setColumns("USER");
    }     
        
    public boolean isInMyWorld (String them) {
        
        String zzz;
/*
AuditTrail.println("[---] MyWorld start");        
        for (int i = 0; i < myWorld.size(); i++) {
            zzz = (String) myWorld.get(i);
            AuditTrail.println("[---] MyWorld entry: " + zzz);
        }
        for (int i = 0; i < notMyWorld.size(); i++) {
            zzz = (String) notMyWorld.get(i);
            AuditTrail.println("[---] NotMyWorld entry: " + zzz);
        }
*/      
        boolean retVal = false;
// AuditTrail.println("[---] isInMyWorld entry: " + them);
        if ( index4Person(myWorld, them) > -1 )
        {
            retVal = true;
        } else if ( index4Person(notMyWorld, them) == -1 )
        {            
            String SQLCommand;
            java.util.ArrayList set = new java.util.ArrayList();
            boolean keepGoing = true;
            do {
                SQLCommand = db.repStr(SQL_Manager, "$persnum$", them);
                set.add(them);
// AuditTrail.println("[---] isInMyWorld array add: " + them);
                try {
                   if (db.setResultSet(SQLCommand))
                   {
                      them = db.getTrim(db.myResult.getString(db.getColumnName("MANAGER")));  
                      if ( index4Person(myWorld, them) > -1 )
                      {
                         addArrays(myWorld, set);
                         keepGoing = false;
                         retVal = true;
// AuditTrail.println("[---] isInMyWorld found: " + them);
                      } else if ( index4Person(myWorld, them) > -1 )
                      {
                         addArrays(notMyWorld, set);
                         keepGoing = false;
// AuditTrail.println("[---] isInMyWorld not found: " + them);
                      }
                   } else {
                       addArrays(notMyWorld, set);
                       keepGoing = false;
// AuditTrail.println("[---] isInMyWorld ran out: " + them);
                   }
                } catch (java.lang.NullPointerException ex) {
                  addArrays(notMyWorld, set);
                  AuditTrail.println("[400] MyWorld.isInMyWorld: no record for: " + them);
                  keepGoing = false;
                } catch (java.lang.Exception ex){
                  AuditTrail.println("[500] MyWorld.isInMyWorld: Error finding " + them);
                  AuditTrail.println("[500] MyWorld.SQL: " + SQLCommand);
                  AuditTrail.println("[500] MyWorld.Error: " + ex.toString());
                  ex.printStackTrace();
                  keepGoing = false;
                }
            } while (keepGoing);
        }
// AuditTrail.println("[---] MyWorld end");         
        return retVal;
    }
    
    private void addArrays(java.util.ArrayList master, java.util.ArrayList add)
    {
// AuditTrail.println("[---] addArrays");
        master.addAll(add);
    }
    
    private int index4Person (java.util.ArrayList x, String y) 
    {
        int retVal = -1;
        String z;
        for (int i = 0; i < x.size(); i++) 
        {
            z = (String) x.get(i); 
// AuditTrail.println("[---] index4Person comparing: " + y + " to: " + z);            
            if (z.equalsIgnoreCase(y))
            {
                retVal = i;
                i = x.size();
            }
        }
        return retVal;
    }
            
}