/*
OutputImageFile.java - Used to write out a text file   
Copyright (C) 2012 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;


public class OutputImageFile extends TextFile {
    private FileOutputStream FileHandle;
    private boolean writeStatus = false;

    public OutputImageFile() {
    }    
        
    public void createFileHandle(String OutputTextFileName) throws IOException {
        createFileHandle(OutputTextFileName, true);
    }
    
    public void setFile(String OutputTextFileName, boolean append) {
      try {
        createFileHandle(OutputTextFileName, append);
        writeStatus = true;
      } catch (IOException e) {
        e.printStackTrace();
        writeStatus = false;
      }  
    }

    public boolean getWriteStatus() {
      return writeStatus;
    }  

    public void createFileHandle(String OutputTextFileName, boolean append) throws IOException {
        FileHandle = new FileOutputStream(OutputTextFileName, append);
    }

    public void write(byte[] bufferArray) throws IOException {
    	
        int x;
        for (int i = 0; i < bufferArray.length; i++) {
        	x = (int) bufferArray[i] & 0x00ff ;
        	FileHandle.write(x);  
        }
        FileHandle.flush();
    }

    public void setClose() throws IOException {
        close();
    }    

    public void close() throws IOException {
        FileHandle.flush();
        FileHandle.close();                //defined in superclass
    }
    
    public boolean rename(String newFile, String oldFile)
    {
    	File new_file = new File(newFile);
    	File old_file = new File(oldFile);
    	boolean retVal = rename(new_file, old_file);
    	return retVal;
    }
    
    public boolean rename(File newFile, File oldFile)
    {
    	return oldFile.renameTo(newFile);
    }
}
