/*
OutputTextFile.java - Used to write out a text file   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;
//import java.util.*;

public class OutputTextFile extends TextFile {
    private BufferedWriter FileHandle;
    private boolean writeStatus = false;

    public OutputTextFile() {
    }    
        
    public void createFileHandle(String OutputTextFileName) throws IOException {
        createFileHandle(OutputTextFileName, true);
    }
    
    public void setFile(String OutputTextFileName, boolean append) {
      try {
        createFileHandle(OutputTextFileName, append);
        writeStatus = true;
      } catch (IOException e) {
        e.printStackTrace();
        writeStatus = false;
      }  
    }

    public void setFile(String OutputTextFileName, String bufferString) {
      try {
        createFileHandle(OutputTextFileName, false);
        write(bufferString);
        close();
        writeStatus = true;
      } catch (IOException e) {
        e.printStackTrace();
        writeStatus = false;
      }  
    }
    
    public boolean getWriteStatus() {
      return writeStatus;
    }  

    public void createFileHandle(String OutputTextFileName, boolean append) throws IOException {
        FileHandle = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(OutputTextFileName, append)));
    }

    public void writeln(String bufferString) throws IOException {
        FileHandle.write(bufferString,0, bufferString.length());
        FileHandle.newLine();
        FileHandle.flush();
     }

    public void write(String bufferString) throws IOException {
        FileHandle.write(bufferString,0, bufferString.length());
        FileHandle.flush();
    }
    
    public void setClose() throws IOException {
        close();
    }    

    public void close() throws IOException {
        FileHandle.flush();
        FileHandle.close();                //defined in superclass
    }
    
    public boolean rename(String newFile, String oldFile)
    {
    	File new_file = new File(newFile);
    	File old_file = new File(oldFile);
    	boolean retVal = rename(new_file, old_file);
    	return retVal;
    }
    
    public boolean rename(File newFile, File oldFile)
    {
    	return oldFile.renameTo(newFile);
    }
}
