/*
ParsedTokenFile.java - Parses a text based report message  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;
import java.util.*;

class ParsedTokenFile extends InputTextFile{
    private Vector FileVector;
    private String TextFileName;
    private CommonFunctions F = new CommonFunctions();
    private String Delimiter = "=";
    private AuditTrail Logfile = new AuditTrail();



    ParsedTokenFile (String InputTextFileName, String ThisDelimiter) throws IOException {

        Delimiter = ThisDelimiter;
        LoadVectorFromFile(InputTextFileName);
    }


    ParsedTokenFile (String InputTextFileName) throws IOException {

        LoadVectorFromFile(InputTextFileName);
    }

    private void LoadVectorFromFile(String InputTextFileName){
        String InputLine;
        String ReturnString;
        boolean LoopThruFile = true;    // This flag allows the loop to be cancelled
        String[] InputArray;
        String[] LastRealInputArray;
        int UpperArrayBound;
        String[] FileVectorElement = new String[2];

        TextFileName = InputTextFileName;
        FileVector = new Vector();
        try {
            createFileHandle(TextFileName);
            while (LoopThruFile && (InputLine = readString()) != null) {
                InputArray = CommonFunctions.parsDelimStr(CommonFunctions.normalizeString(InputLine), Delimiter);
                if (InputArray.length == 2) {
                    // later on may need to create a specialized parsDelimStr to only
                    // parse up to the first equal sign only.....
AuditTrail.println(InputArray[0] + " is " + InputArray[1]);    //Keep in for now - may be permanent.
                    FileVector.addElement(InputArray);
                    LastRealInputArray = InputArray;   //will use later to adjust the last element
                } else {
                    UpperArrayBound = FileVector.size() - 1;
                    if (UpperArrayBound >= 0) {
AuditTrail.println(InputLine);    //Keep in for now - may be permanent.
                        FileVectorElement = (String[]) FileVector.elementAt(UpperArrayBound);
                        FileVectorElement[1] = FileVectorElement[1] +  CommonFunctions.CRLF() + InputLine;  //Remove CRLF
                        FileVector.setElementAt(FileVectorElement, UpperArrayBound);
                    }
                }
            }
        }catch (IOException e) {
            AuditTrail.println("[400] End of file detected: " + TextFileName);
        }
    }

    public void makePermanent() {



    }
}
