/*
PersonnelSession.java - Used in the app server to ID the connected user  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import javax.servlet.http.*;
//
//  This object extends PersonnelTable, which extended AdisoftDBase, to provide
//  online functionality implemented by HttpSessonBindingListener

public class PersonnelSession extends PersonnelTable implements javax.servlet.http.HttpSessionBindingListener {
//
//  instance variables of event are:
//  java.lang.String event.getName()
//  HttpSession event.getSession()
//
   private java.util.Vector imagesViewed = new java.util.Vector(); 	
   
   private String reportViewed;
	
   public void valueBound(javax.servlet.http.HttpSessionBindingEvent event) {
   }
   
   public void valueUnbound(javax.servlet.http.HttpSessionBindingEvent event) {
      AuditTrail.println("[222] PersonnelSession.valueUnbound Automatic logoff for: " + email);
      try {
        
    	 javax.servlet.http.HttpSession thisSession = event.getSession();
         AuditTrail.println("[223] PersonnelSession.valueUnbound Automatic logoff session: " + thisSession.getId());
         AuditTrail.setRemoveUsers(thisSession.getId());
         AuditTrail.setRemoveReports(thisSession.getId());
         
         resetProfile();
         close();
         
      } catch (java.lang.NullPointerException e) {
         AuditTrail.println("[400] PersonnelSession.valueUnbound NullPointerException caught");
      } catch (java.lang.Exception e) {
         AuditTrail.println("[500] PersonnelSession.valueUnbound unknown error");
         e.printStackTrace();
      }
   }
   
   public void setImagesViewed()
   {
	   imagesViewed.clear();
   }
   
   public void addImage(String x)
   {
	   imagesViewed.add(x);
   }
   
   public String getImageString()
   {
	   return imagesViewed.toString();
   }
   
   public void setReportViewed(String x)
   {
	   reportViewed = x;
   }
   public String getReportViewed()
   {
	   return reportViewed;
   }
 
}