/*
Register.java - interface to the Register table
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;

public class Register extends AdisoftDbase {

// Need to add the methodology of opening up a new message file for each rpt.
//
 
    public final int OWNER = 0;
    public final int XMLFILE = OWNER + 1;
    public final int STATUS = XMLFILE + 1;
    public final int MESSAGE = STATUS + 1;
    public final int XREF = MESSAGE + 1;
    public final int REFERENCE = XREF + 1;
    public final int REPDATE = REFERENCE + 1;
//    private ServerSystemTable SystemTable;
    private AuditTrail AuditLog = new AuditTrail();
//    private String smtp_address;
    private String[] tags = {"OWNER","XMLFILE","STATUS","MESSAGE","XREF","REFERENCE","REPDATE"};
    private String[] values = {"ADISOFT","","Copy","","","",""};
   
    public Register()
    {
//caller needs to call setDB().        
//        SystemTable = new ServerSystemTable();
//        smtp_address = SystemTable.getSystemString("SMTP_ADDRESS","192.168.0.21");
    }
    
    public Register(String DBUrl, String DBUser, String DBPassword)
    {
        setDB(DBUrl, DBUser, DBPassword);
    }
    
    public Register(Connection x) {
    	setConnection(x);
    }
    
    public void setOwner(String owner)
    {
        values[OWNER] = owner.toUpperCase();
    }
    
    public void setEmailFileName(String emailFileName)
    {
        values[XMLFILE] = emailFileName;
    }
    
    public void setStatus(String status)
    {
        values[STATUS] = status;
    }
    
    public void setMessage(String message)
    {
        values[MESSAGE] = message;
    }
    
    public void setXMLReference(String XMLReference)
    {
        values[XREF] = XMLReference;
    }
    
    public void setReportDate(String ReportDate)
    {
        values[REPDATE] = ReportDate;
    }
    
    public void setReference(String reference)
    {
        values[REFERENCE] = reference;
    }
    
    public void setTags(String[] tags)
    {
        this.tags = tags;
    }
    
    public void setValues(String[] values) 
    {
        this.values = values;
    }
    
    public String getOwner()
    {
        return(values[OWNER]);
    }
    
    public String getEmailFileName()
    {
        return(values[XMLFILE]);
    }
    
    public String getStatus()
    {
        return(values[STATUS]);
    }
    
    public String getMessage()
    {
        return(values[MESSAGE]);
    }
    
    public String getXMLReference()
    {
        return(values[XREF]);
    }
    
    public String getReference()
    {
        return(values[REFERENCE]);
    }
    
    public String[] getTags()
    {
        return(tags);
    }
    
    public String[] getValues() 
    {
        return(values);
    }
    public void updateColumn(String reference, String tag, String newValue)
    {
        String[] tags = {tag};
        String[] values = {newValue};
        setSimple(REFERENCE,reference, tags, values);
    }
    
    public void setSimple(String[] elementTags, String[] elementValues) {
    //The key here is the first member of the ElementTags array    
       setSimple("REGISTER", elementTags[0], elementValues[0], elementTags, elementValues);
    }
  
    public void setSimple(int keyTag, String KeyValue, String[] elementTags, String[] elementValues)
    {
        setSimple("REGISTER", tags[keyTag], KeyValue, elementTags, elementValues);
    }
    public void setSimple(int keyTag, String KeyValue)
    {
        setSimple("REGISTER", tags[keyTag], KeyValue, tags, values);
    }
    
}



    
