/*
Report2Client.java - Translated a report DOM to a set arrays to load to browser   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

import org.jdom.Element;
import org.jdom.Document;

public class Report2Client {

  private ess.AuditTrail Logfile = new ess.AuditTrail();  
  private String Header = "";
  private String Purposes = "";
  private String Receipts = "";
  private String DBase = "";
  //private AdisoftDOM debugDOM = new AdisoftDOM();
  private String dateFormatStr = "MM/dd/yyyy";
  private String numberFormatStr = "period";
  private String decimalStr = ".";
  private String separatorStr = ",";
  private String currentDateFormat = "MM/dd/yyyy";
  private String currentNumberFormat = ".";
  private String currentSeparator = ",";
  private String[] dateCheckArray = {"credate","subdate","recdate","rcptdate","cre_date","xdate","begdate","expdate","enddate"};
  private String[] numberCheckArray = {"reamt","rcamt","adamt","phyrec","amount","recamt","xrate","weight"};
  private CustomDate cdate = new CustomDate();
  
  
  public Report2Client () {
  }
  public Report2Client (Document RegisterDOM) {
    setReportStrings(RegisterDOM);
  }  
  
  public void setDateFormat(String x) {
	  dateFormatStr = x;
  }
  
  public void setDecimal(String x) {
	  decimalStr = x;
	  if (x.equals(",")) {
		  numberFormatStr = "comma";
	  } else {
		  numberFormatStr = "period";
	  }

  }
  public void setSeparator(String x) {
	  separatorStr = x;
  }
  
  public void setDateCheckArray(String[] x)  {
      dateCheckArray = x;
  }
  
  public void setNumberCheckArray(String[] x)  {
	  numberCheckArray = x;  
  }
  
  public void setReportStrings (AdisoftDOM RegisterDOM) {
	  ess.AuditTrail.println("[000] Report2Client.setReportString (before): " + RegisterDOM.toString());
	  //Element Navigate = RegisterDOM.getDOM().getRootElement();
	  //Navigate = Navigate.getChild("report");
	  AdisoftDOM headerCheck = new AdisoftDOM();
	  headerCheck.setDOM(RegisterDOM.getReportDOM());
	  String reportDateFormat = headerCheck.getDOMTableValueFor("header","dateformat");
	  RegisterDOM.setThirdLevelInfo("report","header","dateformat",dateFormatStr);
	  String reportNumberFormat = headerCheck.getDOMTableValueFor("header","numberformat");
	  RegisterDOM.setThirdLevelInfo("report","header","numberformat",numberFormatStr);
	  if ((reportDateFormat) != null && (reportDateFormat.length() > 0)) currentDateFormat = reportDateFormat;
	  if ((reportNumberFormat) != null && (reportNumberFormat.length() > 0)) {
		  if (reportNumberFormat.equalsIgnoreCase("comma")) {
			  currentNumberFormat = ",";
		  } else {
			  currentNumberFormat = ".";
		  }
	  }
	  ess.AuditTrail.println("[000] currentDateFormat: " + currentDateFormat);
	  ess.AuditTrail.println("[000] dateFormatStr: " + dateFormatStr);
	  if (!dateFormatStr.equals(currentDateFormat)) {
		  ess.AuditTrail.println("[000] detecting date conversion is necessay");
		  cdate.setUserDateFormat(dateFormatStr);
		  ConvertDate ExecuteDate = new ConvertDate();
		  RegisterDOM.performAgainstDOM(ExecuteDate); 
	  }
	  if (!decimalStr.equals(currentNumberFormat)) {
		  currentSeparator = decimalStr;
		  ConvertNumber ExecuteNumber = new ConvertNumber();
		  RegisterDOM.performAgainstDOM(ExecuteNumber);
	  }
	  ess.AuditTrail.println("[000] Report2Client.setReportString (after):: " + RegisterDOM.toString());
	  
	  setReportStrings(RegisterDOM.getDOM(), "report");
  }
  
  public class ConvertDate extends ess.AdisoftTreeAPI4DOM{
       public ConvertDate() {
    	   
       }
	   public void doMethod(Element CurrentElement) {
	        String EleName = CurrentElement.getName();
	        for (int i = 0; i < dateCheckArray.length; i++) {
	        	if (dateCheckArray[i].equals(EleName))
	        	{
		        	ess.AuditTrail.println("[000] check: " + dateCheckArray[i] + " equals " + EleName);
	               CurrentElement.setText(cdate.getStrFromDate(cdate.getDateFromStr(CurrentElement.getTextTrim(), currentDateFormat), dateFormatStr));
	               ess.AuditTrail.println("[000] new date: " + CurrentElement.getText());
	               i = dateCheckArray.length;
	        	}
	        }
	   }
  }	   
	 
  public class ConvertNumber extends ess.AdisoftTreeAPI4DOM{
       public ConvertNumber() {
   	   
       }
	   public void doMethod(Element CurrentElement) {
	        String EleName = CurrentElement.getName();
	        for (int i = 0; i < numberCheckArray.length; i++) {
	        	if (numberCheckArray[i].equals(EleName))
	        	{
	      	      String x = CurrentElement.getText();  
	    	      x = Utilities.replaceStr(x,currentSeparator,"");
	              CurrentElement.setText(Utilities.replaceStr(x,currentNumberFormat,decimalStr)); 
	              AuditTrail.println("[000] Report2Client.ConvertNumber: " + CurrentElement.getText());
	        	}
	        }
	   }
  }
  
  public void setReportStrings (Document RegisterDOM) {  //Should be deprecated/used by legacy JSPs
     setReportStrings(RegisterDOM, "report");
  }
  
  public void setReportStrings (Document RegisterDOM, String TopElementName) {
    
    Element Navigate = RegisterDOM.getRootElement();
    Navigate = Navigate.getChild(TopElementName);
    java.util.List ReportElements = Navigate.getChildren();
    
    Header = "[";   //initializing the beginnings
    Purposes = "[";
    Receipts = "[";
    
    String PurposeComma = "";
    String ReceiptComma = "";
    
    for (int i = 0; i < ReportElements.size(); i++) {
      Element Entry = (Element) ReportElements.get(i);
      String EntryClass = Entry.getName();
      if (EntryClass.equals("header")) {
          Header = Header + setChildren(Entry.getChildren()) ;
      } else if (EntryClass.equals("purpose")) {
          Purposes = Purposes + PurposeComma + "[\"" + Entry.getAttribute("type").getValue() + "\",[" + setChildren(Entry.getChildren()) + "]]";
          PurposeComma = ",";
      } else if (EntryClass.equals("receipt")) {
          Receipts = Receipts + ReceiptComma + "[\"" + Entry.getAttribute("type").getValue() + "\",[" + setChildren(Entry.getChildren()) + "]]";
          ReceiptComma = ",";
      } else {
        AuditTrail.println("[500] Report2Client.setReportStrings invalid entry class " + EntryClass + " in " + TopElementName);
      }  
    }
    Header = Header + "]";   
    Purposes = Purposes + "]";
    Receipts = Receipts + "]";
    
    AuditTrail.println("[000] Report2Client.setReportStrings Header: " + Header);
    AuditTrail.println("[000] Report2Client.setReportStrings Purposes: " + Purposes);
    AuditTrail.println("[000] Report2Client.setReportStrings Receipts: " + Receipts);
  }
  
  public void setDBString(Document RegisterDOM) {
    Element DB = RegisterDOM.getRootElement();
    //Logfile.println("[000] Report2Client.setDBString: " + RegisterDOM.toString());
    java.util.List DBaseElements = DB.getChildren();   
    DBase = "[";
    DBase = DBase + setChildren(DBaseElements) ;
    DBase = DBase + "]";   
  }
 
 
  private String setChildren(java.util.List Children) {
    java.util.List DBaseElements;
    String ReturnString = "";
    String Comma = "";
    for (int i = 0; i < Children.size(); i++) {
      Element CE = (Element) Children.get(i);
//      if (CE.getTextNormalize().length() != 0 || (CE.getContentSize() > 0)) {
      if (CE.getContentSize() > 0) {
        ReturnString += Comma + "[\"" + ess.CommonFunctions.restoreSpace(CE.getName()) + "\""; 
        if (CE.getTextNormalize().length() != 0) {
// Possible place for a conversion of dates and amounts.        	
          ReturnString += ",\"" + repStr(CE.getText()) + "\"" ;  //was getTextNormalize() before - added repStr 4/2/2009
        }
//        if (CE.getContentSize() > 0) {
//          java.util.List DBaseElements = CE.getChildren();
//          ReturnString += ",[" + setChildren(DBaseElements) + "]";
//        }  
        DBaseElements = CE.getChildren();
        if (DBaseElements.size() > 0) {
          ReturnString += ",[" + setChildren(DBaseElements) + "]";
        }  
        ReturnString += "]";
        Comma = ",";
      }
    }
    return ReturnString;
  }
 
  /*
  private String setChildren(java.util.List Children) {
    String ReturnString = "";
    String Comma = "";
    for (int i = 0; i < Children.size(); i++) {
      Element CE = (Element) Children.get(i);
      if (CE.getTextNormalize().length() != 0 || (CE.getContentSize() > 0)) {
        ReturnString += Comma + "[\"" + ess.CommonFunctions.restoreSpace(CE.getName()) + "\""; 
        if (CE.getTextNormalize().length() != 0) {
          ReturnString += ",\"" + repStr(CE.getText()) + "\"" ;  //was getTextNormalize() before
        }
        if (CE.getContentSize() > 0) {
          java.util.List DBaseElements = CE.getChildren();
          ReturnString += ",[" + setChildren(DBaseElements) + "]";
        }  
        ReturnString += "]";
        Comma = ",";
      }
    }
    return ReturnString;
  }
  */
  public String getHeader() {
    return Header;
  }  
  public String getPurposes() {
    return Purposes;
  }  
  public String getReceipts() {
    return Receipts;
  } 
  public String getDBase() {
    return DBase;
  }
  
  public static String repStr(String x) {
  //    x = repStr(x, "\"","'");
  //    x = repStr(x, "\\","\\\\"); // was "&#92"
  //    x = repStr(x, "\n","\\n");  // was "&#10;"
  //    x = repStr(x, "\r","");
      x = repStr(x, "\"","'");
      x = repStr(x, "\\","\\\\"); // was "&#92"
      x = repStr(x, "\n","\\n");  // was "&#10;"
      x = repStr(x, "\r","");

      return x; 
  }
   
  public static String repStr(String x, String oldChar, String newChar) 
  {
      int startLocate = 0;
      int oldLength = oldChar.length();
      int newLength = newChar.length();
      
      int locate = x.indexOf(oldChar, startLocate);
      while (locate != -1) {
          x = x.substring(0,locate) + newChar + x.substring(locate + oldLength);
          startLocate = locate + newLength;
          locate = x.indexOf(oldChar, startLocate);
      }
      return x;
  }
  
} //End of Report2Client Class