/*
ReportAPI.java - template for EOD reports   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.io.*;
//import java.util.*; 
//import org.jdom.Document;
import org.jdom.Element;
//import org.jdom.Attribute;
//import java.sql.*;


public abstract class ReportAPI extends FeedAPI {
    // This class is used instantiating feeds in the EOD process
    static AuditTrail Logfile;
    private OutputTextFile outFile = new OutputTextFile();
    private InputTextFile inputFile = new InputTextFile();
    java.util.StringTokenizer pool;    //used to hold the items before they go into the Element
    protected String[] newPool;
    
    protected String importType = "Prepopulated"; //points to major element in importDescFile
    protected String rowType = "row";    //points to the row name under the major element
    protected String journalName = "SimpleGL.dat";
    
    // Element inputLine; //Element used to retreive whatever column you want.  // These are located in FeedAPI

    // ess.AdisoftDOM DescribDOM;   //Should be in the FeedAPI.java
    
    // java.util.List columnList;    // These are located in FeedAPI
    // java.util.List dateList;
    // java.util.List numberList;
    // java.util.List logicList;
    
    // java.io.File SystemFile;  //Should be in the FeedAPI.java
    // String maskInput;   //Should be in the FeedAPI.java
    // String maskRow;     //Should be in the FeedAPI.java
    
    public void post(PersonnelTable p, Report r)
    {
    }
    
    protected int inputFileFullPath(String fileName)
    {
        //want to put in logic for 
        int retVal = 0;
        try {
            inputFile.setFile(fileName);
            AuditTrail.println("[000] ReportAPI.inputFileFullPath (1) input file: " + fileName);
        } catch (IOException e) {
            AuditTrail.println("[000] ReportAPI.inputFileFullPath (1) cannot open: " + fileName);
            retVal = -1;
        }
        return retVal;
    }
    
    protected int inputFile(String fileName)
    {
        //want to put in logic for 
        int retVal = 0;
        fileName = Sys.getDOMTableValueFor("endofday","folder","") + fileName;
        try {
            inputFile.setFile(fileName);
            AuditTrail.println("[000] ReportAPI.inputFile (1) input file: " + fileName);
        } catch (IOException e) {
            AuditTrail.println("[000] ReportAPI.inputFile (1) cannot open: " + fileName);
            retVal = -1;
        }
        return retVal;
    }
    
    protected int inputFile(String fileName, String pathName)
    {
        //want to put in logic for 
        int retVal = 0;
        int lastChar = pathName.length() - 1;
        if (pathName.substring(lastChar).equals("/") && pathName.substring(lastChar).equals("\\"))
            pathName = pathName + "/";
        fileName = pathName + fileName;
        try {
            inputFile.setFile(fileName);
            AuditTrail.println("[000] ReportAPI.inputFile (2) input file: " + fileName);            
        } catch (IOException e) {
            AuditTrail.println("[000] ReportAPI.inputFile (2) cannot open: " + fileName);
            retVal = -1;
        }
        return retVal;
    }
    
    protected int outputFile(String fileName)
    {
        //want to put in logic for 
        int retVal = 0;
        fileName = Sys.getDOMTableValueFor("endofday","folder","") + fileName;
        outFile.setFile(fileName, false);
        if (outFile.getWriteStatus())
        { 
            AuditTrail.println("[000] ReportAPI.openFile - Opened: " + fileName);
        } else {
            AuditTrail.println("[500] ReportAPI.openFile - Error: " + fileName);
            retVal = -1;
        }
        return retVal;
    }
    public void setClose()
    {
        try {
            outFile.setClose();
            AuditTrail.println("[000] ReportAPI.setClose (outFile) - OK");
        } catch (IOException e) {
            AuditTrail.println("[500] ReportAPI.setClose (outFile) - IO Error");
        } catch (Exception e) {
            AuditTrail.println("[500] ReportAPI.setClose (outFile) - General Error");
        }
        try {
            inputFile.setClose();
            AuditTrail.println("[000] ReportAPI.setClose (inputFile) - OK");
        } catch (IOException e) {
            AuditTrail.println("[500] ReportAPI.setClose (inputFile) - IO Error");
        } catch (Exception e) {
            AuditTrail.println("[500] ReportAPI.setClose (inputFile) - General Error");
        }
    }
    

    public void setRowType(String x)
    {
        if (x != null) rowType = x;
    }

    public void setImportType(String x)
    {
    	if (x != null)
    	{
    		importType = x;
    		setMaskInput(x);  //JH 2006-07-08
    	}
    }

    public void setJournalName(String x)
    {
    	if (x != null)
    	{
    		CustomDate y = new CustomDate();
    		journalName = Utilities.replaceStr(x, "$date$", CustomDate.getExportDate(y.getDate()) + CustomDate.getNachaTime(y.getDate()));
    	}
    }
        
    public String getJournalName()
    {
    	return journalName;
    }
    
    public boolean next()
    {
        return setParser();
    }
    
    public boolean setParser()
    {
        boolean retVal = false;
        try {

            String x = inputFile.readLine();

            if (x == null)
            {
               retVal = false; 
            } else if (fileType.toUpperCase().equals("DELIMITED"))
            {
               AuditTrail.println("[000] ReportAPI.setParser delimited: " + x); 
               retVal = setParserDelimited(x);
            } else if (fileType.toUpperCase().equals("SDF"))
            {
               AuditTrail.println("[000] ReportAPI.setParser sdf: " + x);
               retVal = setParserSDF(x);
            } else 
            { 
               AuditTrail.println("[500] ReportAPI.setParser type error: " + fileType); 
               retVal = false;
            }
        } catch (java.io.IOException e)
        {
            retVal = false;
        }
        return retVal;
    }    
    
    private boolean setParserDelimited(String x) 
    {
        boolean retVal = false;
        if (x != null)
        {
        	AuditTrail.println("[000] ReportAPI.setParserDemlimited delimitstr: " + delimitStr);
           pool = new java.util.StringTokenizer(x, delimitStr, false);  //was hardcoded to ","
           newPool = x.split(delimitStr);    //was just ";"  Jim Holton 2012-01-23
           if (pool.countTokens() < 1) 
           {
              retVal = false;
              AuditTrail.println("[400] ReportAPI.setParserDemlimited no tokens found.");              
           } else {
              retVal = setElement();
           }
        }
        return retVal;
    }
    
    private boolean setParserSDF(String x) 
    {
        boolean retVal = true;
        Element z;
        String token;
        
        setupElement();   //Seems inefficient - review this one after Linko jh 2011-04-03.
        
        int y = columnList.size();
        
        int start;
        int length;
        
        for (int i = 0; i < y; i++)
        {
           z = (Element) columnList.get(i);
           
           //Logfile.println("[---] " + z.getName() + ", " + z.getAttributeValue("position"));            
           
           start = Integer.parseInt(z.getAttributeValue("position"));
           length = Integer.parseInt(z.getAttributeValue("length"));
           
           token = x.substring(start - 1, length + (start-1));
           //Logfile.println("[---] " + token);
           
           z.setText(token);
        }
        return retVal;
    }
    
    
    public void initElement(String system_file, String inputMask, String row)
    {
          AuditTrail.println("[000] ReportAPI.initElement: " + system_file + ", " + inputMask + ", " + row);
          super.SystemFile = new java.io.File(system_file);
          setMaskInput(inputMask);
          setMaskRow(row);
          DescribDOM = new AdisoftDOM();
          DescribDOM.setDOM(super.SystemFile); 

    }

    public void setupElement()  //See also init in the GeneralJournal
    {          
          Element xLine;
          DescribDOM = new AdisoftDOM();  //this is very inefficient - need to redo jh
          DescribDOM.setDOM(super.SystemFile); 
          
          AuditTrail.println("[000] ReportAPI.setupElement getMaskInput(): " + getMaskInput());
          xLine = DescribDOM.getElement(getMaskInput());

          //setDelimitStr(xLine.getAttributeValue("delimiter"));
          AuditTrail.println("[000] ReportAPI.setupElement getDelimitStr(): " + getDelimitStr());

          //setQuotes(xLine.getAttributeValue("quotes"));
          AuditTrail.println("[000] ReportAPI.setupElement getQuotes(): " + getQuotes());
          
          inputLine = xLine.getChild(maskRow);
          columnList = inputLine.getChildren();
           
    }
    
    private boolean setElement()
    {
        boolean retVal = true;
        Element z;
        String token;
        
        setupElement();   //seems very inefficient - look into this after Linko finish jh 2011-04-03
        
        // int x = pool.countTokens();
        int x = newPool.length;
        int y = columnList.size();
        for (int i = 0; i < y; i++)
        {
           if (i < x)
           {
              // token = pool.nextToken();
        	   token = newPool[i];
              Logfile.println("[000] ReportAPI.setElement getting Token: " + token);                  
           } else {
              token = "";
              Logfile.println("[000] ReportAPI.setElement blank token ");                  
           }
           z = (Element) columnList.get(i);
           z.setText(token);
        }
        return retVal;
    }
    
    public String[] getRow(String[] names, boolean doTrim)  
    {
        Element z;
        String x;
        String[] retValues = new String[names.length];
        for (int i = 0; i < names.length; i++) 
        {
            z = DescribDOM.singleElement(names[i],columnList);
            x = z.getText();
            if (doTrim) x = x.trim();
            retValues[i] = x;
            Logfile.println("[000] ReportAPI.getRow token value: " + x); 
        }
        return retValues;
    }
    
    public String[] getRow(String[] names)  
    {
        return getRow(names, false);
    }
}