/*
ReportContainer.java - Used to store/retrieve reports in the register container   
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;
import org.jdom.Document;
import org.jdom.Element;


public class ReportContainer extends RegisterContainer {
    //Consider implementing an interace for the Save/Submit jsp and the getReport jsp

    private ServerSystemTable SystemTable = new ServerSystemTable();
    static AuditTrail AuditLog;
    private java.util.Date date = new java.util.Date();
    private String Owner = "Adisoft";
    private String Status = "New";
    String RegisterFileName = "Invalid";
    private String Last_Refer = "";
    private String DBUrl = "";
    private String DBUser = "";
    private String DBPassword = "";
    private String comment = "";
    private String repDate = date.toGMTString();
    
    public void setDB(String Url, String User, String Password) {
       DBUser = User;
       DBPassword = Password;
       setDB(Url);
    }
 
    public void setDB(String Url) {
       DBUrl = Url;
       SystemTable.setDB(Url, DBUser, DBPassword);
       SystemTable.setSQLTerminator(super.sqlTerminator);
    }
    
    public void setConnection(Connection dbConn) {
       SystemTable.setConnection(dbConn);
       SystemTable.setSQLTerminator(super.sqlTerminator);
    }
    
    public void setSQLTerminator(String x) {
        super.setSQLTerminator(x);
        SystemTable.setSQLTerminator(super.sqlTerminator);
    }
    
    public ReportContainer() {  //blank constructor
    }    
    
    public void setOwner(String setString) {
        String FileType = "xml";
        Owner = setString;
        RegisterFileName = SystemTable.getSystemString("xml_folder","C:\\WORK\\")+ Owner + "." + FileType;
        super.setKey("reference");
        super.setContainer(RegisterFileName);
    }
    
    public void setComment(String setString) {
        comment = setString;
    }
    
    public void setReportDate(String setString) {
        repDate = setString;
    }
    
    public void setStatus(String setString) {
        AuditTrail.println("[000] ReportContainer.setStatus set to " + setString);
        Status = setString;
    }    
    public String getStatus() {
      return Status;
    }
    
    public String getLastReference() {
      return Last_Refer;
    }  
    
    public void setDocument(Document Message) {
        
    }
    
    public String getXML(String reg_dbase, String ownersName, String referenceNumber)
    {
        String FileType = "xml";
        Owner = ownersName;
        RegisterFileName = reg_dbase + Owner + "." + FileType;
        super.setKey("reference");
        super.setContainer(RegisterFileName);
        return super.getReportString(referenceNumber);
    }

    public void setXMLFile(String MessageText) {
      boolean foundFlag = true;        
      String Reference = SystemTable.getSystemString("MESSAGE_SEQUENCE", "0");
      String Dup_reference_value = "X";
      String SQLCommand;
      while (foundFlag && !Reference.equals(Dup_reference_value))
      {
        Dup_reference_value = Reference;
        Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");
        SQLCommand = "SELECT * FROM REGISTER WHERE REFERENCE = '" + Reference + "'" + super.getSQLTerminator();
//        SQLCommand = "SELECT * FROM REGISTER WHERE RTRIM(REFERENCE) = '" + Reference.trim() + "'" + super.getSQLTerminator();
        foundFlag = SystemTable.setResultSet(SQLCommand);
      }
      if (Reference.equals(Dup_reference_value))
      {
        AuditTrail.println("[500] ReportContainer.setXMLFile Problem - Invalid Reference number generation.");
        outputXML(MessageText, Reference, "Problem");
      } else {
        outputXML(MessageText, Reference, Status);
      }
    }

    public void setXMLFile(String MessageText, String Reference) {
      if (Reference.equals("")) {
        setXMLFile(MessageText);
      } else {
        outputXML(MessageText, Reference, Status);
      }
    }

    private void outputXML(String MessageText, String Reference, String xStatus) {

       
       
       String FileName = Reference;
       String SaveFileName = Reference;
       AdisoftDOM workingDOM = new AdisoftDOM();
              
       String Item2Save = "";
       Status = xStatus;
       Last_Refer = "";
       String message = "Expense report saved";
       if (!comment.equals("")) message = comment;
       if (message.length() > 60) message = message.substring(0, 60);
       String[] Tags = {"OWNER","XMLFILE","STATUS","MESSAGE","REVIEWER","XREF","REPDATE","REFERENCE","REPORTER","THEIR_REF","AMOUNT"};
       String[] Values = {SystemTable.str(AdisoftDbase.repStr(Owner.toUpperCase()),60),SystemTable.str(FileName,60),SystemTable.str(Status,20),SystemTable.str(AdisoftDbase.repStr(message),60)," "," ",SystemTable.str(repDate,40),SystemTable.str(Reference,16)," "," "," "};
       Values[5] = setXref(FileName.toUpperCase());

       AuditTrail.println("[000] ReportContainer.outputXML in " + RegisterFileName + ": " + Reference);
            
       Item2Save += "<register>";
       Item2Save += "<reference>" + Reference + "</reference>";
       Item2Save += "<status>" + Status + "</status>";
       Item2Save += "<file>" + SaveFileName + "</file>";
       Item2Save += MessageText;
       Item2Save += "</register>";
       //Write to the container here
       workingDOM.setDOM(Item2Save);
       Element workingElement = (Element) workingDOM.getDOM().getRootElement().detach();
       if (super.update(workingElement))
       {
         super.persist();
         AuditTrail.println("[200] ReportContainer.outputXML file saved:" + RegisterFileName + ": " + Reference);
         SystemTable.setSimple("REGISTER","REFERENCE",Reference, Tags, Values);
       } else {
         AuditTrail.println("[500] ReportContainer.outputXML failed to update:" + RegisterFileName + ": " + Reference);
         SystemTable.setSimple("REGISTER","REFERENCE",Reference, Tags, Values);
       }
       Last_Refer = Reference;
    }
    
    public boolean registerXML(String MessageText, String Reference, String xStatus) {
       System.out.println("registerXML accessed");
       boolean retVal = false;
       String FileName = Reference;
       String SaveFileName = Reference;
       AdisoftDOM workingDOM = new AdisoftDOM();
              
       String Item2Save = "";
       Status = xStatus;
       Last_Refer = "";
       //Need to check for an empty Reference here and then assign the next
            
       System.out.println("registerXML has been called");     
       Item2Save += "<register>";
       Item2Save += "<reference>" + Reference + "</reference>";
       Item2Save += "<status>" + Status + "</status>";
       Item2Save += "<file>" + SaveFileName + "</file>";
       Item2Save += MessageText;
       Item2Save += "</register>";
       //Write to the container here
       workingDOM.setDOM(Item2Save);
       Element workingElement = (Element) workingDOM.getDOM().getRootElement().detach();
       if (super.updateNoEscape(workingElement))
       {
         super.persist();
         retVal = true;
       }
       Last_Refer = Reference;
       return retVal;
    }
    
    
    
    public String setXref(String X) {
       String xref = "00000000" + X.toUpperCase();
       String alternatePrefix = SystemTable.getSystemString("alternateprefix","A");
       xref = alternatePrefix + xref.substring(xref.length() - 7);
       return xref;
    }
    
    public void setRegister(String Ref){
       setRegister(Ref, repDate);
    }
    
    public void setRegisterWithThrRef(String Ref, String ThrRef) {
       String[] Tags = {"STATUS","REPDATE","THEIR_REF"};
       String[] Values = {Status,repDate,ThrRef};
       AuditTrail.println("[250] ReportContainer.setRegister:" + Ref + " Status:" + Status + " Voucher:" + ThrRef + " Date:" + repDate);
       SystemTable.setSimple("REGISTER","REFERENCE",Ref, Tags, Values);
    }
    
    
    public void setRegister(String Ref, String reportDate){
       String[] Tags = {"STATUS","REPDATE"};
       String[] Values = {Status,reportDate};
       AuditTrail.println("[251] ReportContainer.setRegister:" + Ref + " " + reportDate);
       SystemTable.setSimple("REGISTER","REFERENCE",Ref, Tags, Values);
    }
}
