/*
RouteTo.java - interface for workflow message routing  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

//import java.io.*;
//import java.util.*;
import java.sql.*;
//import org.jdom.Document;


public interface RouteTo
{   
    public void init(String DBUrl, String DBUser, String DBPassword, String SQLTerminator);
    public void init(Connection DBConnection, String SQLTerminator);
    public String getEmailAddress(String persNum);
/**
searchs and returns the desired emailAddress. The search rules are implementation dependend.
Not all input parameters are required by all implementation

@param String persNum - submitter's personnel number.
@param String chargedDepart - department that the report was charged to.
@param String limitRequired - if true, check the limit amount against the reportAmount.
@param String reportAmount - requrired field if limitRequired is true.
@param String adminSigned - personnel number of the admin that had already signed this report. 
                            Should contain a empty not (null)string if no admin had signed the report yet. 
                            
@param String signed1 - personnel number of the manager that had already signed this report. 
                            Should contain a empty not (null)string if no admin had signed the report yet. 
                            
@param String signed2 - personnel number of the second manager that had already signed this report. 
                            Should contain a empty not (null)string if no admin had signed the report yet. 

@return the email address found based on the information provided in the parameter list.
*/
    public String getEmailAddress(String persNum, String duplicateSignatureOK, 
    		        String chargedDepart, String chargedCompany, String limitRequired, 
    		        String reportAmount, String adminSigned, String signed1, 
    		        String signed2, boolean atLeastOnce);

    public String getRouteToPersNum();
    public void setCurrencyConversion(double multiplier);
    
}
