/*
SMTPSingle.java - Send a single SMTP message  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

//import java.net.*;
import java.io.*;
//import java.util.*;

public class SMTPSingle extends POP3andSMTP {

// This is an extension of the POP3andSMTP object that specializes in doing an SMTP message upload to
// text file in batch mode.  It is written for multithreading


// This static object also exists in the parent object but I used it here just to keep
// the code more readable and modular - don't know if this makes sense, the jury's out
    //private CommonFunctions F = new CommonFunctions();
    //private AuditTrail Logfile = new AuditTrail();
    private String mimeSendType = "body=8BITMIME";  //other value is "attachment"

    private String contentType = "text/plain; charset=utf-8";
    private String mimeVersion = "Version 1.0";
    
    private String nameDelimiter = ".";
    private String nameDomain = "adisoft-inc.com";
    
    private String subjectLine = "Expense Report";

    public SMTPSingle() {
    	// was public void SMTPSingle() {
    	    }    

    public SMTPSingle(String Message) {
    	// was public boolean SMTPSingle(String Message) {
    	boolean x = setSMTPMessage(Message);
        // was return setSMTPMessage(Message);
    	}    

    public boolean setSMTPMessage (String Message) {
        String rcpt_to = "expense@adisoft-inc.com";
        String from_address = "palserver@adisoft-inc.com";
        boolean retValue =  putSMTPMessage(Message, rcpt_to, from_address);
        return retValue;
    }
    public boolean setSMTPMessage (String Message, String rcpt_to, String from_address) {
        boolean retValue =  putSMTPMessage(Message, rcpt_to, from_address);
        return retValue;
    }
    
    public void setDelimiter(String x) {
        nameDelimiter = x;
    }
    
    public void setDomain(String x) {
        nameDomain = x;
    }
      
    public void setPort(String x) {
        super.SMTPPort = Integer.valueOf(x);
    }

    public void setSubject(String x) {
        subjectLine = x;
    }
    
    public void setMimeSendType(String x) {   //deprecated
        mimeSendType = x;
    }
    public void setMessageBodyType(String x) {
        mimeSendType = x;
    }
 
    public void setContentType(String x) {
        contentType = x;
    }
    public void setMimeVersion(String x) {
        mimeVersion = x;
    }

    private boolean putSMTPMessage (String Message, String rcpt_to, String from_address) {

        String ReturnString;
        int FirstReturn;
        boolean status = false;
        if (outSocketSMTP() == true)        //later on will have to get parameter from the param file stuff
        {
            int x = normalAddress(from_address).indexOf("@");
            String domain = from_address.substring(x + 1);
     
            try 
            {
                ReturnString = read();  //need to make somekind of time out parameter
                FirstReturn = ReturnString.indexOf(13);
                if (FirstReturn == -1) {
                    AuditTrail.println("[002] " + ReturnString);
                } else {
                    AuditTrail.println("[002] " + ReturnString.substring(0,FirstReturn));
                }
                if (writeAndReply("helo " + domain) == true)
                {
                    rcpt_to = normalAddress(rcpt_to);
                    from_address = normalAddress(from_address);
                    if (mimeSendType.equals("attachment")) {
                        status = uploadAttachment(Message, rcpt_to, from_address);    
                    } else {   
                        status = uploadMessageFile(Message, rcpt_to, from_address);
                    }
                } else {
                    AuditTrail.println("[500] SMTPSingle.putSMTPMessage SMTP server is not responding properly");
                }
                writeAndReply("quit");
                //ReturnString = read();
            } catch (IOException e) {
                AuditTrail.println("[500] SMTPSingle.putSMTPMessage got i/o error. Possible network problem or invalid data.");
            } catch (StringIndexOutOfBoundsException e) {
                AuditTrail.println("[500] SMTPSingle.putSMTPMessage did not receive SMTP Banner. Line maybe down.");
            }
            finally
            {
                close();
            }
        }
        return status;
    }

    private boolean uploadMessageFile(String UploadMessage, String Rcpt2, String From) {
        java.util.Date MsgDate = new java.util.Date();
        // return uploadMessageFile(UploadMessage, Rcpt2, From, MsgDate.toLocaleString());
        return uploadMessageFile(UploadMessage, Rcpt2, From, MsgDate.toGMTString());        
    }    

    private boolean uploadAttachment(String UploadMessage, String Rcpt2, String From) {
        java.util.Date MsgDate = new java.util.Date();
        // return uploadAttachment(UploadMessage, Rcpt2, From, MsgDate.toLocaleString());
        return uploadAttachment(UploadMessage, Rcpt2, From, MsgDate.toGMTString());
    }    


    public boolean uploadMessageFile(String UploadMessage, String Rcpt2, String From, String MsgDate) {
        //InputTextFile Message = new InputTextFile();
        //String InputLine;
        //String ReturnString;
        //boolean LoopThruFile = true;    // Flag that signifies
        //boolean DotFlag = false;        // Signifies that a message has ended and won't continue until next
        boolean status = false;
        String mailFrom = "mail from:" + "<" + From + ">";
// Might want to rewrite this to require a return on all sends except those within
// the DATA . function instead of it's current positive checking for
// specific commands.
// Need to make allowances for mime and attachments

// Added spaces after colons....4/28/2003 JH
        try {
        	if (!mimeSendType.equals("body")){
        	 mailFrom = mailFrom + " " + mimeSendType;
        	}
            if (writeAndReply(mailFrom))
            if (writeAndReply("rcpt to:" + "<" + Rcpt2 + ">"))
            if (writeAndReply("data"))
            {
                doWrite("From: " + From);
                doWrite("To: " + Rcpt2);
                doWrite("Date: " + MsgDate);
                doWrite("Subject: " + subjectLine);
                if (!contentType.equals("")) doWrite("Content-Type: " + contentType);
                if (!mimeVersion.equals("")) doWrite("MIME-Version: " + mimeVersion);
                doWrite("");
                doWrite(UploadMessage);
                status = writeAndReply(".");
            }    
            if (status == false)
                AuditTrail.println("[500] SMTPSingle.UpLoadMsgFile: doWrite() failed.");
        }catch (IOException e) {
            AuditTrail.println("[500] SMTPSingle.UpLoadMsgFile failed to send message.");
        }
        return status;
    }
    
    public boolean uploadAttachment(String UploadMessage, String Rcpt2, String From, String MsgDate) {
        //InputTextFile Message = new InputTextFile();
        //String InputLine;
        //String ReturnString;
        final String mimeBreak = "------------060508060900020409000101"; 
        //boolean LoopThruFile = true;    // Flag that signifies
        //boolean DotFlag = false;        // Signifies that a message has ended and won't continue until next
        boolean status = false;

        try {
            if (writeAndReply("mail from:" + From))
            if (writeAndReply("rcpt to:" +Rcpt2))
            if (writeAndReply("data"))
            {
                doWrite("From:" + From);
                doWrite("To:" + Rcpt2);
                doWrite("Date: " + MsgDate);
                doWrite("MIME-Version: 1.0");
                doWrite("Subject:Expense Report");
                doWrite("Content-Type: multipart/mixed; boundry=" + mimeBreak);
                doWrite("");
                doWrite("");
                doWrite("This is a multi-part message in MIME format.");
                doWrite(mimeBreak);
                doWrite("Content-Type: text/plain; charset=us-ascii; format=flowed ");
                doWrite("");
                doWrite("//ATTACHMENT//");
                doWrite("");
                doWrite(mimeBreak);
                doWrite("Content-Type: text/plain; name=expense.rpt");
                doWrite("Content-Disposition: attachement; name=expense.rpt");
                doWrite("");
                
                doWrite(UploadMessage);
                
                doWrite("");
                doWrite(mimeBreak);
                doWrite("");
                
                status = writeAndReply(".");
            }
            
            if (status == false)
                AuditTrail.println("[500] SMTPSingle.UpLoadAttachment: doWrite() failed.");
        }catch (IOException e) {
            AuditTrail.println("[500] SMTPSingle.UpLoadAttachment failed to send message.");
        }
        return status;
    }

    private void doWrite (String msgText) throws IOException {
    // This is being used to facilitate debugging and QA - take out later    
         write(msgText);
         AuditTrail.println("[001] " + msgText);
    }     

    private boolean writeAndReply (String msgText) throws IOException {
    // This is being used to facilitate debugging and QA - take out later    
         write(msgText);
         AuditTrail.println("[001] " + msgText);
         return(checkReturn());         
    }     

    private boolean checkReturn()throws IOException {
        boolean status;
        String ReturnString = read();
        
        status = messageBackIsOK(ReturnString);
        if (status) {
            AuditTrail.println("[002] " + ReturnString);
        } else {
           AuditTrail.println("[500] SMTPSingle.checkReturn invalid response: " + ReturnString);
        }
        return status;
    }
    
    private String normalAddress(String DBAddress){
      String newAddress = "";
      int x = DBAddress.indexOf(","); 
      int y = DBAddress.indexOf("@");
      int z = DBAddress.indexOf(" ");
      if (DBAddress.equalsIgnoreCase("ZZHOLTON, JIM")) {
        newAddress = "jim@expenseservices.com";
      } else if (x > -1) { //check for a comma
        if (DBAddress.substring(0,2).equalsIgnoreCase("zz")) {  //special process for BofA
          DBAddress = DBAddress.substring(2).trim();
          x = x - 2;
        }
        newAddress = DBAddress.substring(x+1);
        while(newAddress.substring(0,1).equals(" ")) {
          newAddress = newAddress.substring(1);
        }
        newAddress = newAddress + nameDelimiter + DBAddress.substring(0,x).trim() + "@" +nameDomain; // change to "_" and  "fleetcapital.com"
      } else if (z > -1) {  //checking for a simple reverse
        newAddress = DBAddress.substring(z);
        while(newAddress.substring(0,1).equals(" ")) {
          newAddress = newAddress.substring(1);
        }
        newAddress = newAddress + nameDelimiter + DBAddress.substring(0,z).trim() + "@" +nameDomain; // change to "_" and  "fleetcapital.com"
      } else if (DBAddress.indexOf("zz") == 0) { //single name Notes BofA address
        DBAddress.substring(2).trim();
        newAddress = DBAddress.substring(2).trim() + "@" + nameDomain; 
      } else {  //normal condition
        newAddress = DBAddress;
      }
      return newAddress;
    }
    
}

