/*
SaveAndStatus.java - Used to post a report to the app server    
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;

import java.io.*;
//import java.util.*;
import java.sql.*;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;
import org.jdom.output.Format;

public class SaveAndStatus extends OutputTextFile {

    private ServerSystemTable SystemTable = new ServerSystemTable();
    private AuditTrail AuditLog = new AuditTrail();
    private java.util.Date date = new java.util.Date();
    private String Owner = "Adisoft";
    private String Status = "New";
    private String Last_Refer = "";
    private String DBUrl = "";
    private String DBUser = "";
    private String DBPassword = "";
    private String comment = "";
    private String repDate = date.toGMTString();
     
    public void setDB(String Url, String User, String Password) {
       DBUser = User;
       DBPassword = Password;
       setDB(Url);
    }
 
    public void setDB(String Url) {
       DBUrl = Url;
       SystemTable.setDB(Url, DBUser, DBPassword);
    }
    
    public void setConnection(Connection dbConn) {
       SystemTable.setConnection(dbConn);
    }
    
    public SaveAndStatus() {  //blank constructor
    }    
    
    public void setOwner(String setString) {
        Owner = setString;
    }
    
    public void setComment(String setString) {
        comment = setString;
    }
    
    public void setReportDate(String setString) {
        repDate = setString;
    }
    
    public void setStatus(String setString) {
        AuditTrail.println("[000] SaveAndStatus.setStatus set to " + setString);
        Status = setString;
    }    
    public String getStatus() {
      return Status;
    }
    
    public String getLastReference() {
      return Last_Refer;
    }  
    
    public void setDocument(Document Message) {
        
    }

    public void setXMLFile(String MessageText) {
      String Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");
      outputXML(MessageText, Reference,"xml", Reference, Status);
    }

    public void setXMLFile(String MessageText, String Reference) {
      if (Reference.equals("")) {
        setXMLFile(MessageText);
      } else {
        outputXML(MessageText, Reference,"xml", Reference, Status);
      }
    }

    public void setFile(String MessageText, String FileName, String Extension, String Reference) {
      outputXML(MessageText, FileName, Extension, Reference, Status);
    }
    

    public void setFile(String MessageText, String FileName) {
      String Reference = SystemTable.getSystemIncString("MESSAGE_SEQUENCE");  
      outputXML(MessageText, FileName, "out", Reference, Status);
    }
    
    public String getXML(String reg_dbase, String ownersName, String reference)
    {
       java.io.File report = new java.io.File(reg_dbase + reference + ".xml");
       SAXBuilder builder = new SAXBuilder();
       Document CommonDOM = new Document(new Element("empty"));
       try {
         CommonDOM = builder.build(report);
         AuditTrail.println("[000] SaveAndStatus.getXML loaded " + report.getName());
       } catch (org.jdom.JDOMException e) {
         AuditTrail.println("[400] SaveAndStatus.getXML XML DOM problem: " + report.getName());
       } catch (java.io.IOException e) {
         AuditTrail.println("[400] SaveAndStatus.getXML XML IO problem: " + report.getName());
       }
       XMLOutputter ShowXML = new XMLOutputter();
       Format formatObj = Format.getCompactFormat();
       //Format formatObj = Format.getRawFormat();
       ShowXML.setFormat(formatObj);
       //ShowXML.setNewlines(false);
       //ShowXML.setOmitDeclaration(true);
       //ShowXML.setLineSeparator("\r\n");
       
       return (String) ShowXML.outputString(CommonDOM);
    }
    
    private void outputXML(String MessageText, String FileName, String FileType, String Reference, String xStatus) {

       Status = xStatus;
       Last_Refer = "";
       String message = "Expense report saved";
       if (!comment.equals("")) message = comment;
       if (message.length() > 60) message = message.substring(0, 60);
       String SaveFileName = SystemTable.getSystemString("xml_folder","C:\\WORK\\")+ FileName + "." + FileType;
       String[] Tags = {"OWNER","XMLFILE","STATUS","MESSAGE","REVIEWER","XREF","REFERENCE","REPDATE","REPORTER","THEIR_REF","AMOUNT"};
       String[] Values = {SystemTable.str(AdisoftDbase.repStr(Owner.toUpperCase()),60),SystemTable.str(SaveFileName,60),SystemTable.str(Status,20),SystemTable.str(AdisoftDbase.repStr(message),60),"","",SystemTable.str(Reference,16), SystemTable.str(repDate,40),"","",""};
       Values[5] = setXref(FileName.toUpperCase());
       
       try {
            this.createFileHandle(SaveFileName, false);  //overwrite any existing file
            AuditTrail.println("[000] RPT file creation:" + SaveFileName);
            
            this.writeln("<register>");
            this.writeln("<reference>" + Reference + "</reference>");
            this.writeln("<status>" + Status + "</status>");
            this.writeln("<file>" + SaveFileName + "</file>");
            this.writeln(MessageText);
            this.writeln("</register>");
            this.close();
            
            AuditTrail.println("[200] SaveAndStatus.outputXML file saved:" + SaveFileName);
            SystemTable.setSimple("REGISTER","REFERENCE",Reference, Tags, Values);
            
            Last_Refer = Reference;
                
       } catch (IOException e) {
            AuditTrail.println("[500] SaveAndStatus.outputXML save failed for " + Reference);
            Status = "Failure";
       }
    }
    
    public String setXref(String X) {
       String xref = "00000000" + X.toUpperCase();
       String alternatePrefix = SystemTable.getSystemString("alternateprefix","A");
       xref = alternatePrefix + xref.substring(xref.length() - 7);
       return xref;
    }
    
    public void setRegister(String Ref){
       setRegister(Ref, repDate);
    }
    
    public void setRegisterWithThrRef(String Ref, String ThrRef) {
       String[] Tags = {"STATUS","REPDATE","THEIR_REF"};
       String[] Values = {Status,repDate,ThrRef};
       AuditTrail.println("[250] SaveAndStatus.setRegister:" + Ref + " Status:" + Status + " Voucher:" + ThrRef + " Date:" + repDate);
       SystemTable.setSimple("REGISTER","REFERENCE",Ref, Tags, Values);
    }
    
    
    public void setRegister(String Ref, String reportDate){
       String[] Tags = {"STATUS","REPDATE"};
       String[] Values = {Status,reportDate};
       AuditTrail.println("[251] SaveAndStatus.setRegister:" + Ref + " " + reportDate);
       SystemTable.setSimple("REGISTER","REFERENCE",Ref, Tags, Values);
    }
}
