/*
SavePersData.java - Readies personnel data for the app server  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/


package ess;

import java.sql.*;
import java.io.*;
//import java.util.*;

public class SavePersData extends OutputTextFile {

    private ServerSystemTable SystemTable = new ServerSystemTable();
    private AuditTrail AuditLog = new AuditTrail();
    private String DBUrl = "";
    private String DBUser = "";
    private String DBPassword = "";
    private String Status = "Saved";
 
 
    public void setDB(String Url, String User, String Password) {
      DBUser = User;
      DBPassword = Password;
      setDB(Url);
    }
  
    public void setDB(String Url) {
       DBUrl = Url;
       SystemTable.setDB(Url, DBUser, DBPassword);
    }
    
    public void setConnection(Connection db) {
       SystemTable.setConnection(db);
    }
    
    public void setSQLTerminator(String X) {
        SystemTable.setSQLTerminator(X);
    }
        
    public SavePersData() {  //blank constructor
    }    
    
    public void setStatus(String setString) {
        AuditTrail.println("[000] SavePersData.setStatus set to " + setString);
        Status = setString;
    }    
    public String getStatus() {
      return Status;
    }
    
    public void setFile(String MessageText, String FileName) {
      outputXML(MessageText, FileName);
    }
    
    private void outputXML(String MessageText, String FileName) {

       String SaveFileName = SystemTable.getSystemString("PERSONAL_FOLDER","C:\\WORK\\")+ FileName;
       
       try {
            //AuditLog.println("[000] SavePersData.outputXML file creation:" + MessageText);
            this.createFileHandle(SaveFileName, false);  //overwrite any existing file
            this.writeln(MessageText);
            this.close();
            AuditTrail.println("[200] SavePersData.outputXML:" + SaveFileName);
       } catch (IOException e) {
            AuditTrail.println("[500] SavePersData.outputXML IO failure for " + SaveFileName);
            AuditTrail.println("[500] SavePersData.outputXML content:" + MessageText);
            Status = "Error";
       } catch (NullPointerException e) {
            AuditTrail.println("[500] SavePersData.outputXML NullPointer failure for " + SaveFileName);
            AuditTrail.println("[500] SavePersData.outputXML content:" + MessageText);
            Status = "Error";        
       }
    }
    
}
