/*
SortVector.java - sorts any vector  
Copyright (C) 2004 R. James Holton

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version.  This program is distributed in the hope that it will be 
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details.

You should have received a copy of the GNU General Public License along with 
this program; if not, write to the Free Software Foundation, Inc., 
675 Mass Ave, Cambridge, MA 02139, USA. 
*/

package ess;
import java.util.*;

public class SortVector extends Vector{
    private Compare compare;
    public SortVector (Compare comp){
        
        compare = comp;
    }
    public void reLoad(Compare comp){
        compare = comp;
    }    
    public void sort(){
        quickSort(0, size() -1);
    }
    private void quickSort(int left, int right) {
        if(right > left) {
            Object o1 = elementAt(right);
            int i = left - 1;
            int j = right;
            while (true) {
                while (compare.lessThan(elementAt(++i), o1))
                    ;  //skipping those that are less than
                while (j > 0)
                    if (compare.lessThanOrEqual(
                                        elementAt(--j), o1))
                        break; // out of while loop
                
                if (i>=j) break;
                swap(i, j);
            }
            swap(i, right);
            quickSort(left, i-1);
            quickSort(i+1, right);
        }
    }
    
    private void swap(int loc1, int loc2)
    {
        Object temp = elementAt(loc1);
        setElementAt(elementAt(loc2), loc1);
        setElementAt(temp, loc2);
    }
}
               
    